function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
!function (t, r) {
  "object" == (typeof exports === "undefined" ? "undefined" : _typeof(exports)) && "undefined" != typeof module ? module.exports = r(require("angular"), require("Vue")) : "function" == typeof define && define.amd ? define(["angular", "Vue"], r) : (t = "undefined" != typeof globalThis ? globalThis : t || self).AngularVueModule = r(t.angular, t.Vue);
}(this, function (t, r) {
  "use strict";

  function e(t) {
    return t && "object" == _typeof(t) && "default" in t ? t : {
      default: t
    };
  }
  var n = e(t),
    o = e(r),
    u = {
      parent: a,
      parents: function parents(t) {
        var r = [];
        var e = a(t);
        for (; e;) {
          r.push(e), e = a(e);
        }
        return r;
      },
      leaf: function leaf(t) {
        return i(t).pop();
      },
      root: function root(t) {
        return i(t)[0];
      },
      isRoot: function isRoot(t) {
        return 1 === i(t).length;
      }
    };
  function a(t) {
    var r = i(t);
    return r.pop(), function (t) {
      return t.join(".");
    }(r);
  }
  function i(t) {
    if (!t) throw new Error("Invalid path ".concat(t));
    return t.split(".");
  }
  var c = "undefined" != typeof globalThis ? globalThis : "undefined" != typeof window ? window : "undefined" != typeof global ? global : "undefined" != typeof self ? self : {};
  var f = function f(t, r) {
    for (var e = -1, n = null == t ? 0 : t.length, o = Array(n); ++e < n;) {
      o[e] = r(t[e], e, t);
    }
    return o;
  };
  var l = function l() {
    this.__data__ = [], this.size = 0;
  };
  var v = function v(t, r) {
      return t === r || t != t && r != r;
    },
    s = v;
  var p = function p(t, r) {
      for (var e = t.length; e--;) {
        if (s(t[e][0], r)) return e;
      }
      return -1;
    },
    d = p,
    b = Array.prototype.splice;
  var h = p;
  var y = p;
  var g = p;
  var j = l,
    _ = function _(t) {
      var r = this.__data__,
        e = d(r, t);
      return !(e < 0) && (e == r.length - 1 ? r.pop() : b.call(r, e, 1), --this.size, !0);
    },
    w = function w(t) {
      var r = this.__data__,
        e = h(r, t);
      return e < 0 ? void 0 : r[e][1];
    },
    x = function x(t) {
      return y(this.__data__, t) > -1;
    },
    O = function O(t, r) {
      var e = this.__data__,
        n = g(e, t);
      return n < 0 ? (++this.size, e.push([t, r])) : e[n][1] = r, this;
    };
  function $(t) {
    var r = -1,
      e = null == t ? 0 : t.length;
    for (this.clear(); ++r < e;) {
      var n = t[r];
      this.set(n[0], n[1]);
    }
  }
  $.prototype.clear = j, $.prototype.delete = _, $.prototype.get = w, $.prototype.has = x, $.prototype.set = O;
  var A = $,
    m = A;
  var z = function z() {
    this.__data__ = new m(), this.size = 0;
  };
  var E = function E(t) {
    var r = this.__data__,
      e = r.delete(t);
    return this.size = r.size, e;
  };
  var S = function S(t) {
    return this.__data__.get(t);
  };
  var U = function U(t) {
      return this.__data__.has(t);
    },
    I = "object" == _typeof(c) && c && c.Object === Object && c,
    C = I,
    P = "object" == (typeof self === "undefined" ? "undefined" : _typeof(self)) && self && self.Object === Object && self,
    T = C || P || Function("return this")(),
    R = T.Symbol,
    L = R,
    V = Object.prototype,
    k = V.hasOwnProperty,
    D = V.toString,
    F = L ? L.toStringTag : void 0;
  var M = function M(t) {
      var r = k.call(t, F),
        e = t[F];
      try {
        t[F] = void 0;
        var n = !0;
      } catch (t) {}
      var o = D.call(t);
      return n && (r ? t[F] = e : delete t[F]), o;
    },
    B = Object.prototype.toString;
  var N = M,
    Z = function Z(t) {
      return B.call(t);
    },
    G = R ? R.toStringTag : void 0;
  var W = function W(t) {
    return null == t ? void 0 === t ? "[object Undefined]" : "[object Null]" : G && G in Object(t) ? N(t) : Z(t);
  };
  var q = function q(t) {
      var r = _typeof(t);
      return null != t && ("object" == r || "function" == r);
    },
    H = W,
    Y = q;
  var J,
    K = function K(t) {
      if (!Y(t)) return !1;
      var r = H(t);
      return "[object Function]" == r || "[object GeneratorFunction]" == r || "[object AsyncFunction]" == r || "[object Proxy]" == r;
    },
    Q = T["__core-js_shared__"],
    X = (J = /[^.]+$/.exec(Q && Q.keys && Q.keys.IE_PROTO || "")) ? "Symbol(src)_1." + J : "";
  var tt = function tt(t) {
      return !!X && X in t;
    },
    rt = Function.prototype.toString;
  var et = function et(t) {
      if (null != t) {
        try {
          return rt.call(t);
        } catch (t) {}
        try {
          return t + "";
        } catch (t) {}
      }
      return "";
    },
    nt = K,
    ot = tt,
    ut = q,
    at = et,
    it = /^\[object .+?Constructor\]$/,
    ct = Function.prototype,
    ft = Object.prototype,
    lt = ct.toString,
    vt = ft.hasOwnProperty,
    st = RegExp("^" + lt.call(vt).replace(/[\\^$.*+?()[\]{}|]/g, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$");
  var pt = function pt(t) {
      return !(!ut(t) || ot(t)) && (nt(t) ? st : it).test(at(t));
    },
    dt = function dt(t, r) {
      return null == t ? void 0 : t[r];
    };
  var bt = function bt(t, r) {
      var e = dt(t, r);
      return pt(e) ? e : void 0;
    },
    ht = bt(T, "Map"),
    yt = bt(Object, "create"),
    gt = yt;
  var jt = function jt() {
    this.__data__ = gt ? gt(null) : {}, this.size = 0;
  };
  var _t = function _t(t) {
      var r = this.has(t) && delete this.__data__[t];
      return this.size -= r ? 1 : 0, r;
    },
    wt = yt,
    xt = Object.prototype.hasOwnProperty;
  var Ot = function Ot(t) {
      var r = this.__data__;
      if (wt) {
        var e = r[t];
        return "__lodash_hash_undefined__" === e ? void 0 : e;
      }
      return xt.call(r, t) ? r[t] : void 0;
    },
    $t = yt,
    At = Object.prototype.hasOwnProperty;
  var mt = yt;
  var zt = jt,
    Et = _t,
    St = Ot,
    Ut = function Ut(t) {
      var r = this.__data__;
      return $t ? void 0 !== r[t] : At.call(r, t);
    },
    It = function It(t, r) {
      var e = this.__data__;
      return this.size += this.has(t) ? 0 : 1, e[t] = mt && void 0 === r ? "__lodash_hash_undefined__" : r, this;
    };
  function Ct(t) {
    var r = -1,
      e = null == t ? 0 : t.length;
    for (this.clear(); ++r < e;) {
      var n = t[r];
      this.set(n[0], n[1]);
    }
  }
  Ct.prototype.clear = zt, Ct.prototype.delete = Et, Ct.prototype.get = St, Ct.prototype.has = Ut, Ct.prototype.set = It;
  var Pt = Ct,
    Tt = A,
    Rt = ht;
  var Lt = function Lt(t) {
    var r = _typeof(t);
    return "string" == r || "number" == r || "symbol" == r || "boolean" == r ? "__proto__" !== t : null === t;
  };
  var Vt = function Vt(t, r) {
      var e = t.__data__;
      return Lt(r) ? e["string" == typeof r ? "string" : "hash"] : e.map;
    },
    kt = Vt;
  var Dt = Vt;
  var Ft = Vt;
  var Mt = Vt;
  var Bt = function Bt() {
      this.size = 0, this.__data__ = {
        hash: new Pt(),
        map: new (Rt || Tt)(),
        string: new Pt()
      };
    },
    Nt = function Nt(t) {
      var r = kt(this, t).delete(t);
      return this.size -= r ? 1 : 0, r;
    },
    Zt = function Zt(t) {
      return Dt(this, t).get(t);
    },
    Gt = function Gt(t) {
      return Ft(this, t).has(t);
    },
    Wt = function Wt(t, r) {
      var e = Mt(this, t),
        n = e.size;
      return e.set(t, r), this.size += e.size == n ? 0 : 1, this;
    };
  function qt(t) {
    var r = -1,
      e = null == t ? 0 : t.length;
    for (this.clear(); ++r < e;) {
      var n = t[r];
      this.set(n[0], n[1]);
    }
  }
  qt.prototype.clear = Bt, qt.prototype.delete = Nt, qt.prototype.get = Zt, qt.prototype.has = Gt, qt.prototype.set = Wt;
  var Ht = qt,
    Yt = A,
    Jt = ht,
    Kt = Ht;
  var Qt = A,
    Xt = z,
    tr = E,
    rr = S,
    er = U,
    nr = function nr(t, r) {
      var e = this.__data__;
      if (e instanceof Yt) {
        var n = e.__data__;
        if (!Jt || n.length < 199) return n.push([t, r]), this.size = ++e.size, this;
        e = this.__data__ = new Kt(n);
      }
      return e.set(t, r), this.size = e.size, this;
    };
  function or(t) {
    var r = this.__data__ = new Qt(t);
    this.size = r.size;
  }
  or.prototype.clear = Xt, or.prototype.delete = tr, or.prototype.get = rr, or.prototype.has = er, or.prototype.set = nr;
  var ur = or;
  var ar = function ar(t, r) {
      for (var e = -1, n = null == t ? 0 : t.length; ++e < n && !1 !== r(t[e], e, t);) {
        ;
      }
      return t;
    },
    ir = bt,
    cr = function () {
      try {
        var t = ir(Object, "defineProperty");
        return t({}, "", {}), t;
      } catch (t) {}
    }(),
    fr = cr;
  var lr = function lr(t, r, e) {
      "__proto__" == r && fr ? fr(t, r, {
        configurable: !0,
        enumerable: !0,
        value: e,
        writable: !0
      }) : t[r] = e;
    },
    vr = lr,
    sr = v,
    pr = Object.prototype.hasOwnProperty;
  var dr = function dr(t, r, e) {
      var n = t[r];
      pr.call(t, r) && sr(n, e) && (void 0 !== e || r in t) || vr(t, r, e);
    },
    br = dr,
    hr = lr;
  var yr = function yr(t, r, e, n) {
    var o = !e;
    e || (e = {});
    for (var u = -1, a = r.length; ++u < a;) {
      var i = r[u],
        c = n ? n(e[i], t[i], i, e, t) : void 0;
      void 0 === c && (c = t[i]), o ? hr(e, i, c) : br(e, i, c);
    }
    return e;
  };
  var gr = function gr(t, r) {
    for (var e = -1, n = Array(t); ++e < t;) {
      n[e] = r(e);
    }
    return n;
  };
  var jr = function jr(t) {
      return null != t && "object" == _typeof(t);
    },
    _r = W,
    wr = jr;
  var xr = function xr(t) {
      return wr(t) && "[object Arguments]" == _r(t);
    },
    Or = jr,
    $r = Object.prototype,
    Ar = $r.hasOwnProperty,
    mr = $r.propertyIsEnumerable,
    zr = xr(function () {
      return arguments;
    }()) ? xr : function (t) {
      return Or(t) && Ar.call(t, "callee") && !mr.call(t, "callee");
    },
    Er = zr,
    Sr = Array.isArray,
    Ur = {
      exports: {}
    };
  var Ir = function Ir() {
    return !1;
  };
  !function (t, r) {
    var e = T,
      n = Ir,
      o = r && !r.nodeType && r,
      u = o && t && !t.nodeType && t,
      a = u && u.exports === o ? e.Buffer : void 0,
      i = (a ? a.isBuffer : void 0) || n;
    t.exports = i;
  }(Ur, Ur.exports);
  var Cr = /^(?:0|[1-9]\d*)$/;
  var Pr = function Pr(t, r) {
    var e = _typeof(t);
    return !!(r = null == r ? 9007199254740991 : r) && ("number" == e || "symbol" != e && Cr.test(t)) && t > -1 && t % 1 == 0 && t < r;
  };
  var Tr = function Tr(t) {
      return "number" == typeof t && t > -1 && t % 1 == 0 && t <= 9007199254740991;
    },
    Rr = W,
    Lr = Tr,
    Vr = jr,
    kr = {};
  kr["[object Float32Array]"] = kr["[object Float64Array]"] = kr["[object Int8Array]"] = kr["[object Int16Array]"] = kr["[object Int32Array]"] = kr["[object Uint8Array]"] = kr["[object Uint8ClampedArray]"] = kr["[object Uint16Array]"] = kr["[object Uint32Array]"] = !0, kr["[object Arguments]"] = kr["[object Array]"] = kr["[object ArrayBuffer]"] = kr["[object Boolean]"] = kr["[object DataView]"] = kr["[object Date]"] = kr["[object Error]"] = kr["[object Function]"] = kr["[object Map]"] = kr["[object Number]"] = kr["[object Object]"] = kr["[object RegExp]"] = kr["[object Set]"] = kr["[object String]"] = kr["[object WeakMap]"] = !1;
  var Dr = function Dr(t) {
    return Vr(t) && Lr(t.length) && !!kr[Rr(t)];
  };
  var Fr = function Fr(t) {
      return function (r) {
        return t(r);
      };
    },
    Mr = {
      exports: {}
    };
  !function (t, r) {
    var e = I,
      n = r && !r.nodeType && r,
      o = n && t && !t.nodeType && t,
      u = o && o.exports === n && e.process,
      a = function () {
        try {
          var t = o && o.require && o.require("util").types;
          return t || u && u.binding && u.binding("util");
        } catch (t) {}
      }();
    t.exports = a;
  }(Mr, Mr.exports);
  var Br = Dr,
    Nr = Fr,
    Zr = Mr.exports,
    Gr = Zr && Zr.isTypedArray,
    Wr = Gr ? Nr(Gr) : Br,
    qr = gr,
    Hr = Er,
    Yr = Sr,
    Jr = Ur.exports,
    Kr = Pr,
    Qr = Wr,
    Xr = Object.prototype.hasOwnProperty;
  var te = function te(t, r) {
      var e = Yr(t),
        n = !e && Hr(t),
        o = !e && !n && Jr(t),
        u = !e && !n && !o && Qr(t),
        a = e || n || o || u,
        i = a ? qr(t.length, String) : [],
        c = i.length;
      for (var f in t) {
        !r && !Xr.call(t, f) || a && ("length" == f || o && ("offset" == f || "parent" == f) || u && ("buffer" == f || "byteLength" == f || "byteOffset" == f) || Kr(f, c)) || i.push(f);
      }
      return i;
    },
    re = Object.prototype;
  var ee = function ee(t) {
    var r = t && t.constructor;
    return t === ("function" == typeof r && r.prototype || re);
  };
  var ne = function ne(t, r) {
      return function (e) {
        return t(r(e));
      };
    },
    oe = ne(Object.keys, Object),
    ue = ee,
    ae = oe,
    ie = Object.prototype.hasOwnProperty;
  var ce = K,
    fe = Tr;
  var le = function le(t) {
      return null != t && fe(t.length) && !ce(t);
    },
    ve = te,
    se = function se(t) {
      if (!ue(t)) return ae(t);
      var r = [];
      for (var e in Object(t)) {
        ie.call(t, e) && "constructor" != e && r.push(e);
      }
      return r;
    },
    pe = le;
  var de = function de(t) {
      return pe(t) ? ve(t) : se(t);
    },
    be = yr,
    he = de;
  var ye = function ye(t, r) {
    return t && be(r, he(r), t);
  };
  var ge = q,
    je = ee,
    _e = function _e(t) {
      var r = [];
      if (null != t) for (var e in Object(t)) {
        r.push(e);
      }
      return r;
    },
    we = Object.prototype.hasOwnProperty;
  var xe = te,
    Oe = function Oe(t) {
      if (!ge(t)) return _e(t);
      var r = je(t),
        e = [];
      for (var n in t) {
        ("constructor" != n || !r && we.call(t, n)) && e.push(n);
      }
      return e;
    },
    $e = le;
  var Ae = function Ae(t) {
      return $e(t) ? xe(t, !0) : Oe(t);
    },
    me = yr,
    ze = Ae;
  var Ee = function Ee(t, r) {
      return t && me(r, ze(r), t);
    },
    Se = {
      exports: {}
    };
  !function (t, r) {
    var e = T,
      n = r && !r.nodeType && r,
      o = n && t && !t.nodeType && t,
      u = o && o.exports === n ? e.Buffer : void 0,
      a = u ? u.allocUnsafe : void 0;
    t.exports = function (t, r) {
      if (r) return t.slice();
      var e = t.length,
        n = a ? a(e) : new t.constructor(e);
      return t.copy(n), n;
    };
  }(Se, Se.exports);
  var Ue = function Ue(t, r) {
    var e = -1,
      n = t.length;
    for (r || (r = Array(n)); ++e < n;) {
      r[e] = t[e];
    }
    return r;
  };
  var Ie = function Ie() {
      return [];
    },
    Ce = function Ce(t, r) {
      for (var e = -1, n = null == t ? 0 : t.length, o = 0, u = []; ++e < n;) {
        var a = t[e];
        r(a, e, t) && (u[o++] = a);
      }
      return u;
    },
    Pe = Ie,
    Te = Object.prototype.propertyIsEnumerable,
    Re = Object.getOwnPropertySymbols,
    Le = Re ? function (t) {
      return null == t ? [] : (t = Object(t), Ce(Re(t), function (r) {
        return Te.call(t, r);
      }));
    } : Pe,
    Ve = yr,
    ke = Le;
  var De = function De(t, r) {
    return Ve(t, ke(t), r);
  };
  var Fe = function Fe(t, r) {
      for (var e = -1, n = r.length, o = t.length; ++e < n;) {
        t[o + e] = r[e];
      }
      return t;
    },
    Me = ne(Object.getPrototypeOf, Object),
    Be = Fe,
    Ne = Me,
    Ze = Le,
    Ge = Ie,
    We = Object.getOwnPropertySymbols ? function (t) {
      for (var r = []; t;) {
        Be(r, Ze(t)), t = Ne(t);
      }
      return r;
    } : Ge,
    qe = yr,
    He = We;
  var Ye = function Ye(t, r) {
      return qe(t, He(t), r);
    },
    Je = Fe,
    Ke = Sr;
  var Qe = function Qe(t, r, e) {
      var n = r(t);
      return Ke(t) ? n : Je(n, e(t));
    },
    Xe = Qe,
    tn = Le,
    rn = de;
  var en = function en(t) {
      return Xe(t, rn, tn);
    },
    nn = Qe,
    on = We,
    un = Ae;
  var an = function an(t) {
      return nn(t, un, on);
    },
    cn = bt(T, "DataView"),
    fn = bt(T, "Promise"),
    ln = bt(T, "Set"),
    vn = cn,
    sn = ht,
    pn = fn,
    dn = ln,
    bn = bt(T, "WeakMap"),
    hn = W,
    yn = et,
    gn = "[object Map]",
    jn = "[object Promise]",
    _n = "[object Set]",
    wn = "[object WeakMap]",
    xn = "[object DataView]",
    On = yn(vn),
    $n = yn(sn),
    An = yn(pn),
    mn = yn(dn),
    zn = yn(bn),
    En = hn;
  (vn && En(new vn(new ArrayBuffer(1))) != xn || sn && En(new sn()) != gn || pn && En(pn.resolve()) != jn || dn && En(new dn()) != _n || bn && En(new bn()) != wn) && (En = function En(t) {
    var r = hn(t),
      e = "[object Object]" == r ? t.constructor : void 0,
      n = e ? yn(e) : "";
    if (n) switch (n) {
      case On:
        return xn;
      case $n:
        return gn;
      case An:
        return jn;
      case mn:
        return _n;
      case zn:
        return wn;
    }
    return r;
  });
  var Sn = En,
    Un = Object.prototype.hasOwnProperty;
  var In = function In(t) {
      var r = t.length,
        e = new t.constructor(r);
      return r && "string" == typeof t[0] && Un.call(t, "index") && (e.index = t.index, e.input = t.input), e;
    },
    Cn = T.Uint8Array,
    Pn = Cn;
  var Tn = function Tn(t) {
      var r = new t.constructor(t.byteLength);
      return new Pn(r).set(new Pn(t)), r;
    },
    Rn = Tn;
  var Ln = function Ln(t, r) {
      var e = r ? Rn(t.buffer) : t.buffer;
      return new t.constructor(e, t.byteOffset, t.byteLength);
    },
    Vn = /\w*$/;
  var kn = function kn(t) {
      var r = new t.constructor(t.source, Vn.exec(t));
      return r.lastIndex = t.lastIndex, r;
    },
    Dn = R ? R.prototype : void 0,
    Fn = Dn ? Dn.valueOf : void 0;
  var Mn = Tn;
  var Bn = Tn,
    Nn = Ln,
    Zn = kn,
    Gn = function Gn(t) {
      return Fn ? Object(Fn.call(t)) : {};
    },
    Wn = function Wn(t, r) {
      var e = r ? Mn(t.buffer) : t.buffer;
      return new t.constructor(e, t.byteOffset, t.length);
    };
  var qn = function qn(t, r, e) {
      var n = t.constructor;
      switch (r) {
        case "[object ArrayBuffer]":
          return Bn(t);
        case "[object Boolean]":
        case "[object Date]":
          return new n(+t);
        case "[object DataView]":
          return Nn(t, e);
        case "[object Float32Array]":
        case "[object Float64Array]":
        case "[object Int8Array]":
        case "[object Int16Array]":
        case "[object Int32Array]":
        case "[object Uint8Array]":
        case "[object Uint8ClampedArray]":
        case "[object Uint16Array]":
        case "[object Uint32Array]":
          return Wn(t, e);
        case "[object Map]":
        case "[object Set]":
          return new n();
        case "[object Number]":
        case "[object String]":
          return new n(t);
        case "[object RegExp]":
          return Zn(t);
        case "[object Symbol]":
          return Gn(t);
      }
    },
    Hn = q,
    Yn = Object.create,
    Jn = function () {
      function t() {}
      return function (r) {
        if (!Hn(r)) return {};
        if (Yn) return Yn(r);
        t.prototype = r;
        var e = new t();
        return t.prototype = void 0, e;
      };
    }(),
    Kn = Me,
    Qn = ee;
  var Xn = function Xn(t) {
      return "function" != typeof t.constructor || Qn(t) ? {} : Jn(Kn(t));
    },
    to = Sn,
    ro = jr;
  var eo = function eo(t) {
      return ro(t) && "[object Map]" == to(t);
    },
    no = Fr,
    oo = Mr.exports,
    uo = oo && oo.isMap,
    ao = uo ? no(uo) : eo,
    io = Sn,
    co = jr;
  var fo = function fo(t) {
      return co(t) && "[object Set]" == io(t);
    },
    lo = Fr,
    vo = Mr.exports,
    so = vo && vo.isSet,
    po = so ? lo(so) : fo,
    bo = ur,
    ho = ar,
    yo = dr,
    go = ye,
    jo = Ee,
    _o = Se.exports,
    wo = Ue,
    xo = De,
    Oo = Ye,
    $o = en,
    Ao = an,
    mo = Sn,
    zo = In,
    Eo = qn,
    So = Xn,
    Uo = Sr,
    Io = Ur.exports,
    Co = ao,
    Po = q,
    To = po,
    Ro = de,
    Lo = Ae,
    Vo = "[object Arguments]",
    ko = "[object Function]",
    Do = "[object Object]",
    Fo = {};
  Fo[Vo] = Fo["[object Array]"] = Fo["[object ArrayBuffer]"] = Fo["[object DataView]"] = Fo["[object Boolean]"] = Fo["[object Date]"] = Fo["[object Float32Array]"] = Fo["[object Float64Array]"] = Fo["[object Int8Array]"] = Fo["[object Int16Array]"] = Fo["[object Int32Array]"] = Fo["[object Map]"] = Fo["[object Number]"] = Fo[Do] = Fo["[object RegExp]"] = Fo["[object Set]"] = Fo["[object String]"] = Fo["[object Symbol]"] = Fo["[object Uint8Array]"] = Fo["[object Uint8ClampedArray]"] = Fo["[object Uint16Array]"] = Fo["[object Uint32Array]"] = !0, Fo["[object Error]"] = Fo[ko] = Fo["[object WeakMap]"] = !1;
  var Mo = function t(r, e, n, o, u, a) {
      var i,
        c = 1 & e,
        f = 2 & e,
        l = 4 & e;
      if (n && (i = u ? n(r, o, u, a) : n(r)), void 0 !== i) return i;
      if (!Po(r)) return r;
      var v = Uo(r);
      if (v) {
        if (i = zo(r), !c) return wo(r, i);
      } else {
        var s = mo(r),
          p = s == ko || "[object GeneratorFunction]" == s;
        if (Io(r)) return _o(r, c);
        if (s == Do || s == Vo || p && !u) {
          if (i = f || p ? {} : So(r), !c) return f ? Oo(r, jo(i, r)) : xo(r, go(i, r));
        } else {
          if (!Fo[s]) return u ? r : {};
          i = Eo(r, s, c);
        }
      }
      a || (a = new bo());
      var d = a.get(r);
      if (d) return d;
      a.set(r, i), To(r) ? r.forEach(function (o) {
        i.add(t(o, e, n, o, r, a));
      }) : Co(r) && r.forEach(function (o, u) {
        i.set(u, t(o, e, n, u, r, a));
      });
      var b = v ? void 0 : (l ? f ? Ao : $o : f ? Lo : Ro)(r);
      return ho(b || r, function (o, u) {
        b && (o = r[u = o]), yo(i, u, t(o, e, n, u, r, a));
      }), i;
    },
    Bo = W,
    No = jr;
  var Zo = function Zo(t) {
      return "symbol" == _typeof(t) || No(t) && "[object Symbol]" == Bo(t);
    },
    Go = Sr,
    Wo = Zo,
    qo = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,
    Ho = /^\w*$/;
  var Yo = function Yo(t, r) {
      if (Go(t)) return !1;
      var e = _typeof(t);
      return !("number" != e && "symbol" != e && "boolean" != e && null != t && !Wo(t)) || Ho.test(t) || !qo.test(t) || null != r && t in Object(r);
    },
    Jo = Ht;
  function Ko(t, r) {
    if ("function" != typeof t || null != r && "function" != typeof r) throw new TypeError("Expected a function");
    var e = function e() {
      var n = arguments,
        o = r ? r.apply(this, n) : n[0],
        u = e.cache;
      if (u.has(o)) return u.get(o);
      var a = t.apply(this, n);
      return e.cache = u.set(o, a) || u, a;
    };
    return e.cache = new (Ko.Cache || Jo)(), e;
  }
  Ko.Cache = Jo;
  var Qo = Ko;
  var Xo = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g,
    tu = /\\(\\)?/g,
    ru = function (t) {
      var r = Qo(t, function (t) {
          return 500 === e.size && e.clear(), t;
        }),
        e = r.cache;
      return r;
    }(function (t) {
      var r = [];
      return 46 === t.charCodeAt(0) && r.push(""), t.replace(Xo, function (t, e, n, o) {
        r.push(n ? o.replace(tu, "$1") : e || t);
      }), r;
    }),
    eu = f,
    nu = Sr,
    ou = Zo,
    uu = R ? R.prototype : void 0,
    au = uu ? uu.toString : void 0;
  var iu = function t(r) {
      if ("string" == typeof r) return r;
      if (nu(r)) return eu(r, t) + "";
      if (ou(r)) return au ? au.call(r) : "";
      var e = r + "";
      return "0" == e && 1 / r == -Infinity ? "-0" : e;
    },
    cu = iu;
  var fu = function fu(t) {
      return null == t ? "" : cu(t);
    },
    lu = Sr,
    vu = Yo,
    su = ru,
    pu = fu;
  var du = function du(t, r) {
    return lu(t) ? t : vu(t, r) ? [t] : su(pu(t));
  };
  var bu = Zo;
  var hu = function hu(t) {
      if ("string" == typeof t || bu(t)) return t;
      var r = t + "";
      return "0" == r && 1 / t == -Infinity ? "-0" : r;
    },
    yu = du,
    gu = hu;
  var ju = function ju(t, r) {
    for (var e = 0, n = (r = yu(r, t)).length; null != t && e < n;) {
      t = t[gu(r[e++])];
    }
    return e && e == n ? t : void 0;
  };
  var _u = function _u(t, r, e) {
      var n = -1,
        o = t.length;
      r < 0 && (r = -r > o ? 0 : o + r), (e = e > o ? o : e) < 0 && (e += o), o = r > e ? 0 : e - r >>> 0, r >>>= 0;
      for (var u = Array(o); ++n < o;) {
        u[n] = t[n + r];
      }
      return u;
    },
    wu = ju,
    xu = _u;
  var Ou = du,
    $u = function $u(t) {
      var r = null == t ? 0 : t.length;
      return r ? t[r - 1] : void 0;
    },
    Au = function Au(t, r) {
      return r.length < 2 ? t : wu(t, xu(r, 0, -1));
    },
    mu = hu;
  var zu = function zu(t, r) {
      return r = Ou(r, t), null == (t = Au(t, r)) || delete t[mu($u(r))];
    },
    Eu = W,
    Su = Me,
    Uu = jr,
    Iu = Function.prototype,
    Cu = Object.prototype,
    Pu = Iu.toString,
    Tu = Cu.hasOwnProperty,
    Ru = Pu.call(Object);
  var Lu = function Lu(t) {
    if (!Uu(t) || "[object Object]" != Eu(t)) return !1;
    var r = Su(t);
    if (null === r) return !0;
    var e = Tu.call(r, "constructor") && r.constructor;
    return "function" == typeof e && e instanceof e && Pu.call(e) == Ru;
  };
  var Vu = function Vu(t) {
      return Lu(t) ? void 0 : t;
    },
    ku = Er,
    Du = Sr,
    Fu = R ? R.isConcatSpreadable : void 0;
  var Mu = Fe,
    Bu = function Bu(t) {
      return Du(t) || ku(t) || !!(Fu && t && t[Fu]);
    };
  var Nu = function t(r, e, n, o, u) {
      var a = -1,
        i = r.length;
      for (n || (n = Bu), u || (u = []); ++a < i;) {
        var c = r[a];
        e > 0 && n(c) ? e > 1 ? t(c, e - 1, n, o, u) : Mu(u, c) : o || (u[u.length] = c);
      }
      return u;
    },
    Zu = Nu;
  var Gu = function Gu(t) {
    return (null == t ? 0 : t.length) ? Zu(t, 1) : [];
  };
  var Wu = function Wu(t, r, e) {
      switch (e.length) {
        case 0:
          return t.call(r);
        case 1:
          return t.call(r, e[0]);
        case 2:
          return t.call(r, e[0], e[1]);
        case 3:
          return t.call(r, e[0], e[1], e[2]);
      }
      return t.apply(r, e);
    },
    qu = Math.max;
  var Hu = function Hu(t, r, e) {
    return r = qu(void 0 === r ? t.length - 1 : r, 0), function () {
      for (var n = arguments, o = -1, u = qu(n.length - r, 0), a = Array(u); ++o < u;) {
        a[o] = n[r + o];
      }
      o = -1;
      for (var i = Array(r + 1); ++o < r;) {
        i[o] = n[o];
      }
      return i[r] = e(a), Wu(t, this, i);
    };
  };
  var Yu = function Yu(t) {
      return t;
    },
    Ju = function Ju(t) {
      return function () {
        return t;
      };
    },
    Ku = cr,
    Qu = Ku ? function (t, r) {
      return Ku(t, "toString", {
        configurable: !0,
        enumerable: !1,
        value: Ju(r),
        writable: !0
      });
    } : Yu,
    Xu = Date.now;
  var ta = function ta(t) {
      var r = 0,
        e = 0;
      return function () {
        var n = Xu(),
          o = 16 - (n - e);
        if (e = n, o > 0) {
          if (++r >= 800) return arguments[0];
        } else r = 0;
        return t.apply(void 0, arguments);
      };
    },
    ra = ta(Qu),
    ea = Gu,
    na = Hu,
    oa = ra;
  var ua = f,
    aa = Mo,
    ia = zu,
    ca = du,
    fa = yr,
    la = Vu,
    va = an,
    sa = function (t) {
      return oa(na(t, void 0, ea), t + "");
    }(function (t, r) {
      var e = {};
      if (null == t) return e;
      var n = !1;
      r = ua(r, function (r) {
        return r = ca(r, t), n || (n = r.length > 1), r;
      }), fa(t, va(t), e), n && (e = aa(e, 7, la));
      for (var o = r.length; o--;) {
        ia(e, r[o]);
      }
      return e;
    }),
    pa = sa,
    da = ju;
  var ba = function ba(t, r, e) {
    var n = null == t ? void 0 : da(t, r);
    return void 0 === n ? e : n;
  };
  var ha = function (t) {
      return function (r, e, n) {
        for (var o = -1, u = Object(r), a = n(r), i = a.length; i--;) {
          var c = a[t ? i : ++o];
          if (!1 === e(u[c], c, u)) break;
        }
        return r;
      };
    }(),
    ya = de;
  var ga = le;
  var ja = function (t, r) {
      return function (e, n) {
        if (null == e) return e;
        if (!ga(e)) return t(e, n);
        for (var o = e.length, u = r ? o : -1, a = Object(e); (r ? u-- : ++u < o) && !1 !== n(a[u], u, a);) {
          ;
        }
        return e;
      };
    }(function (t, r) {
      return t && ha(t, r, ya);
    }),
    _a = Yu;
  var wa = ar,
    xa = ja,
    Oa = function Oa(t) {
      return "function" == typeof t ? t : _a;
    },
    $a = Sr;
  var Aa = function Aa(t, r) {
    return ($a(t) ? wa : xa)(t, Oa(r));
  };
  var ma = function ma(t, r, e, n) {
    var o = -1,
      u = null == t ? 0 : t.length;
    for (n && u && (e = t[++o]); ++o < u;) {
      e = r(e, t[o], o, t);
    }
    return e;
  };
  var za = function (t) {
      return function (r) {
        return null == t ? void 0 : t[r];
      };
    }({
      "À": "A",
      "Á": "A",
      "Â": "A",
      "Ã": "A",
      "Ä": "A",
      "Å": "A",
      "à": "a",
      "á": "a",
      "â": "a",
      "ã": "a",
      "ä": "a",
      "å": "a",
      "Ç": "C",
      "ç": "c",
      "Ð": "D",
      "ð": "d",
      "È": "E",
      "É": "E",
      "Ê": "E",
      "Ë": "E",
      "è": "e",
      "é": "e",
      "ê": "e",
      "ë": "e",
      "Ì": "I",
      "Í": "I",
      "Î": "I",
      "Ï": "I",
      "ì": "i",
      "í": "i",
      "î": "i",
      "ï": "i",
      "Ñ": "N",
      "ñ": "n",
      "Ò": "O",
      "Ó": "O",
      "Ô": "O",
      "Õ": "O",
      "Ö": "O",
      "Ø": "O",
      "ò": "o",
      "ó": "o",
      "ô": "o",
      "õ": "o",
      "ö": "o",
      "ø": "o",
      "Ù": "U",
      "Ú": "U",
      "Û": "U",
      "Ü": "U",
      "ù": "u",
      "ú": "u",
      "û": "u",
      "ü": "u",
      "Ý": "Y",
      "ý": "y",
      "ÿ": "y",
      "Æ": "Ae",
      "æ": "ae",
      "Þ": "Th",
      "þ": "th",
      "ß": "ss",
      "Ā": "A",
      "Ă": "A",
      "Ą": "A",
      "ā": "a",
      "ă": "a",
      "ą": "a",
      "Ć": "C",
      "Ĉ": "C",
      "Ċ": "C",
      "Č": "C",
      "ć": "c",
      "ĉ": "c",
      "ċ": "c",
      "č": "c",
      "Ď": "D",
      "Đ": "D",
      "ď": "d",
      "đ": "d",
      "Ē": "E",
      "Ĕ": "E",
      "Ė": "E",
      "Ę": "E",
      "Ě": "E",
      "ē": "e",
      "ĕ": "e",
      "ė": "e",
      "ę": "e",
      "ě": "e",
      "Ĝ": "G",
      "Ğ": "G",
      "Ġ": "G",
      "Ģ": "G",
      "ĝ": "g",
      "ğ": "g",
      "ġ": "g",
      "ģ": "g",
      "Ĥ": "H",
      "Ħ": "H",
      "ĥ": "h",
      "ħ": "h",
      "Ĩ": "I",
      "Ī": "I",
      "Ĭ": "I",
      "Į": "I",
      "İ": "I",
      "ĩ": "i",
      "ī": "i",
      "ĭ": "i",
      "į": "i",
      "ı": "i",
      "Ĵ": "J",
      "ĵ": "j",
      "Ķ": "K",
      "ķ": "k",
      "ĸ": "k",
      "Ĺ": "L",
      "Ļ": "L",
      "Ľ": "L",
      "Ŀ": "L",
      "Ł": "L",
      "ĺ": "l",
      "ļ": "l",
      "ľ": "l",
      "ŀ": "l",
      "ł": "l",
      "Ń": "N",
      "Ņ": "N",
      "Ň": "N",
      "Ŋ": "N",
      "ń": "n",
      "ņ": "n",
      "ň": "n",
      "ŋ": "n",
      "Ō": "O",
      "Ŏ": "O",
      "Ő": "O",
      "ō": "o",
      "ŏ": "o",
      "ő": "o",
      "Ŕ": "R",
      "Ŗ": "R",
      "Ř": "R",
      "ŕ": "r",
      "ŗ": "r",
      "ř": "r",
      "Ś": "S",
      "Ŝ": "S",
      "Ş": "S",
      "Š": "S",
      "ś": "s",
      "ŝ": "s",
      "ş": "s",
      "š": "s",
      "Ţ": "T",
      "Ť": "T",
      "Ŧ": "T",
      "ţ": "t",
      "ť": "t",
      "ŧ": "t",
      "Ũ": "U",
      "Ū": "U",
      "Ŭ": "U",
      "Ů": "U",
      "Ű": "U",
      "Ų": "U",
      "ũ": "u",
      "ū": "u",
      "ŭ": "u",
      "ů": "u",
      "ű": "u",
      "ų": "u",
      "Ŵ": "W",
      "ŵ": "w",
      "Ŷ": "Y",
      "ŷ": "y",
      "Ÿ": "Y",
      "Ź": "Z",
      "Ż": "Z",
      "Ž": "Z",
      "ź": "z",
      "ż": "z",
      "ž": "z",
      "Ĳ": "IJ",
      "ĳ": "ij",
      "Œ": "Oe",
      "œ": "oe",
      "ŉ": "'n",
      "ſ": "s"
    }),
    Ea = fu,
    Sa = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g,
    Ua = RegExp("[\\u0300-\\u036f\\ufe20-\\ufe2f\\u20d0-\\u20ff]", "g");
  var Ia = function Ia(t) {
      return (t = Ea(t)) && t.replace(Sa, za).replace(Ua, "");
    },
    Ca = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g;
  var Pa = function Pa(t) {
      return t.match(Ca) || [];
    },
    Ta = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/;
  var Ra = function Ra(t) {
      return Ta.test(t);
    },
    La = "\\u2700-\\u27bf",
    Va = "a-z\\xdf-\\xf6\\xf8-\\xff",
    ka = "A-Z\\xc0-\\xd6\\xd8-\\xde",
    Da = "\\xac\\xb1\\xd7\\xf7\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf\\u2000-\\u206f \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000",
    Fa = "[" + Da + "]",
    Ma = "\\d+",
    Ba = "[\\u2700-\\u27bf]",
    Na = "[" + Va + "]",
    Za = "[^\\ud800-\\udfff" + Da + Ma + La + Va + ka + "]",
    Ga = "(?:\\ud83c[\\udde6-\\uddff]){2}",
    Wa = "[\\ud800-\\udbff][\\udc00-\\udfff]",
    qa = "[" + ka + "]",
    Ha = "(?:" + Na + "|" + Za + ")",
    Ya = "(?:" + qa + "|" + Za + ")",
    Ja = "(?:['’](?:d|ll|m|re|s|t|ve))?",
    Ka = "(?:['’](?:D|LL|M|RE|S|T|VE))?",
    Qa = "(?:[\\u0300-\\u036f\\ufe20-\\ufe2f\\u20d0-\\u20ff]|\\ud83c[\\udffb-\\udfff])?",
    Xa = "[\\ufe0e\\ufe0f]?",
    ti = Xa + Qa + ("(?:\\u200d(?:" + ["[^\\ud800-\\udfff]", Ga, Wa].join("|") + ")" + Xa + Qa + ")*"),
    ri = "(?:" + [Ba, Ga, Wa].join("|") + ")" + ti,
    ei = RegExp([qa + "?" + Na + "+" + Ja + "(?=" + [Fa, qa, "$"].join("|") + ")", Ya + "+" + Ka + "(?=" + [Fa, qa + Ha, "$"].join("|") + ")", qa + "?" + Ha + "+" + Ja, qa + "+" + Ka, "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", Ma, ri].join("|"), "g");
  var ni = Pa,
    oi = Ra,
    ui = fu,
    ai = function ai(t) {
      return t.match(ei) || [];
    };
  var ii = ma,
    ci = Ia,
    fi = function fi(t, r, e) {
      return t = ui(t), void 0 === (r = e ? void 0 : r) ? oi(t) ? ai(t) : ni(t) : t.match(r) || [];
    },
    li = RegExp("['’]", "g");
  var vi = function vi(t) {
      return function (r) {
        return ii(fi(ci(r).replace(li, "")), t, "");
      };
    },
    si = vi(function (t, r, e) {
      return t + (e ? "-" : "") + r.toLowerCase();
    }),
    pi = _u;
  var di = function di(t, r, e) {
      var n = t.length;
      return e = void 0 === e ? n : e, !r && e >= n ? t : pi(t, r, e);
    },
    bi = RegExp("[\\u200d\\ud800-\\udfff\\u0300-\\u036f\\ufe20-\\ufe2f\\u20d0-\\u20ff\\ufe0e\\ufe0f]");
  var hi = function hi(t) {
    return bi.test(t);
  };
  var yi = function yi(t) {
      return t.split("");
    },
    gi = "[\\ud800-\\udfff]",
    ji = "[\\u0300-\\u036f\\ufe20-\\ufe2f\\u20d0-\\u20ff]",
    _i = "\\ud83c[\\udffb-\\udfff]",
    wi = "[^\\ud800-\\udfff]",
    xi = "(?:\\ud83c[\\udde6-\\uddff]){2}",
    Oi = "[\\ud800-\\udbff][\\udc00-\\udfff]",
    $i = "(?:" + ji + "|" + _i + ")" + "?",
    Ai = "[\\ufe0e\\ufe0f]?",
    mi = Ai + $i + ("(?:\\u200d(?:" + [wi, xi, Oi].join("|") + ")" + Ai + $i + ")*"),
    zi = "(?:" + [wi + ji + "?", ji, xi, Oi, gi].join("|") + ")",
    Ei = RegExp(_i + "(?=" + _i + ")|" + zi + mi, "g");
  var Si = yi,
    Ui = hi,
    Ii = function Ii(t) {
      return t.match(Ei) || [];
    };
  var Ci = di,
    Pi = hi,
    Ti = function Ti(t) {
      return Ui(t) ? Ii(t) : Si(t);
    },
    Ri = fu;
  var Li = function (t) {
      return function (r) {
        r = Ri(r);
        var e = Pi(r) ? Ti(r) : void 0,
          n = e ? e[0] : r.charAt(0),
          o = e ? Ci(e, 1).join("") : r.slice(1);
        return n[t]() + o;
      };
    }("toUpperCase"),
    Vi = fu,
    ki = Li;
  var Di = function Di(t) {
      return ki(Vi(t).toLowerCase());
    },
    Fi = vi(function (t, r, e) {
      return r = r.toLowerCase(), t + (e ? Di(r) : r);
    }),
    Mi = Yu,
    Bi = Hu,
    Ni = ra;
  var Zi = function Zi(t, r) {
    return Ni(Bi(t, r, Mi), t + "");
  };
  var Gi = Ht,
    Wi = function Wi(t) {
      return this.__data__.set(t, "__lodash_hash_undefined__"), this;
    },
    qi = function qi(t) {
      return this.__data__.has(t);
    };
  function Hi(t) {
    var r = -1,
      e = null == t ? 0 : t.length;
    for (this.__data__ = new Gi(); ++r < e;) {
      this.add(t[r]);
    }
  }
  Hi.prototype.add = Hi.prototype.push = Wi, Hi.prototype.has = qi;
  var Yi = Hi;
  var Ji = function Ji(t, r, e, n) {
      for (var o = t.length, u = e + (n ? 1 : -1); n ? u-- : ++u < o;) {
        if (r(t[u], u, t)) return u;
      }
      return -1;
    },
    Ki = function Ki(t) {
      return t != t;
    },
    Qi = function Qi(t, r, e) {
      for (var n = e - 1, o = t.length; ++n < o;) {
        if (t[n] === r) return n;
      }
      return -1;
    };
  var Xi = function Xi(t, r, e) {
    return r == r ? Qi(t, r, e) : Ji(t, Ki, e);
  };
  var tc = function tc(t, r) {
    return !!(null == t ? 0 : t.length) && Xi(t, r, 0) > -1;
  };
  var rc = function rc(t, r, e) {
    for (var n = -1, o = null == t ? 0 : t.length; ++n < o;) {
      if (e(r, t[n])) return !0;
    }
    return !1;
  };
  var ec = function ec(t, r) {
    return t.has(r);
  };
  var nc = function nc(t) {
      var r = -1,
        e = Array(t.size);
      return t.forEach(function (t) {
        e[++r] = t;
      }), e;
    },
    oc = ln,
    uc = function uc() {},
    ac = oc && 1 / nc(new oc([, -0]))[1] == 1 / 0 ? function (t) {
      return new oc(t);
    } : uc,
    ic = Yi,
    cc = tc,
    fc = rc,
    lc = ec,
    vc = ac,
    sc = nc;
  var pc = function pc(t, r, e) {
      var n = -1,
        o = cc,
        u = t.length,
        a = !0,
        i = [],
        c = i;
      if (e) a = !1, o = fc;else if (u >= 200) {
        var f = r ? null : vc(t);
        if (f) return sc(f);
        a = !1, o = lc, c = new ic();
      } else c = r ? [] : i;
      t: for (; ++n < u;) {
        var l = t[n],
          v = r ? r(l) : l;
        if (l = e || 0 !== l ? l : 0, a && v == v) {
          for (var s = c.length; s--;) {
            if (c[s] === v) continue t;
          }
          r && c.push(v), i.push(l);
        } else o(c, v, e) || (c !== i && c.push(v), i.push(l));
      }
      return i;
    },
    dc = le,
    bc = jr;
  var hc = Nu,
    yc = pc,
    gc = function gc(t) {
      return bc(t) && dc(t);
    },
    jc = Zi(function (t) {
      return yc(hc(t, 1, gc, !0));
    }),
    _c = pc;
  var wc = function wc(t) {
    return t && t.length ? _c(t) : [];
  };
  var xc = Yi,
    Oc = function Oc(t, r) {
      for (var e = -1, n = null == t ? 0 : t.length; ++e < n;) {
        if (r(t[e], e, t)) return !0;
      }
      return !1;
    },
    $c = ec;
  var Ac = function Ac(t, r, e, n, o, u) {
    var a = 1 & e,
      i = t.length,
      c = r.length;
    if (i != c && !(a && c > i)) return !1;
    var f = u.get(t),
      l = u.get(r);
    if (f && l) return f == r && l == t;
    var v = -1,
      s = !0,
      p = 2 & e ? new xc() : void 0;
    for (u.set(t, r), u.set(r, t); ++v < i;) {
      var d = t[v],
        b = r[v];
      if (n) var h = a ? n(b, d, v, r, t, u) : n(d, b, v, t, r, u);
      if (void 0 !== h) {
        if (h) continue;
        s = !1;
        break;
      }
      if (p) {
        if (!Oc(r, function (t, r) {
          if (!$c(p, r) && (d === t || o(d, t, e, n, u))) return p.push(r);
        })) {
          s = !1;
          break;
        }
      } else if (d !== b && !o(d, b, e, n, u)) {
        s = !1;
        break;
      }
    }
    return u.delete(t), u.delete(r), s;
  };
  var mc = Cn,
    zc = v,
    Ec = Ac,
    Sc = function Sc(t) {
      var r = -1,
        e = Array(t.size);
      return t.forEach(function (t, n) {
        e[++r] = [n, t];
      }), e;
    },
    Uc = nc,
    Ic = R ? R.prototype : void 0,
    Cc = Ic ? Ic.valueOf : void 0;
  var Pc = function Pc(t, r, e, n, o, u, a) {
      switch (e) {
        case "[object DataView]":
          if (t.byteLength != r.byteLength || t.byteOffset != r.byteOffset) return !1;
          t = t.buffer, r = r.buffer;
        case "[object ArrayBuffer]":
          return !(t.byteLength != r.byteLength || !u(new mc(t), new mc(r)));
        case "[object Boolean]":
        case "[object Date]":
        case "[object Number]":
          return zc(+t, +r);
        case "[object Error]":
          return t.name == r.name && t.message == r.message;
        case "[object RegExp]":
        case "[object String]":
          return t == r + "";
        case "[object Map]":
          var i = Sc;
        case "[object Set]":
          var c = 1 & n;
          if (i || (i = Uc), t.size != r.size && !c) return !1;
          var f = a.get(t);
          if (f) return f == r;
          n |= 2, a.set(t, r);
          var l = Ec(i(t), i(r), n, o, u, a);
          return a.delete(t), l;
        case "[object Symbol]":
          if (Cc) return Cc.call(t) == Cc.call(r);
      }
      return !1;
    },
    Tc = en,
    Rc = Object.prototype.hasOwnProperty;
  var Lc = ur,
    Vc = Ac,
    kc = Pc,
    Dc = function Dc(t, r, e, n, o, u) {
      var a = 1 & e,
        i = Tc(t),
        c = i.length;
      if (c != Tc(r).length && !a) return !1;
      for (var f = c; f--;) {
        var l = i[f];
        if (!(a ? l in r : Rc.call(r, l))) return !1;
      }
      var v = u.get(t),
        s = u.get(r);
      if (v && s) return v == r && s == t;
      var p = !0;
      u.set(t, r), u.set(r, t);
      for (var d = a; ++f < c;) {
        var b = t[l = i[f]],
          h = r[l];
        if (n) var y = a ? n(h, b, l, r, t, u) : n(b, h, l, t, r, u);
        if (!(void 0 === y ? b === h || o(b, h, e, n, u) : y)) {
          p = !1;
          break;
        }
        d || (d = "constructor" == l);
      }
      if (p && !d) {
        var g = t.constructor,
          j = r.constructor;
        g == j || !("constructor" in t) || !("constructor" in r) || "function" == typeof g && g instanceof g && "function" == typeof j && j instanceof j || (p = !1);
      }
      return u.delete(t), u.delete(r), p;
    },
    Fc = Sn,
    Mc = Sr,
    Bc = Ur.exports,
    Nc = Wr,
    Zc = "[object Arguments]",
    Gc = "[object Array]",
    Wc = "[object Object]",
    qc = Object.prototype.hasOwnProperty;
  var Hc = function Hc(t, r, e, n, o, u) {
      var a = Mc(t),
        i = Mc(r),
        c = a ? Gc : Fc(t),
        f = i ? Gc : Fc(r),
        l = (c = c == Zc ? Wc : c) == Wc,
        v = (f = f == Zc ? Wc : f) == Wc,
        s = c == f;
      if (s && Bc(t)) {
        if (!Bc(r)) return !1;
        a = !0, l = !1;
      }
      if (s && !l) return u || (u = new Lc()), a || Nc(t) ? Vc(t, r, e, n, o, u) : kc(t, r, c, e, n, o, u);
      if (!(1 & e)) {
        var p = l && qc.call(t, "__wrapped__"),
          d = v && qc.call(r, "__wrapped__");
        if (p || d) {
          var b = p ? t.value() : t,
            h = d ? r.value() : r;
          return u || (u = new Lc()), o(b, h, e, n, u);
        }
      }
      return !!s && (u || (u = new Lc()), Dc(t, r, e, n, o, u));
    },
    Yc = jr;
  var Jc = function t(r, e, n, o, u) {
      return r === e || (null == r || null == e || !Yc(r) && !Yc(e) ? r != r && e != e : Hc(r, e, n, o, t, u));
    },
    Kc = ur,
    Qc = Jc;
  var Xc = q;
  var tf = function tf(t) {
      return t == t && !Xc(t);
    },
    rf = tf,
    ef = de;
  var nf = function nf(t, r) {
      return function (e) {
        return null != e && e[t] === r && (void 0 !== r || t in Object(e));
      };
    },
    of = function of(t, r, e, n) {
      var o = e.length,
        u = o,
        a = !n;
      if (null == t) return !u;
      for (t = Object(t); o--;) {
        var i = e[o];
        if (a && i[2] ? i[1] !== t[i[0]] : !(i[0] in t)) return !1;
      }
      for (; ++o < u;) {
        var c = (i = e[o])[0],
          f = t[c],
          l = i[1];
        if (a && i[2]) {
          if (void 0 === f && !(c in t)) return !1;
        } else {
          var v = new Kc();
          if (n) var s = n(f, l, c, t, r, v);
          if (!(void 0 === s ? Qc(l, f, 3, n, v) : s)) return !1;
        }
      }
      return !0;
    },
    uf = function uf(t) {
      for (var r = ef(t), e = r.length; e--;) {
        var n = r[e],
          o = t[n];
        r[e] = [n, o, rf(o)];
      }
      return r;
    },
    af = nf;
  var cf = du,
    ff = Er,
    lf = Sr,
    vf = Pr,
    sf = Tr,
    pf = hu;
  var df = function df(t, r) {
      return null != t && r in Object(t);
    },
    bf = function bf(t, r, e) {
      for (var n = -1, o = (r = cf(r, t)).length, u = !1; ++n < o;) {
        var a = pf(r[n]);
        if (!(u = null != t && e(t, a))) break;
        t = t[a];
      }
      return u || ++n != o ? u : !!(o = null == t ? 0 : t.length) && sf(o) && vf(a, o) && (lf(t) || ff(t));
    };
  var hf = Jc,
    yf = ba,
    gf = function gf(t, r) {
      return null != t && bf(t, r, df);
    },
    jf = Yo,
    _f = tf,
    wf = nf,
    xf = hu;
  var Of = ju;
  var $f = function $f(t) {
      return function (r) {
        return null == r ? void 0 : r[t];
      };
    },
    Af = function Af(t) {
      return function (r) {
        return Of(r, t);
      };
    },
    mf = Yo,
    zf = hu;
  var Ef = function Ef(t) {
      var r = uf(t);
      return 1 == r.length && r[0][2] ? af(r[0][0], r[0][1]) : function (e) {
        return e === t || of(e, t, r);
      };
    },
    Sf = function Sf(t, r) {
      return jf(t) && _f(r) ? wf(xf(t), r) : function (e) {
        var n = yf(e, t);
        return void 0 === n && n === r ? gf(e, t) : hf(r, n, 3);
      };
    },
    Uf = Yu,
    If = Sr,
    Cf = function Cf(t) {
      return mf(t) ? $f(zf(t)) : Af(t);
    };
  var Pf = ja,
    Tf = le;
  var Rf = Zo;
  var Lf = function Lf(t, r) {
    if (t !== r) {
      var e = void 0 !== t,
        n = null === t,
        o = t == t,
        u = Rf(t),
        a = void 0 !== r,
        i = null === r,
        c = r == r,
        f = Rf(r);
      if (!i && !f && !u && t > r || u && a && c && !i && !f || n && a && c || !e && c || !o) return 1;
      if (!n && !u && !f && t < r || f && e && o && !n && !u || i && e && o || !a && o || !c) return -1;
    }
    return 0;
  };
  var Vf = f,
    kf = ju,
    Df = function Df(t) {
      return "function" == typeof t ? t : null == t ? Uf : "object" == _typeof(t) ? If(t) ? Sf(t[0], t[1]) : Ef(t) : Cf(t);
    },
    Ff = function Ff(t, r) {
      var e = -1,
        n = Tf(t) ? Array(t.length) : [];
      return Pf(t, function (t, o, u) {
        n[++e] = r(t, o, u);
      }), n;
    },
    Mf = function Mf(t, r) {
      var e = t.length;
      for (t.sort(r); e--;) {
        t[e] = t[e].value;
      }
      return t;
    },
    Bf = Fr,
    Nf = function Nf(t, r, e) {
      for (var n = -1, o = t.criteria, u = r.criteria, a = o.length, i = e.length; ++n < a;) {
        var c = Lf(o[n], u[n]);
        if (c) return n >= i ? c : c * ("desc" == e[n] ? -1 : 1);
      }
      return t.index - r.index;
    },
    Zf = Yu,
    Gf = Sr;
  var Wf = v,
    qf = le,
    Hf = Pr,
    Yf = q;
  var Jf = Nu,
    Kf = function Kf(t, r, e) {
      r = r.length ? Vf(r, function (t) {
        return Gf(t) ? function (r) {
          return kf(r, 1 === t.length ? t[0] : t);
        } : t;
      }) : [Zf];
      var n = -1;
      r = Vf(r, Bf(Df));
      var o = Ff(t, function (t, e, o) {
        return {
          criteria: Vf(r, function (r) {
            return r(t);
          }),
          index: ++n,
          value: t
        };
      });
      return Mf(o, function (t, r) {
        return Nf(t, r, e);
      });
    },
    Qf = function Qf(t, r, e) {
      if (!Yf(e)) return !1;
      var n = _typeof(r);
      return !!("number" == n ? qf(e) && Hf(r, e.length) : "string" == n && r in e) && Wf(e[r], t);
    },
    Xf = Zi(function (t, r) {
      if (null == t) return [];
      var e = r.length;
      return e > 1 && Qf(t, r[0], r[1]) ? r = [] : e > 2 && Qf(r[0], r[1], r[2]) && (r = [r[0]]), Kf(t, Jf(r, 1), []);
    });
  function tl(t, r) {
    var e = t.$root.$$phase;
    "$apply" == e || "$digest" == e ? r() : t.$apply(r);
  }
  var rl = [function () {
    return {
      restrict: "A",
      terminal: !0,
      priority: 1001,
      link: function link(e, n, a) {
        var _o$default$prototype, _o$default$prototype$;
        var i = function (r) {
            var _r$ngVueExpose;
            var e = /^&([a-z$_][a-z0-9$_]*)$/i,
              n = ((_r$ngVueExpose = r.ngVueExpose) !== null && _r$ngVueExpose !== void 0 ? _r$ngVueExpose : "").split(",").map(function (t) {
                return t.trim();
              }).filter(function (t) {
                return e.test(t);
              }).map(function (t) {
                return t.replace(e, "$1");
              }),
              o = /^(?:v-on:|@)[a-z-]+(:[a-z0-9-]+)?(\.[a-z0-9-]+)*/i,
              u = /^([a-z_$][a-z0-9_$]*)(?:\(\))?$/i,
              a = t(r);
            return Aa(a, function (t, r) {
              o.test(r) && u.test(t) && n.push(t.replace(u, "$1"));
            }), n;
          }(a),
          c = function (r) {
            var _r$ngVueExpose2;
            var e = /^(?:v-model|v-html|v-text|v-show|v-class|v-attr|v-style|v-if)(?:\.[a-z0-9]+)*$/i,
              n = /^(?:v-bind)?:[a-z-]+(\.[a-z]+)*$/i,
              o = /^[a-z$_][a-z0-9$_]*(\.[a-z$_][a-z0-9$_]*)*$/i,
              a = ((_r$ngVueExpose2 = r.ngVueExpose) !== null && _r$ngVueExpose2 !== void 0 ? _r$ngVueExpose2 : "").split(",").map(function (t) {
                return t.trim();
              }).filter(function (t) {
                return o.test(t);
              }),
              i = t(r);
            Aa(i, function (t, r) {
              (n.test(r) || e.test(r)) && o.test(t) && a.push(t);
            });
            var c = _toConsumableArray(a);
            return a.forEach(function (t) {
              c = jc(c, u.parents(t));
            }), Xf(wc(c));
          }(a),
          f = function (r) {
            var e = /^(?:v-model)$/i,
              n = /^(?:v-bind)?:([a-z-]+)\.sync*$/i,
              o = /^[a-z$_][a-z0-9$_]*(\.[a-z$_][a-z0-9$_]*)*$/i,
              u = {},
              a = t(r);
            return Aa(a, function (t, r) {
              if (e.test(r)) {
                var _r2 = "value";
                if (!o.test(t)) throw Error("Unsupported v-model binding value: ".concat(t));
                u[_r2] = t;
              }
              if (n.test(r)) {
                var _e2 = r.replace(n, "$1").replace(/-[a-z]/g, function (t) {
                  return t[1].toUpperCase();
                }).replace(/^[A-Z]/, function (t) {
                  return t[1].toLowerCase();
                });
                if (!o.test(t)) throw Error("Unsupported v-bind:".concat(_e2, ".sync binding value: ").concat(t));
                u[_e2] = t;
              }
            }), u;
          }(a);
        c.forEach(function (t) {
          return r(e, t);
        }), i.forEach(function (t) {
          return r(e, t);
        });
        var l = {},
          v = {};
        c.filter(u.isRoot).forEach(function (t) {
          l[t] = e.$eval(t);
        });
        var s = {};
        a.ngVue && (s = e.$eval(a.ngVue) || {}), s = pa(s, "props", "data", "computed", "methods", "watch"), i.forEach(function (t) {
          v[t] = function () {
            for (var _len = arguments.length, r = new Array(_len), _key = 0; _key < _len; _key++) {
              r[_key] = arguments[_key];
            }
            console.debug("ng(vue): Calling ng delegate: ".concat(t, "()")), tl(e, function () {
              return e.$eval(t).apply(e, r);
            });
          };
        });
        var p = function (t) {
            var _r3;
            var r = t,
              e = (_r3 = r) === null || _r3 === void 0 ? void 0 : _r3.$component;
            for (; !e && r;) {
              var _r4;
              r = r.parentElement, e = (_r4 = r) === null || _r4 === void 0 ? void 0 : _r4.$component;
            }
            return e;
          }(n) || ((_o$default$prototype = o.default.prototype) === null || _o$default$prototype === void 0 ? void 0 : (_o$default$prototype$ = _o$default$prototype.$ngVue) === null || _o$default$prototype$ === void 0 ? void 0 : _o$default$prototype$.vueApp) || void 0,
          d = new o.default(_objectSpread(_objectSpread({
            parent: p
          }, s), {}, {
            data: l,
            methods: v
          })).$mount(n[0]);
        d.$el.$component = d, e.$on("$destroy", function () {
          console.debug("ng(vue): destroying vue-comp", d), d.$destroy();
        }), c.forEach(function (t) {
          var r = t;
          e.$watch(t, function (e) {
            console.debug("ng(vue): ng(".concat(t, ") => vue(").concat(r, ") ="), e);
            var n = d,
              a = r;
            u.isRoot(a) || (n = ba(d, u.parent(a)), a = u.leaf(a)), o.default.set(n, a, e);
          });
        }), Aa(f, function (t, r) {
          d.$children.forEach(function (n) {
            return n.$on("update:".concat(Fi(r)), function (n) {
              console.debug("ng(vue): vue(".concat(r, ") => ng(").concat(t, ") ="), n), tl(e, function () {
                return ba(e, t, n);
              });
            });
          }), d.$children.forEach(function (n) {
            return n.$on("update:".concat(si(r)), function (n) {
              console.warn("$emit event using camelCase (update:".concat(Fi(r), "). instead of kebabCase (update:").concat(si(r), ").")), console.debug("ng(vue): vue(".concat(r, ") => ng(").concat(t, ") ="), n), tl(e, function () {
                return ba(e, t, n);
              });
            });
          });
        });
      }
    };
    function t(t) {
      var r = {};
      return Aa(t.$attr, function (e, n) {
        var o = t[n];
        r[e] = o;
      }), r;
    }
    function r(t, r) {
      if (void 0 === t.$eval(r)) throw Error("\"".concat(r, "\" is not defined on parent scope"));
    }
  }];
  var el = n.default.module("angularVue", []);
  return el.directive("ngVue", rl), el;
});
//# sourceMappingURL=angular-vue.min.js.map
