function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
!function (t, r) {
  "object" == (typeof exports === "undefined" ? "undefined" : _typeof(exports)) && "undefined" != typeof module ? module.exports = r(require("Vue")) : "function" == typeof define && define.amd ? define(["Vue"], r) : (t = "undefined" != typeof globalThis ? globalThis : t || self).AngularVueDirective = r(t.Vue);
}(this, function (t) {
  "use strict";

  function r(t) {
    return t && "object" == _typeof(t) && "default" in t ? t : {
      default: t
    };
  }
  var e = r(t),
    n = {
      parent: o,
      parents: function parents(t) {
        var r = [];
        var e = o(t);
        for (; e;) {
          r.push(e), e = o(e);
        }
        return r;
      },
      leaf: function leaf(t) {
        return u(t).pop();
      },
      root: function root(t) {
        return u(t)[0];
      },
      isRoot: function isRoot(t) {
        return 1 === u(t).length;
      }
    };
  function o(t) {
    var r = u(t);
    return r.pop(), function (t) {
      return t.join(".");
    }(r);
  }
  function u(t) {
    if (!t) throw new Error("Invalid path ".concat(t));
    return t.split(".");
  }
  var a = "undefined" != typeof globalThis ? globalThis : "undefined" != typeof window ? window : "undefined" != typeof global ? global : "undefined" != typeof self ? self : {};
  var i = function i(t, r) {
    for (var e = -1, n = null == t ? 0 : t.length, o = Array(n); ++e < n;) {
      o[e] = r(t[e], e, t);
    }
    return o;
  };
  var c = function c() {
    this.__data__ = [], this.size = 0;
  };
  var f = function f(t, r) {
      return t === r || t != t && r != r;
    },
    v = f;
  var l = function l(t, r) {
      for (var e = t.length; e--;) {
        if (v(t[e][0], r)) return e;
      }
      return -1;
    },
    s = l,
    p = Array.prototype.splice;
  var d = l;
  var b = l;
  var h = l;
  var y = c,
    g = function g(t) {
      var r = this.__data__,
        e = s(r, t);
      return !(e < 0) && (e == r.length - 1 ? r.pop() : p.call(r, e, 1), --this.size, !0);
    },
    j = function j(t) {
      var r = this.__data__,
        e = d(r, t);
      return e < 0 ? void 0 : r[e][1];
    },
    _ = function _(t) {
      return b(this.__data__, t) > -1;
    },
    w = function w(t, r) {
      var e = this.__data__,
        n = h(e, t);
      return n < 0 ? (++this.size, e.push([t, r])) : e[n][1] = r, this;
    };
  function x(t) {
    var r = -1,
      e = null == t ? 0 : t.length;
    for (this.clear(); ++r < e;) {
      var n = t[r];
      this.set(n[0], n[1]);
    }
  }
  x.prototype.clear = y, x.prototype.delete = g, x.prototype.get = j, x.prototype.has = _, x.prototype.set = w;
  var O = x,
    $ = O;
  var A = function A() {
    this.__data__ = new $(), this.size = 0;
  };
  var m = function m(t) {
    var r = this.__data__,
      e = r.delete(t);
    return this.size = r.size, e;
  };
  var z = function z(t) {
    return this.__data__.get(t);
  };
  var E = function E(t) {
      return this.__data__.has(t);
    },
    S = "object" == _typeof(a) && a && a.Object === Object && a,
    U = S,
    I = "object" == (typeof self === "undefined" ? "undefined" : _typeof(self)) && self && self.Object === Object && self,
    C = U || I || Function("return this")(),
    P = C.Symbol,
    T = P,
    R = Object.prototype,
    D = R.hasOwnProperty,
    L = R.toString,
    k = T ? T.toStringTag : void 0;
  var F = function F(t) {
      var r = D.call(t, k),
        e = t[k];
      try {
        t[k] = void 0;
        var n = !0;
      } catch (t) {}
      var o = L.call(t);
      return n && (r ? t[k] = e : delete t[k]), o;
    },
    V = Object.prototype.toString;
  var M = F,
    B = function B(t) {
      return V.call(t);
    },
    N = P ? P.toStringTag : void 0;
  var Z = function Z(t) {
    return null == t ? void 0 === t ? "[object Undefined]" : "[object Null]" : N && N in Object(t) ? M(t) : B(t);
  };
  var G = function G(t) {
      var r = _typeof(t);
      return null != t && ("object" == r || "function" == r);
    },
    W = Z,
    q = G;
  var H,
    Y = function Y(t) {
      if (!q(t)) return !1;
      var r = W(t);
      return "[object Function]" == r || "[object GeneratorFunction]" == r || "[object AsyncFunction]" == r || "[object Proxy]" == r;
    },
    J = C["__core-js_shared__"],
    K = (H = /[^.]+$/.exec(J && J.keys && J.keys.IE_PROTO || "")) ? "Symbol(src)_1." + H : "";
  var Q = function Q(t) {
      return !!K && K in t;
    },
    X = Function.prototype.toString;
  var tt = function tt(t) {
      if (null != t) {
        try {
          return X.call(t);
        } catch (t) {}
        try {
          return t + "";
        } catch (t) {}
      }
      return "";
    },
    rt = Y,
    et = Q,
    nt = G,
    ot = tt,
    ut = /^\[object .+?Constructor\]$/,
    at = Function.prototype,
    it = Object.prototype,
    ct = at.toString,
    ft = it.hasOwnProperty,
    vt = RegExp("^" + ct.call(ft).replace(/[\\^$.*+?()[\]{}|]/g, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$");
  var lt = function lt(t) {
      return !(!nt(t) || et(t)) && (rt(t) ? vt : ut).test(ot(t));
    },
    st = function st(t, r) {
      return null == t ? void 0 : t[r];
    };
  var pt = function pt(t, r) {
      var e = st(t, r);
      return lt(e) ? e : void 0;
    },
    dt = pt(C, "Map"),
    bt = pt(Object, "create"),
    ht = bt;
  var yt = function yt() {
    this.__data__ = ht ? ht(null) : {}, this.size = 0;
  };
  var gt = function gt(t) {
      var r = this.has(t) && delete this.__data__[t];
      return this.size -= r ? 1 : 0, r;
    },
    jt = bt,
    _t = Object.prototype.hasOwnProperty;
  var wt = function wt(t) {
      var r = this.__data__;
      if (jt) {
        var e = r[t];
        return "__lodash_hash_undefined__" === e ? void 0 : e;
      }
      return _t.call(r, t) ? r[t] : void 0;
    },
    xt = bt,
    Ot = Object.prototype.hasOwnProperty;
  var $t = bt;
  var At = yt,
    mt = gt,
    zt = wt,
    Et = function Et(t) {
      var r = this.__data__;
      return xt ? void 0 !== r[t] : Ot.call(r, t);
    },
    St = function St(t, r) {
      var e = this.__data__;
      return this.size += this.has(t) ? 0 : 1, e[t] = $t && void 0 === r ? "__lodash_hash_undefined__" : r, this;
    };
  function Ut(t) {
    var r = -1,
      e = null == t ? 0 : t.length;
    for (this.clear(); ++r < e;) {
      var n = t[r];
      this.set(n[0], n[1]);
    }
  }
  Ut.prototype.clear = At, Ut.prototype.delete = mt, Ut.prototype.get = zt, Ut.prototype.has = Et, Ut.prototype.set = St;
  var It = Ut,
    Ct = O,
    Pt = dt;
  var Tt = function Tt(t) {
    var r = _typeof(t);
    return "string" == r || "number" == r || "symbol" == r || "boolean" == r ? "__proto__" !== t : null === t;
  };
  var Rt = function Rt(t, r) {
      var e = t.__data__;
      return Tt(r) ? e["string" == typeof r ? "string" : "hash"] : e.map;
    },
    Dt = Rt;
  var Lt = Rt;
  var kt = Rt;
  var Ft = Rt;
  var Vt = function Vt() {
      this.size = 0, this.__data__ = {
        hash: new It(),
        map: new (Pt || Ct)(),
        string: new It()
      };
    },
    Mt = function Mt(t) {
      var r = Dt(this, t).delete(t);
      return this.size -= r ? 1 : 0, r;
    },
    Bt = function Bt(t) {
      return Lt(this, t).get(t);
    },
    Nt = function Nt(t) {
      return kt(this, t).has(t);
    },
    Zt = function Zt(t, r) {
      var e = Ft(this, t),
        n = e.size;
      return e.set(t, r), this.size += e.size == n ? 0 : 1, this;
    };
  function Gt(t) {
    var r = -1,
      e = null == t ? 0 : t.length;
    for (this.clear(); ++r < e;) {
      var n = t[r];
      this.set(n[0], n[1]);
    }
  }
  Gt.prototype.clear = Vt, Gt.prototype.delete = Mt, Gt.prototype.get = Bt, Gt.prototype.has = Nt, Gt.prototype.set = Zt;
  var Wt = Gt,
    qt = O,
    Ht = dt,
    Yt = Wt;
  var Jt = O,
    Kt = A,
    Qt = m,
    Xt = z,
    tr = E,
    rr = function rr(t, r) {
      var e = this.__data__;
      if (e instanceof qt) {
        var n = e.__data__;
        if (!Ht || n.length < 199) return n.push([t, r]), this.size = ++e.size, this;
        e = this.__data__ = new Yt(n);
      }
      return e.set(t, r), this.size = e.size, this;
    };
  function er(t) {
    var r = this.__data__ = new Jt(t);
    this.size = r.size;
  }
  er.prototype.clear = Kt, er.prototype.delete = Qt, er.prototype.get = Xt, er.prototype.has = tr, er.prototype.set = rr;
  var nr = er;
  var or = function or(t, r) {
      for (var e = -1, n = null == t ? 0 : t.length; ++e < n && !1 !== r(t[e], e, t);) {
        ;
      }
      return t;
    },
    ur = pt,
    ar = function () {
      try {
        var t = ur(Object, "defineProperty");
        return t({}, "", {}), t;
      } catch (t) {}
    }(),
    ir = ar;
  var cr = function cr(t, r, e) {
      "__proto__" == r && ir ? ir(t, r, {
        configurable: !0,
        enumerable: !0,
        value: e,
        writable: !0
      }) : t[r] = e;
    },
    fr = cr,
    vr = f,
    lr = Object.prototype.hasOwnProperty;
  var sr = function sr(t, r, e) {
      var n = t[r];
      lr.call(t, r) && vr(n, e) && (void 0 !== e || r in t) || fr(t, r, e);
    },
    pr = sr,
    dr = cr;
  var br = function br(t, r, e, n) {
    var o = !e;
    e || (e = {});
    for (var u = -1, a = r.length; ++u < a;) {
      var i = r[u],
        c = n ? n(e[i], t[i], i, e, t) : void 0;
      void 0 === c && (c = t[i]), o ? dr(e, i, c) : pr(e, i, c);
    }
    return e;
  };
  var hr = function hr(t, r) {
    for (var e = -1, n = Array(t); ++e < t;) {
      n[e] = r(e);
    }
    return n;
  };
  var yr = function yr(t) {
      return null != t && "object" == _typeof(t);
    },
    gr = Z,
    jr = yr;
  var _r = function _r(t) {
      return jr(t) && "[object Arguments]" == gr(t);
    },
    wr = yr,
    xr = Object.prototype,
    Or = xr.hasOwnProperty,
    $r = xr.propertyIsEnumerable,
    Ar = _r(function () {
      return arguments;
    }()) ? _r : function (t) {
      return wr(t) && Or.call(t, "callee") && !$r.call(t, "callee");
    },
    mr = Ar,
    zr = Array.isArray,
    Er = {
      exports: {}
    };
  var Sr = function Sr() {
    return !1;
  };
  !function (t, r) {
    var e = C,
      n = Sr,
      o = r && !r.nodeType && r,
      u = o && t && !t.nodeType && t,
      a = u && u.exports === o ? e.Buffer : void 0,
      i = (a ? a.isBuffer : void 0) || n;
    t.exports = i;
  }(Er, Er.exports);
  var Ur = /^(?:0|[1-9]\d*)$/;
  var Ir = function Ir(t, r) {
    var e = _typeof(t);
    return !!(r = null == r ? 9007199254740991 : r) && ("number" == e || "symbol" != e && Ur.test(t)) && t > -1 && t % 1 == 0 && t < r;
  };
  var Cr = function Cr(t) {
      return "number" == typeof t && t > -1 && t % 1 == 0 && t <= 9007199254740991;
    },
    Pr = Z,
    Tr = Cr,
    Rr = yr,
    Dr = {};
  Dr["[object Float32Array]"] = Dr["[object Float64Array]"] = Dr["[object Int8Array]"] = Dr["[object Int16Array]"] = Dr["[object Int32Array]"] = Dr["[object Uint8Array]"] = Dr["[object Uint8ClampedArray]"] = Dr["[object Uint16Array]"] = Dr["[object Uint32Array]"] = !0, Dr["[object Arguments]"] = Dr["[object Array]"] = Dr["[object ArrayBuffer]"] = Dr["[object Boolean]"] = Dr["[object DataView]"] = Dr["[object Date]"] = Dr["[object Error]"] = Dr["[object Function]"] = Dr["[object Map]"] = Dr["[object Number]"] = Dr["[object Object]"] = Dr["[object RegExp]"] = Dr["[object Set]"] = Dr["[object String]"] = Dr["[object WeakMap]"] = !1;
  var Lr = function Lr(t) {
    return Rr(t) && Tr(t.length) && !!Dr[Pr(t)];
  };
  var kr = function kr(t) {
      return function (r) {
        return t(r);
      };
    },
    Fr = {
      exports: {}
    };
  !function (t, r) {
    var e = S,
      n = r && !r.nodeType && r,
      o = n && t && !t.nodeType && t,
      u = o && o.exports === n && e.process,
      a = function () {
        try {
          var t = o && o.require && o.require("util").types;
          return t || u && u.binding && u.binding("util");
        } catch (t) {}
      }();
    t.exports = a;
  }(Fr, Fr.exports);
  var Vr = Lr,
    Mr = kr,
    Br = Fr.exports,
    Nr = Br && Br.isTypedArray,
    Zr = Nr ? Mr(Nr) : Vr,
    Gr = hr,
    Wr = mr,
    qr = zr,
    Hr = Er.exports,
    Yr = Ir,
    Jr = Zr,
    Kr = Object.prototype.hasOwnProperty;
  var Qr = function Qr(t, r) {
      var e = qr(t),
        n = !e && Wr(t),
        o = !e && !n && Hr(t),
        u = !e && !n && !o && Jr(t),
        a = e || n || o || u,
        i = a ? Gr(t.length, String) : [],
        c = i.length;
      for (var f in t) {
        !r && !Kr.call(t, f) || a && ("length" == f || o && ("offset" == f || "parent" == f) || u && ("buffer" == f || "byteLength" == f || "byteOffset" == f) || Yr(f, c)) || i.push(f);
      }
      return i;
    },
    Xr = Object.prototype;
  var te = function te(t) {
    var r = t && t.constructor;
    return t === ("function" == typeof r && r.prototype || Xr);
  };
  var re = function re(t, r) {
      return function (e) {
        return t(r(e));
      };
    },
    ee = re(Object.keys, Object),
    ne = te,
    oe = ee,
    ue = Object.prototype.hasOwnProperty;
  var ae = Y,
    ie = Cr;
  var ce = function ce(t) {
      return null != t && ie(t.length) && !ae(t);
    },
    fe = Qr,
    ve = function ve(t) {
      if (!ne(t)) return oe(t);
      var r = [];
      for (var e in Object(t)) {
        ue.call(t, e) && "constructor" != e && r.push(e);
      }
      return r;
    },
    le = ce;
  var se = function se(t) {
      return le(t) ? fe(t) : ve(t);
    },
    pe = br,
    de = se;
  var be = function be(t, r) {
    return t && pe(r, de(r), t);
  };
  var he = G,
    ye = te,
    ge = function ge(t) {
      var r = [];
      if (null != t) for (var e in Object(t)) {
        r.push(e);
      }
      return r;
    },
    je = Object.prototype.hasOwnProperty;
  var _e = Qr,
    we = function we(t) {
      if (!he(t)) return ge(t);
      var r = ye(t),
        e = [];
      for (var n in t) {
        ("constructor" != n || !r && je.call(t, n)) && e.push(n);
      }
      return e;
    },
    xe = ce;
  var Oe = function Oe(t) {
      return xe(t) ? _e(t, !0) : we(t);
    },
    $e = br,
    Ae = Oe;
  var me = function me(t, r) {
      return t && $e(r, Ae(r), t);
    },
    ze = {
      exports: {}
    };
  !function (t, r) {
    var e = C,
      n = r && !r.nodeType && r,
      o = n && t && !t.nodeType && t,
      u = o && o.exports === n ? e.Buffer : void 0,
      a = u ? u.allocUnsafe : void 0;
    t.exports = function (t, r) {
      if (r) return t.slice();
      var e = t.length,
        n = a ? a(e) : new t.constructor(e);
      return t.copy(n), n;
    };
  }(ze, ze.exports);
  var Ee = function Ee(t, r) {
    var e = -1,
      n = t.length;
    for (r || (r = Array(n)); ++e < n;) {
      r[e] = t[e];
    }
    return r;
  };
  var Se = function Se() {
      return [];
    },
    Ue = function Ue(t, r) {
      for (var e = -1, n = null == t ? 0 : t.length, o = 0, u = []; ++e < n;) {
        var a = t[e];
        r(a, e, t) && (u[o++] = a);
      }
      return u;
    },
    Ie = Se,
    Ce = Object.prototype.propertyIsEnumerable,
    Pe = Object.getOwnPropertySymbols,
    Te = Pe ? function (t) {
      return null == t ? [] : (t = Object(t), Ue(Pe(t), function (r) {
        return Ce.call(t, r);
      }));
    } : Ie,
    Re = br,
    De = Te;
  var Le = function Le(t, r) {
    return Re(t, De(t), r);
  };
  var ke = function ke(t, r) {
      for (var e = -1, n = r.length, o = t.length; ++e < n;) {
        t[o + e] = r[e];
      }
      return t;
    },
    Fe = re(Object.getPrototypeOf, Object),
    Ve = ke,
    Me = Fe,
    Be = Te,
    Ne = Se,
    Ze = Object.getOwnPropertySymbols ? function (t) {
      for (var r = []; t;) {
        Ve(r, Be(t)), t = Me(t);
      }
      return r;
    } : Ne,
    Ge = br,
    We = Ze;
  var qe = function qe(t, r) {
      return Ge(t, We(t), r);
    },
    He = ke,
    Ye = zr;
  var Je = function Je(t, r, e) {
      var n = r(t);
      return Ye(t) ? n : He(n, e(t));
    },
    Ke = Je,
    Qe = Te,
    Xe = se;
  var tn = function tn(t) {
      return Ke(t, Xe, Qe);
    },
    rn = Je,
    en = Ze,
    nn = Oe;
  var on = function on(t) {
      return rn(t, nn, en);
    },
    un = pt(C, "DataView"),
    an = pt(C, "Promise"),
    cn = pt(C, "Set"),
    fn = un,
    vn = dt,
    ln = an,
    sn = cn,
    pn = pt(C, "WeakMap"),
    dn = Z,
    bn = tt,
    hn = "[object Map]",
    yn = "[object Promise]",
    gn = "[object Set]",
    jn = "[object WeakMap]",
    _n = "[object DataView]",
    wn = bn(fn),
    xn = bn(vn),
    On = bn(ln),
    $n = bn(sn),
    An = bn(pn),
    mn = dn;
  (fn && mn(new fn(new ArrayBuffer(1))) != _n || vn && mn(new vn()) != hn || ln && mn(ln.resolve()) != yn || sn && mn(new sn()) != gn || pn && mn(new pn()) != jn) && (mn = function mn(t) {
    var r = dn(t),
      e = "[object Object]" == r ? t.constructor : void 0,
      n = e ? bn(e) : "";
    if (n) switch (n) {
      case wn:
        return _n;
      case xn:
        return hn;
      case On:
        return yn;
      case $n:
        return gn;
      case An:
        return jn;
    }
    return r;
  });
  var zn = mn,
    En = Object.prototype.hasOwnProperty;
  var Sn = function Sn(t) {
      var r = t.length,
        e = new t.constructor(r);
      return r && "string" == typeof t[0] && En.call(t, "index") && (e.index = t.index, e.input = t.input), e;
    },
    Un = C.Uint8Array,
    In = Un;
  var Cn = function Cn(t) {
      var r = new t.constructor(t.byteLength);
      return new In(r).set(new In(t)), r;
    },
    Pn = Cn;
  var Tn = function Tn(t, r) {
      var e = r ? Pn(t.buffer) : t.buffer;
      return new t.constructor(e, t.byteOffset, t.byteLength);
    },
    Rn = /\w*$/;
  var Dn = function Dn(t) {
      var r = new t.constructor(t.source, Rn.exec(t));
      return r.lastIndex = t.lastIndex, r;
    },
    Ln = P ? P.prototype : void 0,
    kn = Ln ? Ln.valueOf : void 0;
  var Fn = Cn;
  var Vn = Cn,
    Mn = Tn,
    Bn = Dn,
    Nn = function Nn(t) {
      return kn ? Object(kn.call(t)) : {};
    },
    Zn = function Zn(t, r) {
      var e = r ? Fn(t.buffer) : t.buffer;
      return new t.constructor(e, t.byteOffset, t.length);
    };
  var Gn = function Gn(t, r, e) {
      var n = t.constructor;
      switch (r) {
        case "[object ArrayBuffer]":
          return Vn(t);
        case "[object Boolean]":
        case "[object Date]":
          return new n(+t);
        case "[object DataView]":
          return Mn(t, e);
        case "[object Float32Array]":
        case "[object Float64Array]":
        case "[object Int8Array]":
        case "[object Int16Array]":
        case "[object Int32Array]":
        case "[object Uint8Array]":
        case "[object Uint8ClampedArray]":
        case "[object Uint16Array]":
        case "[object Uint32Array]":
          return Zn(t, e);
        case "[object Map]":
        case "[object Set]":
          return new n();
        case "[object Number]":
        case "[object String]":
          return new n(t);
        case "[object RegExp]":
          return Bn(t);
        case "[object Symbol]":
          return Nn(t);
      }
    },
    Wn = G,
    qn = Object.create,
    Hn = function () {
      function t() {}
      return function (r) {
        if (!Wn(r)) return {};
        if (qn) return qn(r);
        t.prototype = r;
        var e = new t();
        return t.prototype = void 0, e;
      };
    }(),
    Yn = Fe,
    Jn = te;
  var Kn = function Kn(t) {
      return "function" != typeof t.constructor || Jn(t) ? {} : Hn(Yn(t));
    },
    Qn = zn,
    Xn = yr;
  var to = function to(t) {
      return Xn(t) && "[object Map]" == Qn(t);
    },
    ro = kr,
    eo = Fr.exports,
    no = eo && eo.isMap,
    oo = no ? ro(no) : to,
    uo = zn,
    ao = yr;
  var io = function io(t) {
      return ao(t) && "[object Set]" == uo(t);
    },
    co = kr,
    fo = Fr.exports,
    vo = fo && fo.isSet,
    lo = vo ? co(vo) : io,
    so = nr,
    po = or,
    bo = sr,
    ho = be,
    yo = me,
    go = ze.exports,
    jo = Ee,
    _o = Le,
    wo = qe,
    xo = tn,
    Oo = on,
    $o = zn,
    Ao = Sn,
    mo = Gn,
    zo = Kn,
    Eo = zr,
    So = Er.exports,
    Uo = oo,
    Io = G,
    Co = lo,
    Po = se,
    To = Oe,
    Ro = "[object Arguments]",
    Do = "[object Function]",
    Lo = "[object Object]",
    ko = {};
  ko[Ro] = ko["[object Array]"] = ko["[object ArrayBuffer]"] = ko["[object DataView]"] = ko["[object Boolean]"] = ko["[object Date]"] = ko["[object Float32Array]"] = ko["[object Float64Array]"] = ko["[object Int8Array]"] = ko["[object Int16Array]"] = ko["[object Int32Array]"] = ko["[object Map]"] = ko["[object Number]"] = ko[Lo] = ko["[object RegExp]"] = ko["[object Set]"] = ko["[object String]"] = ko["[object Symbol]"] = ko["[object Uint8Array]"] = ko["[object Uint8ClampedArray]"] = ko["[object Uint16Array]"] = ko["[object Uint32Array]"] = !0, ko["[object Error]"] = ko[Do] = ko["[object WeakMap]"] = !1;
  var Fo = function t(r, e, n, o, u, a) {
      var i,
        c = 1 & e,
        f = 2 & e,
        v = 4 & e;
      if (n && (i = u ? n(r, o, u, a) : n(r)), void 0 !== i) return i;
      if (!Io(r)) return r;
      var l = Eo(r);
      if (l) {
        if (i = Ao(r), !c) return jo(r, i);
      } else {
        var s = $o(r),
          p = s == Do || "[object GeneratorFunction]" == s;
        if (So(r)) return go(r, c);
        if (s == Lo || s == Ro || p && !u) {
          if (i = f || p ? {} : zo(r), !c) return f ? wo(r, yo(i, r)) : _o(r, ho(i, r));
        } else {
          if (!ko[s]) return u ? r : {};
          i = mo(r, s, c);
        }
      }
      a || (a = new so());
      var d = a.get(r);
      if (d) return d;
      a.set(r, i), Co(r) ? r.forEach(function (o) {
        i.add(t(o, e, n, o, r, a));
      }) : Uo(r) && r.forEach(function (o, u) {
        i.set(u, t(o, e, n, u, r, a));
      });
      var b = l ? void 0 : (v ? f ? Oo : xo : f ? To : Po)(r);
      return po(b || r, function (o, u) {
        b && (o = r[u = o]), bo(i, u, t(o, e, n, u, r, a));
      }), i;
    },
    Vo = Z,
    Mo = yr;
  var Bo = function Bo(t) {
      return "symbol" == _typeof(t) || Mo(t) && "[object Symbol]" == Vo(t);
    },
    No = zr,
    Zo = Bo,
    Go = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,
    Wo = /^\w*$/;
  var qo = function qo(t, r) {
      if (No(t)) return !1;
      var e = _typeof(t);
      return !("number" != e && "symbol" != e && "boolean" != e && null != t && !Zo(t)) || Wo.test(t) || !Go.test(t) || null != r && t in Object(r);
    },
    Ho = Wt;
  function Yo(t, r) {
    if ("function" != typeof t || null != r && "function" != typeof r) throw new TypeError("Expected a function");
    var e = function e() {
      var n = arguments,
        o = r ? r.apply(this, n) : n[0],
        u = e.cache;
      if (u.has(o)) return u.get(o);
      var a = t.apply(this, n);
      return e.cache = u.set(o, a) || u, a;
    };
    return e.cache = new (Yo.Cache || Ho)(), e;
  }
  Yo.Cache = Ho;
  var Jo = Yo;
  var Ko = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g,
    Qo = /\\(\\)?/g,
    Xo = function (t) {
      var r = Jo(t, function (t) {
          return 500 === e.size && e.clear(), t;
        }),
        e = r.cache;
      return r;
    }(function (t) {
      var r = [];
      return 46 === t.charCodeAt(0) && r.push(""), t.replace(Ko, function (t, e, n, o) {
        r.push(n ? o.replace(Qo, "$1") : e || t);
      }), r;
    }),
    tu = i,
    ru = zr,
    eu = Bo,
    nu = P ? P.prototype : void 0,
    ou = nu ? nu.toString : void 0;
  var uu = function t(r) {
      if ("string" == typeof r) return r;
      if (ru(r)) return tu(r, t) + "";
      if (eu(r)) return ou ? ou.call(r) : "";
      var e = r + "";
      return "0" == e && 1 / r == -Infinity ? "-0" : e;
    },
    au = uu;
  var iu = function iu(t) {
      return null == t ? "" : au(t);
    },
    cu = zr,
    fu = qo,
    vu = Xo,
    lu = iu;
  var su = function su(t, r) {
    return cu(t) ? t : fu(t, r) ? [t] : vu(lu(t));
  };
  var pu = Bo;
  var du = function du(t) {
      if ("string" == typeof t || pu(t)) return t;
      var r = t + "";
      return "0" == r && 1 / t == -Infinity ? "-0" : r;
    },
    bu = su,
    hu = du;
  var yu = function yu(t, r) {
    for (var e = 0, n = (r = bu(r, t)).length; null != t && e < n;) {
      t = t[hu(r[e++])];
    }
    return e && e == n ? t : void 0;
  };
  var gu = function gu(t, r, e) {
      var n = -1,
        o = t.length;
      r < 0 && (r = -r > o ? 0 : o + r), (e = e > o ? o : e) < 0 && (e += o), o = r > e ? 0 : e - r >>> 0, r >>>= 0;
      for (var u = Array(o); ++n < o;) {
        u[n] = t[n + r];
      }
      return u;
    },
    ju = yu,
    _u = gu;
  var wu = su,
    xu = function xu(t) {
      var r = null == t ? 0 : t.length;
      return r ? t[r - 1] : void 0;
    },
    Ou = function Ou(t, r) {
      return r.length < 2 ? t : ju(t, _u(r, 0, -1));
    },
    $u = du;
  var Au = function Au(t, r) {
      return r = wu(r, t), null == (t = Ou(t, r)) || delete t[$u(xu(r))];
    },
    mu = Z,
    zu = Fe,
    Eu = yr,
    Su = Function.prototype,
    Uu = Object.prototype,
    Iu = Su.toString,
    Cu = Uu.hasOwnProperty,
    Pu = Iu.call(Object);
  var Tu = function Tu(t) {
    if (!Eu(t) || "[object Object]" != mu(t)) return !1;
    var r = zu(t);
    if (null === r) return !0;
    var e = Cu.call(r, "constructor") && r.constructor;
    return "function" == typeof e && e instanceof e && Iu.call(e) == Pu;
  };
  var Ru = function Ru(t) {
      return Tu(t) ? void 0 : t;
    },
    Du = mr,
    Lu = zr,
    ku = P ? P.isConcatSpreadable : void 0;
  var Fu = ke,
    Vu = function Vu(t) {
      return Lu(t) || Du(t) || !!(ku && t && t[ku]);
    };
  var Mu = function t(r, e, n, o, u) {
      var a = -1,
        i = r.length;
      for (n || (n = Vu), u || (u = []); ++a < i;) {
        var c = r[a];
        e > 0 && n(c) ? e > 1 ? t(c, e - 1, n, o, u) : Fu(u, c) : o || (u[u.length] = c);
      }
      return u;
    },
    Bu = Mu;
  var Nu = function Nu(t) {
    return (null == t ? 0 : t.length) ? Bu(t, 1) : [];
  };
  var Zu = function Zu(t, r, e) {
      switch (e.length) {
        case 0:
          return t.call(r);
        case 1:
          return t.call(r, e[0]);
        case 2:
          return t.call(r, e[0], e[1]);
        case 3:
          return t.call(r, e[0], e[1], e[2]);
      }
      return t.apply(r, e);
    },
    Gu = Math.max;
  var Wu = function Wu(t, r, e) {
    return r = Gu(void 0 === r ? t.length - 1 : r, 0), function () {
      for (var n = arguments, o = -1, u = Gu(n.length - r, 0), a = Array(u); ++o < u;) {
        a[o] = n[r + o];
      }
      o = -1;
      for (var i = Array(r + 1); ++o < r;) {
        i[o] = n[o];
      }
      return i[r] = e(a), Zu(t, this, i);
    };
  };
  var qu = function qu(t) {
      return t;
    },
    Hu = function Hu(t) {
      return function () {
        return t;
      };
    },
    Yu = ar,
    Ju = Yu ? function (t, r) {
      return Yu(t, "toString", {
        configurable: !0,
        enumerable: !1,
        value: Hu(r),
        writable: !0
      });
    } : qu,
    Ku = Date.now;
  var Qu = function Qu(t) {
      var r = 0,
        e = 0;
      return function () {
        var n = Ku(),
          o = 16 - (n - e);
        if (e = n, o > 0) {
          if (++r >= 800) return arguments[0];
        } else r = 0;
        return t.apply(void 0, arguments);
      };
    },
    Xu = Qu(Ju),
    ta = Nu,
    ra = Wu,
    ea = Xu;
  var na = i,
    oa = Fo,
    ua = Au,
    aa = su,
    ia = br,
    ca = Ru,
    fa = on,
    va = function (t) {
      return ea(ra(t, void 0, ta), t + "");
    }(function (t, r) {
      var e = {};
      if (null == t) return e;
      var n = !1;
      r = na(r, function (r) {
        return r = aa(r, t), n || (n = r.length > 1), r;
      }), ia(t, fa(t), e), n && (e = oa(e, 7, ca));
      for (var o = r.length; o--;) {
        ua(e, r[o]);
      }
      return e;
    }),
    la = va,
    sa = yu;
  var pa = function pa(t, r, e) {
    var n = null == t ? void 0 : sa(t, r);
    return void 0 === n ? e : n;
  };
  var da = function (t) {
      return function (r, e, n) {
        for (var o = -1, u = Object(r), a = n(r), i = a.length; i--;) {
          var c = a[t ? i : ++o];
          if (!1 === e(u[c], c, u)) break;
        }
        return r;
      };
    }(),
    ba = se;
  var ha = ce;
  var ya = function (t, r) {
      return function (e, n) {
        if (null == e) return e;
        if (!ha(e)) return t(e, n);
        for (var o = e.length, u = r ? o : -1, a = Object(e); (r ? u-- : ++u < o) && !1 !== n(a[u], u, a);) {
          ;
        }
        return e;
      };
    }(function (t, r) {
      return t && da(t, r, ba);
    }),
    ga = qu;
  var ja = or,
    _a = ya,
    wa = function wa(t) {
      return "function" == typeof t ? t : ga;
    },
    xa = zr;
  var Oa = function Oa(t, r) {
    return (xa(t) ? ja : _a)(t, wa(r));
  };
  var $a = function $a(t, r, e, n) {
    var o = -1,
      u = null == t ? 0 : t.length;
    for (n && u && (e = t[++o]); ++o < u;) {
      e = r(e, t[o], o, t);
    }
    return e;
  };
  var Aa = function (t) {
      return function (r) {
        return null == t ? void 0 : t[r];
      };
    }({
      "À": "A",
      "Á": "A",
      "Â": "A",
      "Ã": "A",
      "Ä": "A",
      "Å": "A",
      "à": "a",
      "á": "a",
      "â": "a",
      "ã": "a",
      "ä": "a",
      "å": "a",
      "Ç": "C",
      "ç": "c",
      "Ð": "D",
      "ð": "d",
      "È": "E",
      "É": "E",
      "Ê": "E",
      "Ë": "E",
      "è": "e",
      "é": "e",
      "ê": "e",
      "ë": "e",
      "Ì": "I",
      "Í": "I",
      "Î": "I",
      "Ï": "I",
      "ì": "i",
      "í": "i",
      "î": "i",
      "ï": "i",
      "Ñ": "N",
      "ñ": "n",
      "Ò": "O",
      "Ó": "O",
      "Ô": "O",
      "Õ": "O",
      "Ö": "O",
      "Ø": "O",
      "ò": "o",
      "ó": "o",
      "ô": "o",
      "õ": "o",
      "ö": "o",
      "ø": "o",
      "Ù": "U",
      "Ú": "U",
      "Û": "U",
      "Ü": "U",
      "ù": "u",
      "ú": "u",
      "û": "u",
      "ü": "u",
      "Ý": "Y",
      "ý": "y",
      "ÿ": "y",
      "Æ": "Ae",
      "æ": "ae",
      "Þ": "Th",
      "þ": "th",
      "ß": "ss",
      "Ā": "A",
      "Ă": "A",
      "Ą": "A",
      "ā": "a",
      "ă": "a",
      "ą": "a",
      "Ć": "C",
      "Ĉ": "C",
      "Ċ": "C",
      "Č": "C",
      "ć": "c",
      "ĉ": "c",
      "ċ": "c",
      "č": "c",
      "Ď": "D",
      "Đ": "D",
      "ď": "d",
      "đ": "d",
      "Ē": "E",
      "Ĕ": "E",
      "Ė": "E",
      "Ę": "E",
      "Ě": "E",
      "ē": "e",
      "ĕ": "e",
      "ė": "e",
      "ę": "e",
      "ě": "e",
      "Ĝ": "G",
      "Ğ": "G",
      "Ġ": "G",
      "Ģ": "G",
      "ĝ": "g",
      "ğ": "g",
      "ġ": "g",
      "ģ": "g",
      "Ĥ": "H",
      "Ħ": "H",
      "ĥ": "h",
      "ħ": "h",
      "Ĩ": "I",
      "Ī": "I",
      "Ĭ": "I",
      "Į": "I",
      "İ": "I",
      "ĩ": "i",
      "ī": "i",
      "ĭ": "i",
      "į": "i",
      "ı": "i",
      "Ĵ": "J",
      "ĵ": "j",
      "Ķ": "K",
      "ķ": "k",
      "ĸ": "k",
      "Ĺ": "L",
      "Ļ": "L",
      "Ľ": "L",
      "Ŀ": "L",
      "Ł": "L",
      "ĺ": "l",
      "ļ": "l",
      "ľ": "l",
      "ŀ": "l",
      "ł": "l",
      "Ń": "N",
      "Ņ": "N",
      "Ň": "N",
      "Ŋ": "N",
      "ń": "n",
      "ņ": "n",
      "ň": "n",
      "ŋ": "n",
      "Ō": "O",
      "Ŏ": "O",
      "Ő": "O",
      "ō": "o",
      "ŏ": "o",
      "ő": "o",
      "Ŕ": "R",
      "Ŗ": "R",
      "Ř": "R",
      "ŕ": "r",
      "ŗ": "r",
      "ř": "r",
      "Ś": "S",
      "Ŝ": "S",
      "Ş": "S",
      "Š": "S",
      "ś": "s",
      "ŝ": "s",
      "ş": "s",
      "š": "s",
      "Ţ": "T",
      "Ť": "T",
      "Ŧ": "T",
      "ţ": "t",
      "ť": "t",
      "ŧ": "t",
      "Ũ": "U",
      "Ū": "U",
      "Ŭ": "U",
      "Ů": "U",
      "Ű": "U",
      "Ų": "U",
      "ũ": "u",
      "ū": "u",
      "ŭ": "u",
      "ů": "u",
      "ű": "u",
      "ų": "u",
      "Ŵ": "W",
      "ŵ": "w",
      "Ŷ": "Y",
      "ŷ": "y",
      "Ÿ": "Y",
      "Ź": "Z",
      "Ż": "Z",
      "Ž": "Z",
      "ź": "z",
      "ż": "z",
      "ž": "z",
      "Ĳ": "IJ",
      "ĳ": "ij",
      "Œ": "Oe",
      "œ": "oe",
      "ŉ": "'n",
      "ſ": "s"
    }),
    ma = iu,
    za = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g,
    Ea = RegExp("[\\u0300-\\u036f\\ufe20-\\ufe2f\\u20d0-\\u20ff]", "g");
  var Sa = function Sa(t) {
      return (t = ma(t)) && t.replace(za, Aa).replace(Ea, "");
    },
    Ua = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g;
  var Ia = function Ia(t) {
      return t.match(Ua) || [];
    },
    Ca = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/;
  var Pa = function Pa(t) {
      return Ca.test(t);
    },
    Ta = "\\u2700-\\u27bf",
    Ra = "a-z\\xdf-\\xf6\\xf8-\\xff",
    Da = "A-Z\\xc0-\\xd6\\xd8-\\xde",
    La = "\\xac\\xb1\\xd7\\xf7\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf\\u2000-\\u206f \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000",
    ka = "[" + La + "]",
    Fa = "\\d+",
    Va = "[\\u2700-\\u27bf]",
    Ma = "[" + Ra + "]",
    Ba = "[^\\ud800-\\udfff" + La + Fa + Ta + Ra + Da + "]",
    Na = "(?:\\ud83c[\\udde6-\\uddff]){2}",
    Za = "[\\ud800-\\udbff][\\udc00-\\udfff]",
    Ga = "[" + Da + "]",
    Wa = "(?:" + Ma + "|" + Ba + ")",
    qa = "(?:" + Ga + "|" + Ba + ")",
    Ha = "(?:['’](?:d|ll|m|re|s|t|ve))?",
    Ya = "(?:['’](?:D|LL|M|RE|S|T|VE))?",
    Ja = "(?:[\\u0300-\\u036f\\ufe20-\\ufe2f\\u20d0-\\u20ff]|\\ud83c[\\udffb-\\udfff])?",
    Ka = "[\\ufe0e\\ufe0f]?",
    Qa = Ka + Ja + ("(?:\\u200d(?:" + ["[^\\ud800-\\udfff]", Na, Za].join("|") + ")" + Ka + Ja + ")*"),
    Xa = "(?:" + [Va, Na, Za].join("|") + ")" + Qa,
    ti = RegExp([Ga + "?" + Ma + "+" + Ha + "(?=" + [ka, Ga, "$"].join("|") + ")", qa + "+" + Ya + "(?=" + [ka, Ga + Wa, "$"].join("|") + ")", Ga + "?" + Wa + "+" + Ha, Ga + "+" + Ya, "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", Fa, Xa].join("|"), "g");
  var ri = Ia,
    ei = Pa,
    ni = iu,
    oi = function oi(t) {
      return t.match(ti) || [];
    };
  var ui = $a,
    ai = Sa,
    ii = function ii(t, r, e) {
      return t = ni(t), void 0 === (r = e ? void 0 : r) ? ei(t) ? oi(t) : ri(t) : t.match(r) || [];
    },
    ci = RegExp("['’]", "g");
  var fi = function fi(t) {
      return function (r) {
        return ui(ii(ai(r).replace(ci, "")), t, "");
      };
    },
    vi = fi(function (t, r, e) {
      return t + (e ? "-" : "") + r.toLowerCase();
    }),
    li = gu;
  var si = function si(t, r, e) {
      var n = t.length;
      return e = void 0 === e ? n : e, !r && e >= n ? t : li(t, r, e);
    },
    pi = RegExp("[\\u200d\\ud800-\\udfff\\u0300-\\u036f\\ufe20-\\ufe2f\\u20d0-\\u20ff\\ufe0e\\ufe0f]");
  var di = function di(t) {
    return pi.test(t);
  };
  var bi = function bi(t) {
      return t.split("");
    },
    hi = "[\\ud800-\\udfff]",
    yi = "[\\u0300-\\u036f\\ufe20-\\ufe2f\\u20d0-\\u20ff]",
    gi = "\\ud83c[\\udffb-\\udfff]",
    ji = "[^\\ud800-\\udfff]",
    _i = "(?:\\ud83c[\\udde6-\\uddff]){2}",
    wi = "[\\ud800-\\udbff][\\udc00-\\udfff]",
    xi = "(?:" + yi + "|" + gi + ")" + "?",
    Oi = "[\\ufe0e\\ufe0f]?",
    $i = Oi + xi + ("(?:\\u200d(?:" + [ji, _i, wi].join("|") + ")" + Oi + xi + ")*"),
    Ai = "(?:" + [ji + yi + "?", yi, _i, wi, hi].join("|") + ")",
    mi = RegExp(gi + "(?=" + gi + ")|" + Ai + $i, "g");
  var zi = bi,
    Ei = di,
    Si = function Si(t) {
      return t.match(mi) || [];
    };
  var Ui = si,
    Ii = di,
    Ci = function Ci(t) {
      return Ei(t) ? Si(t) : zi(t);
    },
    Pi = iu;
  var Ti = function (t) {
      return function (r) {
        r = Pi(r);
        var e = Ii(r) ? Ci(r) : void 0,
          n = e ? e[0] : r.charAt(0),
          o = e ? Ui(e, 1).join("") : r.slice(1);
        return n[t]() + o;
      };
    }("toUpperCase"),
    Ri = iu,
    Di = Ti;
  var Li = function Li(t) {
      return Di(Ri(t).toLowerCase());
    },
    ki = fi(function (t, r, e) {
      return r = r.toLowerCase(), t + (e ? Li(r) : r);
    }),
    Fi = qu,
    Vi = Wu,
    Mi = Xu;
  var Bi = function Bi(t, r) {
    return Mi(Vi(t, r, Fi), t + "");
  };
  var Ni = Wt,
    Zi = function Zi(t) {
      return this.__data__.set(t, "__lodash_hash_undefined__"), this;
    },
    Gi = function Gi(t) {
      return this.__data__.has(t);
    };
  function Wi(t) {
    var r = -1,
      e = null == t ? 0 : t.length;
    for (this.__data__ = new Ni(); ++r < e;) {
      this.add(t[r]);
    }
  }
  Wi.prototype.add = Wi.prototype.push = Zi, Wi.prototype.has = Gi;
  var qi = Wi;
  var Hi = function Hi(t, r, e, n) {
      for (var o = t.length, u = e + (n ? 1 : -1); n ? u-- : ++u < o;) {
        if (r(t[u], u, t)) return u;
      }
      return -1;
    },
    Yi = function Yi(t) {
      return t != t;
    },
    Ji = function Ji(t, r, e) {
      for (var n = e - 1, o = t.length; ++n < o;) {
        if (t[n] === r) return n;
      }
      return -1;
    };
  var Ki = function Ki(t, r, e) {
    return r == r ? Ji(t, r, e) : Hi(t, Yi, e);
  };
  var Qi = function Qi(t, r) {
    return !!(null == t ? 0 : t.length) && Ki(t, r, 0) > -1;
  };
  var Xi = function Xi(t, r, e) {
    for (var n = -1, o = null == t ? 0 : t.length; ++n < o;) {
      if (e(r, t[n])) return !0;
    }
    return !1;
  };
  var tc = function tc(t, r) {
    return t.has(r);
  };
  var rc = function rc(t) {
      var r = -1,
        e = Array(t.size);
      return t.forEach(function (t) {
        e[++r] = t;
      }), e;
    },
    ec = cn,
    nc = function nc() {},
    oc = ec && 1 / rc(new ec([, -0]))[1] == 1 / 0 ? function (t) {
      return new ec(t);
    } : nc,
    uc = qi,
    ac = Qi,
    ic = Xi,
    cc = tc,
    fc = oc,
    vc = rc;
  var lc = function lc(t, r, e) {
      var n = -1,
        o = ac,
        u = t.length,
        a = !0,
        i = [],
        c = i;
      if (e) a = !1, o = ic;else if (u >= 200) {
        var f = r ? null : fc(t);
        if (f) return vc(f);
        a = !1, o = cc, c = new uc();
      } else c = r ? [] : i;
      t: for (; ++n < u;) {
        var v = t[n],
          l = r ? r(v) : v;
        if (v = e || 0 !== v ? v : 0, a && l == l) {
          for (var s = c.length; s--;) {
            if (c[s] === l) continue t;
          }
          r && c.push(l), i.push(v);
        } else o(c, l, e) || (c !== i && c.push(l), i.push(v));
      }
      return i;
    },
    sc = ce,
    pc = yr;
  var dc = Mu,
    bc = lc,
    hc = function hc(t) {
      return pc(t) && sc(t);
    },
    yc = Bi(function (t) {
      return bc(dc(t, 1, hc, !0));
    }),
    gc = lc;
  var jc = function jc(t) {
    return t && t.length ? gc(t) : [];
  };
  var _c = qi,
    wc = function wc(t, r) {
      for (var e = -1, n = null == t ? 0 : t.length; ++e < n;) {
        if (r(t[e], e, t)) return !0;
      }
      return !1;
    },
    xc = tc;
  var Oc = function Oc(t, r, e, n, o, u) {
    var a = 1 & e,
      i = t.length,
      c = r.length;
    if (i != c && !(a && c > i)) return !1;
    var f = u.get(t),
      v = u.get(r);
    if (f && v) return f == r && v == t;
    var l = -1,
      s = !0,
      p = 2 & e ? new _c() : void 0;
    for (u.set(t, r), u.set(r, t); ++l < i;) {
      var d = t[l],
        b = r[l];
      if (n) var h = a ? n(b, d, l, r, t, u) : n(d, b, l, t, r, u);
      if (void 0 !== h) {
        if (h) continue;
        s = !1;
        break;
      }
      if (p) {
        if (!wc(r, function (t, r) {
          if (!xc(p, r) && (d === t || o(d, t, e, n, u))) return p.push(r);
        })) {
          s = !1;
          break;
        }
      } else if (d !== b && !o(d, b, e, n, u)) {
        s = !1;
        break;
      }
    }
    return u.delete(t), u.delete(r), s;
  };
  var $c = Un,
    Ac = f,
    mc = Oc,
    zc = function zc(t) {
      var r = -1,
        e = Array(t.size);
      return t.forEach(function (t, n) {
        e[++r] = [n, t];
      }), e;
    },
    Ec = rc,
    Sc = P ? P.prototype : void 0,
    Uc = Sc ? Sc.valueOf : void 0;
  var Ic = function Ic(t, r, e, n, o, u, a) {
      switch (e) {
        case "[object DataView]":
          if (t.byteLength != r.byteLength || t.byteOffset != r.byteOffset) return !1;
          t = t.buffer, r = r.buffer;
        case "[object ArrayBuffer]":
          return !(t.byteLength != r.byteLength || !u(new $c(t), new $c(r)));
        case "[object Boolean]":
        case "[object Date]":
        case "[object Number]":
          return Ac(+t, +r);
        case "[object Error]":
          return t.name == r.name && t.message == r.message;
        case "[object RegExp]":
        case "[object String]":
          return t == r + "";
        case "[object Map]":
          var i = zc;
        case "[object Set]":
          var c = 1 & n;
          if (i || (i = Ec), t.size != r.size && !c) return !1;
          var f = a.get(t);
          if (f) return f == r;
          n |= 2, a.set(t, r);
          var v = mc(i(t), i(r), n, o, u, a);
          return a.delete(t), v;
        case "[object Symbol]":
          if (Uc) return Uc.call(t) == Uc.call(r);
      }
      return !1;
    },
    Cc = tn,
    Pc = Object.prototype.hasOwnProperty;
  var Tc = nr,
    Rc = Oc,
    Dc = Ic,
    Lc = function Lc(t, r, e, n, o, u) {
      var a = 1 & e,
        i = Cc(t),
        c = i.length;
      if (c != Cc(r).length && !a) return !1;
      for (var f = c; f--;) {
        var v = i[f];
        if (!(a ? v in r : Pc.call(r, v))) return !1;
      }
      var l = u.get(t),
        s = u.get(r);
      if (l && s) return l == r && s == t;
      var p = !0;
      u.set(t, r), u.set(r, t);
      for (var d = a; ++f < c;) {
        var b = t[v = i[f]],
          h = r[v];
        if (n) var y = a ? n(h, b, v, r, t, u) : n(b, h, v, t, r, u);
        if (!(void 0 === y ? b === h || o(b, h, e, n, u) : y)) {
          p = !1;
          break;
        }
        d || (d = "constructor" == v);
      }
      if (p && !d) {
        var g = t.constructor,
          j = r.constructor;
        g == j || !("constructor" in t) || !("constructor" in r) || "function" == typeof g && g instanceof g && "function" == typeof j && j instanceof j || (p = !1);
      }
      return u.delete(t), u.delete(r), p;
    },
    kc = zn,
    Fc = zr,
    Vc = Er.exports,
    Mc = Zr,
    Bc = "[object Arguments]",
    Nc = "[object Array]",
    Zc = "[object Object]",
    Gc = Object.prototype.hasOwnProperty;
  var Wc = function Wc(t, r, e, n, o, u) {
      var a = Fc(t),
        i = Fc(r),
        c = a ? Nc : kc(t),
        f = i ? Nc : kc(r),
        v = (c = c == Bc ? Zc : c) == Zc,
        l = (f = f == Bc ? Zc : f) == Zc,
        s = c == f;
      if (s && Vc(t)) {
        if (!Vc(r)) return !1;
        a = !0, v = !1;
      }
      if (s && !v) return u || (u = new Tc()), a || Mc(t) ? Rc(t, r, e, n, o, u) : Dc(t, r, c, e, n, o, u);
      if (!(1 & e)) {
        var p = v && Gc.call(t, "__wrapped__"),
          d = l && Gc.call(r, "__wrapped__");
        if (p || d) {
          var b = p ? t.value() : t,
            h = d ? r.value() : r;
          return u || (u = new Tc()), o(b, h, e, n, u);
        }
      }
      return !!s && (u || (u = new Tc()), Lc(t, r, e, n, o, u));
    },
    qc = yr;
  var Hc = function t(r, e, n, o, u) {
      return r === e || (null == r || null == e || !qc(r) && !qc(e) ? r != r && e != e : Wc(r, e, n, o, t, u));
    },
    Yc = nr,
    Jc = Hc;
  var Kc = G;
  var Qc = function Qc(t) {
      return t == t && !Kc(t);
    },
    Xc = Qc,
    tf = se;
  var rf = function rf(t, r) {
      return function (e) {
        return null != e && e[t] === r && (void 0 !== r || t in Object(e));
      };
    },
    ef = function ef(t, r, e, n) {
      var o = e.length,
        u = o,
        a = !n;
      if (null == t) return !u;
      for (t = Object(t); o--;) {
        var i = e[o];
        if (a && i[2] ? i[1] !== t[i[0]] : !(i[0] in t)) return !1;
      }
      for (; ++o < u;) {
        var c = (i = e[o])[0],
          f = t[c],
          v = i[1];
        if (a && i[2]) {
          if (void 0 === f && !(c in t)) return !1;
        } else {
          var l = new Yc();
          if (n) var s = n(f, v, c, t, r, l);
          if (!(void 0 === s ? Jc(v, f, 3, n, l) : s)) return !1;
        }
      }
      return !0;
    },
    nf = function nf(t) {
      for (var r = tf(t), e = r.length; e--;) {
        var n = r[e],
          o = t[n];
        r[e] = [n, o, Xc(o)];
      }
      return r;
    },
    of = rf;
  var uf = su,
    af = mr,
    cf = zr,
    ff = Ir,
    vf = Cr,
    lf = du;
  var sf = function sf(t, r) {
      return null != t && r in Object(t);
    },
    pf = function pf(t, r, e) {
      for (var n = -1, o = (r = uf(r, t)).length, u = !1; ++n < o;) {
        var a = lf(r[n]);
        if (!(u = null != t && e(t, a))) break;
        t = t[a];
      }
      return u || ++n != o ? u : !!(o = null == t ? 0 : t.length) && vf(o) && ff(a, o) && (cf(t) || af(t));
    };
  var df = Hc,
    bf = pa,
    hf = function hf(t, r) {
      return null != t && pf(t, r, sf);
    },
    yf = qo,
    gf = Qc,
    jf = rf,
    _f = du;
  var wf = yu;
  var xf = function xf(t) {
      return function (r) {
        return null == r ? void 0 : r[t];
      };
    },
    Of = function Of(t) {
      return function (r) {
        return wf(r, t);
      };
    },
    $f = qo,
    Af = du;
  var mf = function mf(t) {
      var r = nf(t);
      return 1 == r.length && r[0][2] ? of(r[0][0], r[0][1]) : function (e) {
        return e === t || ef(e, t, r);
      };
    },
    zf = function zf(t, r) {
      return yf(t) && gf(r) ? jf(_f(t), r) : function (e) {
        var n = bf(e, t);
        return void 0 === n && n === r ? hf(e, t) : df(r, n, 3);
      };
    },
    Ef = qu,
    Sf = zr,
    Uf = function Uf(t) {
      return $f(t) ? xf(Af(t)) : Of(t);
    };
  var If = ya,
    Cf = ce;
  var Pf = Bo;
  var Tf = function Tf(t, r) {
    if (t !== r) {
      var e = void 0 !== t,
        n = null === t,
        o = t == t,
        u = Pf(t),
        a = void 0 !== r,
        i = null === r,
        c = r == r,
        f = Pf(r);
      if (!i && !f && !u && t > r || u && a && c && !i && !f || n && a && c || !e && c || !o) return 1;
      if (!n && !u && !f && t < r || f && e && o && !n && !u || i && e && o || !a && o || !c) return -1;
    }
    return 0;
  };
  var Rf = i,
    Df = yu,
    Lf = function Lf(t) {
      return "function" == typeof t ? t : null == t ? Ef : "object" == _typeof(t) ? Sf(t) ? zf(t[0], t[1]) : mf(t) : Uf(t);
    },
    kf = function kf(t, r) {
      var e = -1,
        n = Cf(t) ? Array(t.length) : [];
      return If(t, function (t, o, u) {
        n[++e] = r(t, o, u);
      }), n;
    },
    Ff = function Ff(t, r) {
      var e = t.length;
      for (t.sort(r); e--;) {
        t[e] = t[e].value;
      }
      return t;
    },
    Vf = kr,
    Mf = function Mf(t, r, e) {
      for (var n = -1, o = t.criteria, u = r.criteria, a = o.length, i = e.length; ++n < a;) {
        var c = Tf(o[n], u[n]);
        if (c) return n >= i ? c : c * ("desc" == e[n] ? -1 : 1);
      }
      return t.index - r.index;
    },
    Bf = qu,
    Nf = zr;
  var Zf = f,
    Gf = ce,
    Wf = Ir,
    qf = G;
  var Hf = Mu,
    Yf = function Yf(t, r, e) {
      r = r.length ? Rf(r, function (t) {
        return Nf(t) ? function (r) {
          return Df(r, 1 === t.length ? t[0] : t);
        } : t;
      }) : [Bf];
      var n = -1;
      r = Rf(r, Vf(Lf));
      var o = kf(t, function (t, e, o) {
        return {
          criteria: Rf(r, function (r) {
            return r(t);
          }),
          index: ++n,
          value: t
        };
      });
      return Ff(o, function (t, r) {
        return Mf(t, r, e);
      });
    },
    Jf = function Jf(t, r, e) {
      if (!qf(e)) return !1;
      var n = _typeof(r);
      return !!("number" == n ? Gf(e) && Wf(r, e.length) : "string" == n && r in e) && Zf(e[r], t);
    },
    Kf = Bi(function (t, r) {
      if (null == t) return [];
      var e = r.length;
      return e > 1 && Jf(t, r[0], r[1]) ? r = [] : e > 2 && Jf(r[0], r[1], r[2]) && (r = [r[0]]), Yf(t, Hf(r, 1), []);
    });
  function Qf(t, r) {
    var e = t.$root.$$phase;
    "$apply" == e || "$digest" == e ? r() : t.$apply(r);
  }
  var Xf = [function () {
    return {
      restrict: "A",
      terminal: !0,
      priority: 1001,
      link: function link(o, u, a) {
        var _e$default$prototype, _e$default$prototype$;
        var i = function (r) {
            var _r$ngVueExpose;
            var e = /^&([a-z$_][a-z0-9$_]*)$/i,
              n = ((_r$ngVueExpose = r.ngVueExpose) !== null && _r$ngVueExpose !== void 0 ? _r$ngVueExpose : "").split(",").map(function (t) {
                return t.trim();
              }).filter(function (t) {
                return e.test(t);
              }).map(function (t) {
                return t.replace(e, "$1");
              }),
              o = /^(?:v-on:|@)[a-z-]+(:[a-z0-9-]+)?(\.[a-z0-9-]+)*/i,
              u = /^([a-z_$][a-z0-9_$]*)(?:\(\))?$/i,
              a = t(r);
            return Oa(a, function (t, r) {
              o.test(r) && u.test(t) && n.push(t.replace(u, "$1"));
            }), n;
          }(a),
          c = function (r) {
            var _r$ngVueExpose2;
            var e = /^(?:v-model|v-html|v-text|v-show|v-class|v-attr|v-style|v-if)(?:\.[a-z0-9]+)*$/i,
              o = /^(?:v-bind)?:[a-z-]+(\.[a-z]+)*$/i,
              u = /^[a-z$_][a-z0-9$_]*(\.[a-z$_][a-z0-9$_]*)*$/i,
              a = ((_r$ngVueExpose2 = r.ngVueExpose) !== null && _r$ngVueExpose2 !== void 0 ? _r$ngVueExpose2 : "").split(",").map(function (t) {
                return t.trim();
              }).filter(function (t) {
                return u.test(t);
              }),
              i = t(r);
            Oa(i, function (t, r) {
              (o.test(r) || e.test(r)) && u.test(t) && a.push(t);
            });
            var c = _toConsumableArray(a);
            return a.forEach(function (t) {
              c = yc(c, n.parents(t));
            }), Kf(jc(c));
          }(a),
          f = function (r) {
            var e = /^(?:v-model)$/i,
              n = /^(?:v-bind)?:([a-z-]+)\.sync*$/i,
              o = /^[a-z$_][a-z0-9$_]*(\.[a-z$_][a-z0-9$_]*)*$/i,
              u = {},
              a = t(r);
            return Oa(a, function (t, r) {
              if (e.test(r)) {
                var _r2 = "value";
                if (!o.test(t)) throw Error("Unsupported v-model binding value: ".concat(t));
                u[_r2] = t;
              }
              if (n.test(r)) {
                var _e2 = r.replace(n, "$1").replace(/-[a-z]/g, function (t) {
                  return t[1].toUpperCase();
                }).replace(/^[A-Z]/, function (t) {
                  return t[1].toLowerCase();
                });
                if (!o.test(t)) throw Error("Unsupported v-bind:".concat(_e2, ".sync binding value: ").concat(t));
                u[_e2] = t;
              }
            }), u;
          }(a);
        c.forEach(function (t) {
          return r(o, t);
        }), i.forEach(function (t) {
          return r(o, t);
        });
        var v = {},
          l = {};
        c.filter(n.isRoot).forEach(function (t) {
          v[t] = o.$eval(t);
        });
        var s = {};
        a.ngVue && (s = o.$eval(a.ngVue) || {}), s = la(s, "props", "data", "computed", "methods", "watch"), i.forEach(function (t) {
          l[t] = function () {
            for (var _len = arguments.length, r = new Array(_len), _key = 0; _key < _len; _key++) {
              r[_key] = arguments[_key];
            }
            console.debug("ng(vue): Calling ng delegate: ".concat(t, "()")), Qf(o, function () {
              return o.$eval(t).apply(o, r);
            });
          };
        });
        var p = function (t) {
            var _r3;
            var r = t,
              e = (_r3 = r) === null || _r3 === void 0 ? void 0 : _r3.$component;
            for (; !e && r;) {
              var _r4;
              r = r.parentElement, e = (_r4 = r) === null || _r4 === void 0 ? void 0 : _r4.$component;
            }
            return e;
          }(u) || ((_e$default$prototype = e.default.prototype) === null || _e$default$prototype === void 0 ? void 0 : (_e$default$prototype$ = _e$default$prototype.$ngVue) === null || _e$default$prototype$ === void 0 ? void 0 : _e$default$prototype$.vueApp) || void 0,
          d = new e.default(_objectSpread(_objectSpread({
            parent: p
          }, s), {}, {
            data: v,
            methods: l
          })).$mount(u[0]);
        d.$el.$component = d, o.$on("$destroy", function () {
          console.debug("ng(vue): destroying vue-comp", d), d.$destroy();
        }), c.forEach(function (t) {
          var r = t;
          o.$watch(t, function (o) {
            console.debug("ng(vue): ng(".concat(t, ") => vue(").concat(r, ") ="), o);
            var u = d,
              a = r;
            n.isRoot(a) || (u = pa(d, n.parent(a)), a = n.leaf(a)), e.default.set(u, a, o);
          });
        }), Oa(f, function (t, r) {
          d.$children.forEach(function (e) {
            return e.$on("update:".concat(ki(r)), function (e) {
              console.debug("ng(vue): vue(".concat(r, ") => ng(").concat(t, ") ="), e), Qf(o, function () {
                return pa(o, t, e);
              });
            });
          }), d.$children.forEach(function (e) {
            return e.$on("update:".concat(vi(r)), function (e) {
              console.warn("$emit event using camelCase (update:".concat(ki(r), "). instead of kebabCase (update:").concat(vi(r), ").")), console.debug("ng(vue): vue(".concat(r, ") => ng(").concat(t, ") ="), e), Qf(o, function () {
                return pa(o, t, e);
              });
            });
          });
        });
      }
    };
    function t(t) {
      var r = {};
      return Oa(t.$attr, function (e, n) {
        var o = t[n];
        r[e] = o;
      }), r;
    }
    function r(t, r) {
      if (void 0 === t.$eval(r)) throw Error("\"".concat(r, "\" is not defined on parent scope"));
    }
  }];
  return Xf;
});
//# sourceMappingURL=ng-vue.min.js.map
