function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _wrapRegExp() { _wrapRegExp = function _wrapRegExp(re, groups) { return new BabelRegExp(re, void 0, groups); }; var _super = RegExp.prototype, _groups = new WeakMap(); function BabelRegExp(re, flags, groups) { var _this = new RegExp(re, flags); return _groups.set(_this, groups || _groups.get(re)), _setPrototypeOf(_this, BabelRegExp.prototype); } function buildGroups(result, re) { var g = _groups.get(re); return Object.keys(g).reduce(function (groups, name) { var i = g[name]; if ("number" == typeof i) groups[name] = result[i];else { for (var k = 0; void 0 === result[i[k]] && k + 1 < i.length;) { k++; } groups[name] = result[i[k]]; } return groups; }, Object.create(null)); } return _inherits(BabelRegExp, RegExp), BabelRegExp.prototype.exec = function (str) { var result = _super.exec.call(this, str); return result && (result.groups = buildGroups(result, this)), result; }, BabelRegExp.prototype[Symbol.replace] = function (str, substitution) { if ("string" == typeof substitution) { var groups = _groups.get(this); return _super[Symbol.replace].call(this, str, substitution.replace(/\$<([^>]+)>/g, function (_, name) { return "$" + groups[name]; })); } if ("function" == typeof substitution) { var _this = this; return _super[Symbol.replace].call(this, str, function () { var args = arguments; return "object" != _typeof(args[args.length - 1]) && (args = [].slice.call(args)).push(buildGroups(args, _this)), substitution.apply(this, args); }); } return _super[Symbol.replace].call(this, str, substitution); }, _wrapRegExp.apply(this, arguments); }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
var camelCase = _.camelCase;
var ngVue2 = [function () {
  return {
    restrict: 'A',
    terminal: true,
    // any directive with lower priority will be ignored
    priority: 1001,
    // 1 more than ngNonBindable => disable angular interpolation!
    link: function link($scope, _ref, attr) {
      var _ref2 = _slicedToArray(_ref, 1),
        element = _ref2[0];
      patchVModel(element, attr);
      var options = $scope.$eval(attr.ngVue || "{}");
      var data = {};
      var computed = {};
      var methods = {};
      var managedProps = parseAttributes(attr);
      managedProps.filter(function (_ref3) {
        var type = _ref3.type;
        return type == 'bind';
      }).forEach(function (_ref4) {
        var rawAttribute = _ref4.rawAttribute,
          name = _ref4.name,
          expression = _ref4.expression,
          modifiers = _ref4.modifiers;
        var dataName = "ngVueDataWrapper_".concat(name);
        data[dataName] = $scope.$eval(expression);
        computed[name] = {
          get: function get() {
            return data[dataName];
          }
        };
        if (modifiers.includes('sync')) {
          computed[name].set = function (v) {
            if ($scope.$eval(expression) === v) return;
            $scope.$apply(function () {
              console.debug("vue(".concat(name, ") => ng(").concat(expression, "):"), v);
              $scope.$eval("".concat(expression, " = $event"), {
                $event: v
              });
            });
          };
        }
        $scope.$watch(expression, function (v) {
          if (data[dataName] === v) return;
          console.debug("ng(".concat(expression, ") => vue(").concat(name, "): "), v);
          data[dataName] = v;
        });
        element.attributes[rawAttribute].value = dataName;
      });
      managedProps.filter(function (_ref5) {
        var type = _ref5.type;
        return type == 'event';
      }).forEach(function (_ref6) {
        var rawAttribute = _ref6.rawAttribute,
          name = _ref6.name,
          expression = _ref6.expression;
        var methodName = "ngVueDelegateWrapper_".concat(camelCase(name));
        methods[methodName] = function ($event) {
          $scope.$apply(function () {
            console.debug("vue(".concat(name, ") calling ng(").concat(expression, "):"), $event);
            $scope.$eval(expression, {
              $event: $event
            });
          });
        };
        element.attributes[rawAttribute].value = "".concat(methodName, "($event)");
      });
      console.debug(element.outerHTML);
      var vm = new Vue(_objectSpread(_objectSpread({}, options), {}, {
        data: data,
        computed: computed,
        methods: methods
      }));
      $scope.$on("$destroy", function () {
        vm.$destroy();
      });
      vm.$mount(element);
      managedProps.filter(function (_ref7) {
        var type = _ref7.type,
          modifiers = _ref7.modifiers;
        return type == 'bind' && modifiers.includes('sync');
      }).forEach(function (_ref8) {
        var name = _ref8.name,
          expression = _ref8.expression,
          updateEvent = _ref8.updateEvent;
        vm.$children.forEach(function (c) {
          c.$on("update:".concat(name), function (v) {
            $scope.$apply(function () {
              console.debug("vue(".concat(updateEvent, ") => ng(").concat(expression, ") ="), v);
              $scope.$eval("".concat(expression, " = $event"), {
                $event: v
              });
            });
          });
        });
      });
    }
  };
}];
var vBindRE = /*#__PURE__*/_wrapRegExp(/^(?:v\x2Dbind:|:)([a-z0-9-]+)((\.[a-z]+)*)$/i, {
  name: 1,
  modifiers: 2
});
var vOnRE = /*#__PURE__*/_wrapRegExp(/^(?:v\x2Don:|@)([a-z0-9-]+(?::[a-z0-9-]+)*)((\.[a-z]+)*)$/i, {
  name: 1,
  modifiers: 2
});
var vDirectivesRE = /*#__PURE__*/_wrapRegExp(/^(v\x2Dmodel|v\x2Dhtml|v\x2Dtext|v\x2Dshow|v\x2Dclass|v\x2Dattr|v\x2Dstyle|v\x2Dif)((\.[a-z]+)*)$/i, {
  name: 1,
  modifiers: 2
});
function patchVModel(element, attr) {
  // replace v-model="myNgVal" with :value="myNgVal" & @input="myNgVal=$event.target.value"

  var vModelAttrKey = Object.keys(attr).find(function (key) {
    return /^vModel\.?/.test(key);
  });
  if (!vModelAttrKey) return;
  var expression = attr[vModelAttrKey];
  var rawAttr = attr.$attr[vModelAttrKey];
  var modifiers = rawAttr.replace(/^v-model/i, '');
  delete attr[vModelAttrKey];
  delete attr.$attr[vModelAttrKey];
  element.removeAttributeNode(element.attributes[rawAttr]);
  attr.value = expression;
  attr.$attr.value = "v-bind:value".concat(modifiers);
  attr.input = "".concat(expression, " = ($event.target ? $event.target.value : $event)");
  attr.$attr.input = 'v-on:input';
  element.setAttribute(attr.$attr.value, attr.value);
  element.setAttribute(attr.$attr.input, attr.input);
}
function parseAttributes(attr) {
  var results = Object.keys(attr).map(function (ngAttrName) {
    var rawAttribute = attr.$attr[ngAttrName];
    var expression = attr[ngAttrName];
    if (vBindRE.test(rawAttribute)) {
      var _rawAttribute$match = rawAttribute.match(vBindRE),
        groups = _rawAttribute$match.groups;
      var name = camelCase(groups.name);
      var modifiers = (groups.modifiers || '').split('.').filter(function (o) {
        return o;
      });
      var type = 'bind';
      return {
        type: type,
        rawAttribute: rawAttribute,
        name: name,
        expression: expression,
        modifiers: modifiers
      };
    }
    if (vDirectivesRE.test(rawAttribute)) {
      var _rawAttribute$match2 = rawAttribute.match(vDirectivesRE),
        _groups2 = _rawAttribute$match2.groups;
      var _name = camelCase(_groups2.name);
      var _modifiers = (_groups2.modifiers || '').split('.').filter(function (o) {
        return o;
      });
      var _type = 'bind';
      return {
        type: _type,
        rawAttribute: rawAttribute,
        name: _name,
        expression: expression,
        modifiers: _modifiers
      };
    }
    if (vOnRE.test(rawAttribute)) {
      var _rawAttribute$match3 = rawAttribute.match(vOnRE),
        _groups3 = _rawAttribute$match3.groups;
      var _name2 = _groups3.name.split(':').map(function (p) {
        return camelCase(p);
      }).join(':');
      var _modifiers2 = (_groups3.modifiers || '').split('.').filter(function (o) {
        return o;
      });
      var _type2 = 'event';
      return {
        type: _type2,
        rawAttribute: rawAttribute,
        name: _name2,
        expression: expression,
        modifiers: _modifiers2
      };
    }
  });
  return results.filter(function (o) {
    return !!o;
  });
}
export { ngVue2 as default };
//# sourceMappingURL=ng-vue2.mjs.map
