function _wrapRegExp() { _wrapRegExp = function _wrapRegExp(re, groups) { return new BabelRegExp(re, void 0, groups); }; var _super = RegExp.prototype, _groups = new WeakMap(); function BabelRegExp(re, flags, groups) { var _this = new RegExp(re, flags); return _groups.set(_this, groups || _groups.get(re)), _setPrototypeOf(_this, BabelRegExp.prototype); } function buildGroups(result, re) { var g = _groups.get(re); return Object.keys(g).reduce(function (groups, name) { var i = g[name]; if ("number" == typeof i) groups[name] = result[i];else { for (var k = 0; void 0 === result[i[k]] && k + 1 < i.length;) { k++; } groups[name] = result[i[k]]; } return groups; }, Object.create(null)); } return _inherits(BabelRegExp, RegExp), BabelRegExp.prototype.exec = function (str) { var result = _super.exec.call(this, str); return result && (result.groups = buildGroups(result, this)), result; }, BabelRegExp.prototype[Symbol.replace] = function (str, substitution) { if ("string" == typeof substitution) { var groups = _groups.get(this); return _super[Symbol.replace].call(this, str, substitution.replace(/\$<([^>]+)>/g, function (_, name) { return "$" + groups[name]; })); } if ("function" == typeof substitution) { var _this = this; return _super[Symbol.replace].call(this, str, function () { var args = arguments; return "object" != _typeof(args[args.length - 1]) && (args = [].slice.call(args)).push(buildGroups(args, _this)), substitution.apply(this, args); }); } return _super[Symbol.replace].call(this, str, substitution); }, _wrapRegExp.apply(this, arguments); }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ _regeneratorRuntime = function _regeneratorRuntime() { return exports; }; var exports = {}, Op = Object.prototype, hasOwn = Op.hasOwnProperty, defineProperty = Object.defineProperty || function (obj, key, desc) { obj[key] = desc.value; }, $Symbol = "function" == typeof Symbol ? Symbol : {}, iteratorSymbol = $Symbol.iterator || "@@iterator", asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator", toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag"; function define(obj, key, value) { return Object.defineProperty(obj, key, { value: value, enumerable: !0, configurable: !0, writable: !0 }), obj[key]; } try { define({}, ""); } catch (err) { define = function define(obj, key, value) { return obj[key] = value; }; } function wrap(innerFn, outerFn, self, tryLocsList) { var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator, generator = Object.create(protoGenerator.prototype), context = new Context(tryLocsList || []); return defineProperty(generator, "_invoke", { value: makeInvokeMethod(innerFn, self, context) }), generator; } function tryCatch(fn, obj, arg) { try { return { type: "normal", arg: fn.call(obj, arg) }; } catch (err) { return { type: "throw", arg: err }; } } exports.wrap = wrap; var ContinueSentinel = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var IteratorPrototype = {}; define(IteratorPrototype, iteratorSymbol, function () { return this; }); var getProto = Object.getPrototypeOf, NativeIteratorPrototype = getProto && getProto(getProto(values([]))); NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype); var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype); function defineIteratorMethods(prototype) { ["next", "throw", "return"].forEach(function (method) { define(prototype, method, function (arg) { return this._invoke(method, arg); }); }); } function AsyncIterator(generator, PromiseImpl) { function invoke(method, arg, resolve, reject) { var record = tryCatch(generator[method], generator, arg); if ("throw" !== record.type) { var result = record.arg, value = result.value; return value && "object" == _typeof(value) && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function (value) { invoke("next", value, resolve, reject); }, function (err) { invoke("throw", err, resolve, reject); }) : PromiseImpl.resolve(value).then(function (unwrapped) { result.value = unwrapped, resolve(result); }, function (error) { return invoke("throw", error, resolve, reject); }); } reject(record.arg); } var previousPromise; defineProperty(this, "_invoke", { value: function value(method, arg) { function callInvokeWithMethodAndArg() { return new PromiseImpl(function (resolve, reject) { invoke(method, arg, resolve, reject); }); } return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(innerFn, self, context) { var state = "suspendedStart"; return function (method, arg) { if ("executing" === state) throw new Error("Generator is already running"); if ("completed" === state) { if ("throw" === method) throw arg; return doneResult(); } for (context.method = method, context.arg = arg;;) { var delegate = context.delegate; if (delegate) { var delegateResult = maybeInvokeDelegate(delegate, context); if (delegateResult) { if (delegateResult === ContinueSentinel) continue; return delegateResult; } } if ("next" === context.method) context.sent = context._sent = context.arg;else if ("throw" === context.method) { if ("suspendedStart" === state) throw state = "completed", context.arg; context.dispatchException(context.arg); } else "return" === context.method && context.abrupt("return", context.arg); state = "executing"; var record = tryCatch(innerFn, self, context); if ("normal" === record.type) { if (state = context.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel) continue; return { value: record.arg, done: context.done }; } "throw" === record.type && (state = "completed", context.method = "throw", context.arg = record.arg); } }; } function maybeInvokeDelegate(delegate, context) { var method = delegate.iterator[context.method]; if (undefined === method) { if (context.delegate = null, "throw" === context.method) { if (delegate.iterator.return && (context.method = "return", context.arg = undefined, maybeInvokeDelegate(delegate, context), "throw" === context.method)) return ContinueSentinel; context.method = "throw", context.arg = new TypeError("The iterator does not provide a 'throw' method"); } return ContinueSentinel; } var record = tryCatch(method, delegate.iterator, context.arg); if ("throw" === record.type) return context.method = "throw", context.arg = record.arg, context.delegate = null, ContinueSentinel; var info = record.arg; return info ? info.done ? (context[delegate.resultName] = info.value, context.next = delegate.nextLoc, "return" !== context.method && (context.method = "next", context.arg = undefined), context.delegate = null, ContinueSentinel) : info : (context.method = "throw", context.arg = new TypeError("iterator result is not an object"), context.delegate = null, ContinueSentinel); } function pushTryEntry(locs) { var entry = { tryLoc: locs[0] }; 1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry); } function resetTryEntry(entry) { var record = entry.completion || {}; record.type = "normal", delete record.arg, entry.completion = record; } function Context(tryLocsList) { this.tryEntries = [{ tryLoc: "root" }], tryLocsList.forEach(pushTryEntry, this), this.reset(!0); } function values(iterable) { if (iterable) { var iteratorMethod = iterable[iteratorSymbol]; if (iteratorMethod) return iteratorMethod.call(iterable); if ("function" == typeof iterable.next) return iterable; if (!isNaN(iterable.length)) { var i = -1, next = function next() { for (; ++i < iterable.length;) { if (hasOwn.call(iterable, i)) return next.value = iterable[i], next.done = !1, next; } return next.value = undefined, next.done = !0, next; }; return next.next = next; } } return { next: doneResult }; } function doneResult() { return { value: undefined, done: !0 }; } return GeneratorFunction.prototype = GeneratorFunctionPrototype, defineProperty(Gp, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), defineProperty(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports.isGeneratorFunction = function (genFun) { var ctor = "function" == typeof genFun && genFun.constructor; return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name)); }, exports.mark = function (genFun) { return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun; }, exports.awrap = function (arg) { return { __await: arg }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, asyncIteratorSymbol, function () { return this; }), exports.AsyncIterator = AsyncIterator, exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) { void 0 === PromiseImpl && (PromiseImpl = Promise); var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl); return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) { return result.done ? result.value : iter.next(); }); }, defineIteratorMethods(Gp), define(Gp, toStringTagSymbol, "Generator"), define(Gp, iteratorSymbol, function () { return this; }), define(Gp, "toString", function () { return "[object Generator]"; }), exports.keys = function (val) { var object = Object(val), keys = []; for (var key in object) { keys.push(key); } return keys.reverse(), function next() { for (; keys.length;) { var key = keys.pop(); if (key in object) return next.value = key, next.done = !1, next; } return next.done = !0, next; }; }, exports.values = values, Context.prototype = { constructor: Context, reset: function reset(skipTempReset) { if (this.prev = 0, this.next = 0, this.sent = this._sent = undefined, this.done = !1, this.delegate = null, this.method = "next", this.arg = undefined, this.tryEntries.forEach(resetTryEntry), !skipTempReset) for (var name in this) { "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = undefined); } }, stop: function stop() { this.done = !0; var rootRecord = this.tryEntries[0].completion; if ("throw" === rootRecord.type) throw rootRecord.arg; return this.rval; }, dispatchException: function dispatchException(exception) { if (this.done) throw exception; var context = this; function handle(loc, caught) { return record.type = "throw", record.arg = exception, context.next = loc, caught && (context.method = "next", context.arg = undefined), !!caught; } for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i], record = entry.completion; if ("root" === entry.tryLoc) return handle("end"); if (entry.tryLoc <= this.prev) { var hasCatch = hasOwn.call(entry, "catchLoc"), hasFinally = hasOwn.call(entry, "finallyLoc"); if (hasCatch && hasFinally) { if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0); if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc); } else if (hasCatch) { if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0); } else { if (!hasFinally) throw new Error("try statement without catch or finally"); if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc); } } } }, abrupt: function abrupt(type, arg) { for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i]; if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) { var finallyEntry = entry; break; } } finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null); var record = finallyEntry ? finallyEntry.completion : {}; return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record); }, complete: function complete(record, afterLoc) { if ("throw" === record.type) throw record.arg; return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel; }, finish: function finish(finallyLoc) { for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i]; if (entry.finallyLoc === finallyLoc) return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel; } }, catch: function _catch(tryLoc) { for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i]; if (entry.tryLoc === tryLoc) { var record = entry.completion; if ("throw" === record.type) { var thrown = record.arg; resetTryEntry(entry); } return thrown; } } throw new Error("illegal catch attempt"); }, delegateYield: function delegateYield(iterable, resultName, nextLoc) { return this.delegate = { iterator: values(iterable), resultName: resultName, nextLoc: nextLoc }, "next" === this.method && (this.arg = undefined), ContinueSentinel; } }, exports; }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
import t from "Vue";
import e from "angular";
function r(t, e) {
  return {
    install: function install(r, n) {
      r.prototype[t] || (r.prototype[t] = e);
    }
  };
}
function n(e) {
  var _t$prototype, _t$prototype$$ngVue;
  if (e || (e = t === null || t === void 0 ? void 0 : (_t$prototype = t.prototype) === null || _t$prototype === void 0 ? void 0 : (_t$prototype$$ngVue = _t$prototype.$ngVue) === null || _t$prototype$$ngVue === void 0 ? void 0 : _t$prototype$$ngVue.$injector), !e) throw new Error("Angular $injector not provided, cannot use AngularVueRoutePlugin plugin");
  var r = e.get("$location"),
    n = e.get("$route"),
    o = e.get("$rootScope");
  if (!r) throw new Error("Angular $location service not available, cannot use AngularVueRoutePlugin plugin");
  if (!n) throw new Error("Angular $route service not available, cannot use AngularVueRoutePlugin");
  var u = window.Vue.observable({
    _route: null
  });
  function a() {
    var _n$current;
    var t = r.url(),
      e = r.path(),
      o = r.hash(),
      a = _objectSpread({}, r.search() || {}),
      i = _objectSpread({}, ((_n$current = n.current) === null || _n$current === void 0 ? void 0 : _n$current.params) || {});
    u._route = {
      get fullPath() {
        return t;
      },
      get path() {
        return e;
      },
      get hash() {
        return o ? "#".concat(o) : "";
      },
      get query() {
        return _objectSpread({}, a);
      },
      get params() {
        return _objectSpread({}, i);
      }
    };
  }
  if (o.$on("$routeUpdate", a), o.$on("$routeChangeSuccess", a), !n.current) {
    var _t2 = o.$watch(function () {
      return n.current;
    }, function (e) {
      void 0 !== e && (_t2(), a());
    });
  }
  return a(), {
    install: function install(t, e) {
      t.prototype.$route || Object.defineProperty(t.prototype, "$route", {
        get: function get() {
          return u._route;
        }
      });
    }
  };
}
function o(e) {
  var _t$prototype2, _t$prototype2$$ngVue;
  if (e || (e = t === null || t === void 0 ? void 0 : (_t$prototype2 = t.prototype) === null || _t$prototype2 === void 0 ? void 0 : (_t$prototype2$$ngVue = _t$prototype2.$ngVue) === null || _t$prototype2$$ngVue === void 0 ? void 0 : _t$prototype2$$ngVue.$injector), !e) throw new Error("Angular $injector not provided, cannot use AngularVueRouterPlugin plugin");
  var r = e.get("$location"),
    n = e.get("$rootScope");
  if (!r) throw new Error("Angular $location service not available, cannot use AngularVueRouterPlugin plugin");
  var o = function o(t) {
    n.$$phase ? t() : n.$apply(t);
  };
  var u = {
    push: function push(_ref) {
      var t = _ref.path,
        e = _ref.query,
        n = _ref.hash;
      o(function () {
        t && r.path(t), e && r.search(e || {}), void 0 !== n && r.hash((n || "").replace(/^#/, ""));
      });
    },
    replace: function replace() {
      var _this = this;
      for (var _len = arguments.length, t = new Array(_len), _key = 0; _key < _len; _key++) {
        t[_key] = arguments[_key];
      }
      o(function () {
        r.replace(), _this.push.apply(_this, t);
      });
    }
  };
  return {
    install: function install(t, e) {
      t.prototype.$router || (t.prototype.$router = u);
    }
  };
}
function u() {
  var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
    t = _ref2.login,
    e = _ref2.logout,
    r = _ref2.fetchUser;
  var n = Vue.observable({
      user: null,
      userToken: null
    }),
    o = {
      get user() {
        return n.user;
      },
      get loggedIn() {
        var _n$user;
        return !(!n.user || !(n !== null && n !== void 0 && (_n$user = n.user) !== null && _n$user !== void 0 && _n$user.isAuthenticated));
      },
      setUser: function setUser(t) {
        n.user = t;
      },
      setUserToken: function setUserToken(t) {
        n.userToken = t;
      },
      login: function login() {
        var _arguments = arguments,
          _this2 = this;
        return _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
          return _regeneratorRuntime().wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  if (t) {
                    _context.next = 2;
                    break;
                  }
                  throw new Error('"login" Not Implemented');
                case 2:
                  if (_this2.loggedIn) {
                    _context.next = 6;
                    break;
                  }
                  _context.next = 5;
                  return t.apply(void 0, _toConsumableArray(_arguments));
                case 5:
                  return _context.abrupt("return", _context.sent);
                case 6:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee);
        }))();
      },
      logout: function logout() {
        if (!e) throw new Error('"logout" Not Implemented');
        e();
      },
      fetchUser: function fetchUser() {
        var _this3 = this;
        return _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2() {
          var t;
          return _regeneratorRuntime().wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  if (r) {
                    _context2.next = 2;
                    break;
                  }
                  throw new Error('"fetchUser" Not Implemented');
                case 2:
                  _context2.next = 4;
                  return r();
                case 4:
                  t = _context2.sent;
                  return _context2.abrupt("return", (_this3.setUser(t), t));
                case 6:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2);
        }))();
      },
      hasScope: function hasScope(t) {
        var _this4 = this;
        var e = [];
        if ("string" == typeof t) e = [t];else if (!Array.isArray(t)) throw new Error("`scopeName` must be string or array od string");
        e = t;
        return !!e.find(function (t) {
          var _this4$user;
          return (_this4$user = _this4.user) === null || _this4$user === void 0 ? void 0 : _this4$user.roles.includes(t);
        });
      },
      refreshTokens: function refreshTokens() {
        throw new Error("Not Implemented");
      },
      onError: function onError() {
        throw new Error("Not Implemented");
      },
      onRedirect: function onRedirect() {
        throw new Error("Not Implemented");
      },
      strategy: {
        token: {
          get: function get() {
            return n.userToken;
          },
          set: function set(t) {
            n.userToken = t;
          }
        },
        get refreshToken() {
          throw new Error("Not Implemented");
        }
      }
    };
  return {
    install: function install(t, e) {
      t.prototype.$auth || Object.defineProperty(t.prototype, "$auth", {
        get: function get() {
          return o;
        }
      });
    }
  };
}
var a = "undefined" != typeof globalThis ? globalThis : "undefined" != typeof window ? window : "undefined" != typeof global ? global : "undefined" != typeof self ? self : {},
  i = "object" == _typeof(a) && a && a.Object === Object && a,
  c = i,
  f = "object" == (typeof self === "undefined" ? "undefined" : _typeof(self)) && self && self.Object === Object && self,
  s = c || f || Function("return this")(),
  l = s.Symbol;
var v = function v(t, e) {
    for (var r = -1, n = null == t ? 0 : t.length, o = Array(n); ++r < n;) {
      o[r] = e(t[r], r, t);
    }
    return o;
  },
  p = Array.isArray,
  d = l,
  h = Object.prototype,
  b = h.hasOwnProperty,
  g = h.toString,
  y = d ? d.toStringTag : void 0;
var $ = function $(t) {
    var e = b.call(t, y),
      r = t[y];
    try {
      t[y] = void 0;
      var n = !0;
    } catch (t) {}
    var o = g.call(t);
    return n && (e ? t[y] = r : delete t[y]), o;
  },
  j = Object.prototype.toString;
var m = $,
  w = function w(t) {
    return j.call(t);
  },
  A = l ? l.toStringTag : void 0;
var x = function x(t) {
  return null == t ? void 0 === t ? "[object Undefined]" : "[object Null]" : A && A in Object(t) ? m(t) : w(t);
};
var O = function O(t) {
    return null != t && "object" == _typeof(t);
  },
  E = x,
  z = O;
var S = function S(t) {
    return "symbol" == _typeof(t) || z(t) && "[object Symbol]" == E(t);
  },
  V = v,
  U = p,
  I = S,
  P = l ? l.prototype : void 0,
  k = P ? P.toString : void 0;
var T = function t(e) {
    if ("string" == typeof e) return e;
    if (U(e)) return V(e, t) + "";
    if (I(e)) return k ? k.call(e) : "";
    var r = e + "";
    return "0" == r && 1 / e == -Infinity ? "-0" : r;
  },
  C = T;
var R = function R(t) {
  return null == t ? "" : C(t);
};
var D = function D(t, e, r) {
    var n = -1,
      o = t.length;
    e < 0 && (e = -e > o ? 0 : o + e), (r = r > o ? o : r) < 0 && (r += o), o = e > r ? 0 : r - e >>> 0, e >>>= 0;
    for (var u = Array(o); ++n < o;) {
      u[n] = t[n + e];
    }
    return u;
  },
  N = D;
var L = function L(t, e, r) {
    var n = t.length;
    return r = void 0 === r ? n : r, !e && r >= n ? t : N(t, e, r);
  },
  M = RegExp("[\\u200d\\ud800-\\udfff\\u0300-\\u036f\\ufe20-\\ufe2f\\u20d0-\\u20ff\\ufe0e\\ufe0f]");
var F = function F(t) {
  return M.test(t);
};
var B = function B(t) {
    return t.split("");
  },
  Z = "[\\ud800-\\udfff]",
  W = "[\\u0300-\\u036f\\ufe20-\\ufe2f\\u20d0-\\u20ff]",
  G = "\\ud83c[\\udffb-\\udfff]",
  q = "[^\\ud800-\\udfff]",
  H = "(?:\\ud83c[\\udde6-\\uddff]){2}",
  Y = "[\\ud800-\\udbff][\\udc00-\\udfff]",
  J = "(?:" + W + "|" + G + ")" + "?",
  K = "[\\ufe0e\\ufe0f]?" + J + ("(?:\\u200d(?:" + [q, H, Y].join("|") + ")[\\ufe0e\\ufe0f]?" + J + ")*"),
  Q = "(?:" + [q + W + "?", W, H, Y, Z].join("|") + ")",
  X = RegExp(G + "(?=" + G + ")|" + Q + K, "g");
var tt = B,
  et = F,
  rt = function rt(t) {
    return t.match(X) || [];
  };
var nt = L,
  ot = F,
  ut = function ut(t) {
    return et(t) ? rt(t) : tt(t);
  },
  at = R;
var it = function (t) {
    return function (e) {
      e = at(e);
      var r = ot(e) ? ut(e) : void 0,
        n = r ? r[0] : e.charAt(0),
        o = r ? nt(r, 1).join("") : e.slice(1);
      return n[t]() + o;
    };
  }("toUpperCase"),
  ct = R,
  ft = it;
var st = function st(t) {
  return ft(ct(t).toLowerCase());
};
var lt = function lt(t, e, r, n) {
  var o = -1,
    u = null == t ? 0 : t.length;
  for (n && u && (r = t[++o]); ++o < u;) {
    r = e(r, t[o], o, t);
  }
  return r;
};
var vt = function (t) {
    return function (e) {
      return null == t ? void 0 : t[e];
    };
  }({
    "À": "A",
    "Á": "A",
    "Â": "A",
    "Ã": "A",
    "Ä": "A",
    "Å": "A",
    "à": "a",
    "á": "a",
    "â": "a",
    "ã": "a",
    "ä": "a",
    "å": "a",
    "Ç": "C",
    "ç": "c",
    "Ð": "D",
    "ð": "d",
    "È": "E",
    "É": "E",
    "Ê": "E",
    "Ë": "E",
    "è": "e",
    "é": "e",
    "ê": "e",
    "ë": "e",
    "Ì": "I",
    "Í": "I",
    "Î": "I",
    "Ï": "I",
    "ì": "i",
    "í": "i",
    "î": "i",
    "ï": "i",
    "Ñ": "N",
    "ñ": "n",
    "Ò": "O",
    "Ó": "O",
    "Ô": "O",
    "Õ": "O",
    "Ö": "O",
    "Ø": "O",
    "ò": "o",
    "ó": "o",
    "ô": "o",
    "õ": "o",
    "ö": "o",
    "ø": "o",
    "Ù": "U",
    "Ú": "U",
    "Û": "U",
    "Ü": "U",
    "ù": "u",
    "ú": "u",
    "û": "u",
    "ü": "u",
    "Ý": "Y",
    "ý": "y",
    "ÿ": "y",
    "Æ": "Ae",
    "æ": "ae",
    "Þ": "Th",
    "þ": "th",
    "ß": "ss",
    "Ā": "A",
    "Ă": "A",
    "Ą": "A",
    "ā": "a",
    "ă": "a",
    "ą": "a",
    "Ć": "C",
    "Ĉ": "C",
    "Ċ": "C",
    "Č": "C",
    "ć": "c",
    "ĉ": "c",
    "ċ": "c",
    "č": "c",
    "Ď": "D",
    "Đ": "D",
    "ď": "d",
    "đ": "d",
    "Ē": "E",
    "Ĕ": "E",
    "Ė": "E",
    "Ę": "E",
    "Ě": "E",
    "ē": "e",
    "ĕ": "e",
    "ė": "e",
    "ę": "e",
    "ě": "e",
    "Ĝ": "G",
    "Ğ": "G",
    "Ġ": "G",
    "Ģ": "G",
    "ĝ": "g",
    "ğ": "g",
    "ġ": "g",
    "ģ": "g",
    "Ĥ": "H",
    "Ħ": "H",
    "ĥ": "h",
    "ħ": "h",
    "Ĩ": "I",
    "Ī": "I",
    "Ĭ": "I",
    "Į": "I",
    "İ": "I",
    "ĩ": "i",
    "ī": "i",
    "ĭ": "i",
    "į": "i",
    "ı": "i",
    "Ĵ": "J",
    "ĵ": "j",
    "Ķ": "K",
    "ķ": "k",
    "ĸ": "k",
    "Ĺ": "L",
    "Ļ": "L",
    "Ľ": "L",
    "Ŀ": "L",
    "Ł": "L",
    "ĺ": "l",
    "ļ": "l",
    "ľ": "l",
    "ŀ": "l",
    "ł": "l",
    "Ń": "N",
    "Ņ": "N",
    "Ň": "N",
    "Ŋ": "N",
    "ń": "n",
    "ņ": "n",
    "ň": "n",
    "ŋ": "n",
    "Ō": "O",
    "Ŏ": "O",
    "Ő": "O",
    "ō": "o",
    "ŏ": "o",
    "ő": "o",
    "Ŕ": "R",
    "Ŗ": "R",
    "Ř": "R",
    "ŕ": "r",
    "ŗ": "r",
    "ř": "r",
    "Ś": "S",
    "Ŝ": "S",
    "Ş": "S",
    "Š": "S",
    "ś": "s",
    "ŝ": "s",
    "ş": "s",
    "š": "s",
    "Ţ": "T",
    "Ť": "T",
    "Ŧ": "T",
    "ţ": "t",
    "ť": "t",
    "ŧ": "t",
    "Ũ": "U",
    "Ū": "U",
    "Ŭ": "U",
    "Ů": "U",
    "Ű": "U",
    "Ų": "U",
    "ũ": "u",
    "ū": "u",
    "ŭ": "u",
    "ů": "u",
    "ű": "u",
    "ų": "u",
    "Ŵ": "W",
    "ŵ": "w",
    "Ŷ": "Y",
    "ŷ": "y",
    "Ÿ": "Y",
    "Ź": "Z",
    "Ż": "Z",
    "Ž": "Z",
    "ź": "z",
    "ż": "z",
    "ž": "z",
    "Ĳ": "IJ",
    "ĳ": "ij",
    "Œ": "Oe",
    "œ": "oe",
    "ŉ": "'n",
    "ſ": "s"
  }),
  pt = R,
  dt = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g,
  ht = RegExp("[\\u0300-\\u036f\\ufe20-\\ufe2f\\u20d0-\\u20ff]", "g");
var bt = function bt(t) {
    return (t = pt(t)) && t.replace(dt, vt).replace(ht, "");
  },
  gt = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g;
var yt = function yt(t) {
    return t.match(gt) || [];
  },
  $t = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/;
var jt = function jt(t) {
    return $t.test(t);
  },
  _t = "\\xac\\xb1\\xd7\\xf7\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf\\u2000-\\u206f \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000",
  mt = "[" + _t + "]",
  wt = "\\d+",
  At = "[\\u2700-\\u27bf]",
  xt = "[a-z\\xdf-\\xf6\\xf8-\\xff]",
  Ot = "[^\\ud800-\\udfff" + _t + wt + "\\u2700-\\u27bfa-z\\xdf-\\xf6\\xf8-\\xffA-Z\\xc0-\\xd6\\xd8-\\xde]",
  Et = "(?:\\ud83c[\\udde6-\\uddff]){2}",
  zt = "[\\ud800-\\udbff][\\udc00-\\udfff]",
  St = "[A-Z\\xc0-\\xd6\\xd8-\\xde]",
  Vt = "(?:" + xt + "|" + Ot + ")",
  Ut = "(?:" + St + "|" + Ot + ")",
  It = "(?:[\\u0300-\\u036f\\ufe20-\\ufe2f\\u20d0-\\u20ff]|\\ud83c[\\udffb-\\udfff])?",
  Pt = "[\\ufe0e\\ufe0f]?" + It + ("(?:\\u200d(?:" + ["[^\\ud800-\\udfff]", Et, zt].join("|") + ")[\\ufe0e\\ufe0f]?" + It + ")*"),
  kt = "(?:" + [At, Et, zt].join("|") + ")" + Pt,
  Tt = RegExp([St + "?" + xt + "+(?:['’](?:d|ll|m|re|s|t|ve))?(?=" + [mt, St, "$"].join("|") + ")", Ut + "+(?:['’](?:D|LL|M|RE|S|T|VE))?(?=" + [mt, St + Vt, "$"].join("|") + ")", St + "?" + Vt + "+(?:['’](?:d|ll|m|re|s|t|ve))?", St + "+(?:['’](?:D|LL|M|RE|S|T|VE))?", "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", wt, kt].join("|"), "g");
var Ct = yt,
  Rt = jt,
  Dt = R,
  Nt = function Nt(t) {
    return t.match(Tt) || [];
  };
var Lt = lt,
  Mt = bt,
  Ft = function Ft(t, e, r) {
    return t = Dt(t), void 0 === (e = r ? void 0 : e) ? Rt(t) ? Nt(t) : Ct(t) : t.match(e) || [];
  },
  Bt = RegExp("['’]", "g");
var Zt = function Zt(t) {
    return function (e) {
      return Lt(Ft(Mt(e).replace(Bt, "")), t, "");
    };
  },
  Wt = st,
  Gt = Zt(function (t, e, r) {
    return e = e.toLowerCase(), t + (r ? Wt(e) : e);
  });
function qt(t, e) {
  var r = t.$root.$$phase;
  "$apply" == r || "$digest" == r ? e() : t.$apply(e);
}
var Ht = {
  render: function render(t) {
    return t(null, "angular placeholder");
  },
  mounted: function mounted() {
    var _e$element$parents,
      _this5 = this;
    if (!this.$ngVue) throw new Error("AngularVuePlugin not installed");
    var t = this.$ngVue.$injector,
      r = (((_e$element$parents = e.element(this.$el).parents(".ng-scope:first")) === null || _e$element$parents === void 0 ? void 0 : _e$element$parents.scope()) || t.get("$rootScope")).$new(!0);
    this.$scope = r, Object.keys(this.$attrs).forEach(function (t) {
      var e = Gt(t);
      console.debug("vue(ng): initial set vue => ng (".concat(e, "):"), _this5.$attrs[t]), r[e] = _this5.$attrs[t], _this5.$watch(function () {
        return _this5.$attrs[t];
      }, function (t) {
        r.$$destroyed || qt(r, function () {
          r[e] !== t && (console.debug("vue(ng): vue => ng (".concat(e, ")"), t), r[e] = t);
        });
      }), r.$watch(function () {
        return r[e];
      }, function (r) {
        _this5.$attrs[t] !== r && (console.debug("vue(ng): ng => vue (".concat(e, ")"), r), _this5.$emit("update:".concat(e), r));
      });
    });
    var n = function (t) {
        var e = new Vue({
          render: function render() {
            return t;
          }
        });
        e.$mount();
        var r = e.$el;
        return e.$destroy(), r;
      }(this.$slots.default),
      o = t.get("$compile")(n),
      _o2 = o(r),
      _o3 = _slicedToArray(_o2, 1),
      u = _o3[0];
    u.$component = this, this.$el.parentElement.replaceChild(u, this.$el);
  },
  beforeDestroy: function beforeDestroy() {
    var t = this.$scope;
    t && (console.debug("vue(ng): destroying ng-scope", t), delete this.$scope, t.$destroy());
  }
};
function Yt(_ref3) {
  var t = _ref3.$injector,
    r = _ref3.ngApp,
    n = _ref3.vueApp;
  var o = {
    get $injector() {
      return t || e.injector();
    },
    get vueApp() {
      return n;
    },
    get ngApp() {
      return r;
    }
  };
  return {
    install: function install(t, e) {
      if (!t.prototype.$ngVue) {
        var _ref4 = e || {},
          _n2 = _ref4.vueNgName;
        t.component(((r = Gt(r = _n2 || "VueNg")) && (r = r[0].toUpperCase() + r.slice(1)), r), Ht), Object.defineProperty(t.prototype, "$ngVue", {
          get: function get() {
            return o;
          }
        });
      }
      var r;
    }
  };
}
var Jt = {
  parent: Kt,
  parents: function parents(t) {
    var e = [];
    var r = Kt(t);
    for (; r;) {
      e.push(r), r = Kt(r);
    }
    return e;
  },
  leaf: function leaf(t) {
    return Qt(t).pop();
  },
  root: function root(t) {
    return Qt(t)[0];
  },
  isRoot: function isRoot(t) {
    return 1 === Qt(t).length;
  }
};
function Kt(t) {
  var e = Qt(t);
  return e.pop(), function (t) {
    return t.join(".");
  }(e);
}
function Qt(t) {
  if (!t) throw new Error("Invalid path ".concat(t));
  return t.split(".");
}
var Xt = function Xt() {
  this.__data__ = [], this.size = 0;
};
var te = function te(t, e) {
    return t === e || t != t && e != e;
  },
  ee = te;
var re = function re(t, e) {
    for (var r = t.length; r--;) {
      if (ee(t[r][0], e)) return r;
    }
    return -1;
  },
  ne = re,
  oe = Array.prototype.splice;
var ue = re;
var ae = re;
var ie = re;
var ce = Xt,
  fe = function fe(t) {
    var e = this.__data__,
      r = ne(e, t);
    return !(r < 0) && (r == e.length - 1 ? e.pop() : oe.call(e, r, 1), --this.size, !0);
  },
  se = function se(t) {
    var e = this.__data__,
      r = ue(e, t);
    return r < 0 ? void 0 : e[r][1];
  },
  le = function le(t) {
    return ae(this.__data__, t) > -1;
  },
  ve = function ve(t, e) {
    var r = this.__data__,
      n = ie(r, t);
    return n < 0 ? (++this.size, r.push([t, e])) : r[n][1] = e, this;
  };
function pe(t) {
  var e = -1,
    r = null == t ? 0 : t.length;
  for (this.clear(); ++e < r;) {
    var n = t[e];
    this.set(n[0], n[1]);
  }
}
pe.prototype.clear = ce, pe.prototype.delete = fe, pe.prototype.get = se, pe.prototype.has = le, pe.prototype.set = ve;
var de = pe,
  he = de;
var be = function be() {
  this.__data__ = new he(), this.size = 0;
};
var ge = function ge(t) {
  var e = this.__data__,
    r = e.delete(t);
  return this.size = e.size, r;
};
var ye = function ye(t) {
  return this.__data__.get(t);
};
var $e = function $e(t) {
  return this.__data__.has(t);
};
var je = function je(t) {
    var e = _typeof(t);
    return null != t && ("object" == e || "function" == e);
  },
  _e = x,
  me = je;
var we,
  Ae = function Ae(t) {
    if (!me(t)) return !1;
    var e = _e(t);
    return "[object Function]" == e || "[object GeneratorFunction]" == e || "[object AsyncFunction]" == e || "[object Proxy]" == e;
  },
  xe = s["__core-js_shared__"],
  Oe = (we = /[^.]+$/.exec(xe && xe.keys && xe.keys.IE_PROTO || "")) ? "Symbol(src)_1." + we : "";
var Ee = function Ee(t) {
    return !!Oe && Oe in t;
  },
  ze = Function.prototype.toString;
var Se = function Se(t) {
    if (null != t) {
      try {
        return ze.call(t);
      } catch (t) {}
      try {
        return t + "";
      } catch (t) {}
    }
    return "";
  },
  Ve = Ae,
  Ue = Ee,
  Ie = je,
  Pe = Se,
  ke = /^\[object .+?Constructor\]$/,
  Te = Function.prototype,
  Ce = Object.prototype,
  Re = Te.toString,
  De = Ce.hasOwnProperty,
  Ne = RegExp("^" + Re.call(De).replace(/[\\^$.*+?()[\]{}|]/g, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$");
var Le = function Le(t) {
    return !(!Ie(t) || Ue(t)) && (Ve(t) ? Ne : ke).test(Pe(t));
  },
  Me = function Me(t, e) {
    return null == t ? void 0 : t[e];
  };
var Fe = function Fe(t, e) {
    var r = Me(t, e);
    return Le(r) ? r : void 0;
  },
  Be = Fe(s, "Map"),
  Ze = Fe(Object, "create"),
  We = Ze;
var Ge = function Ge() {
  this.__data__ = We ? We(null) : {}, this.size = 0;
};
var qe = function qe(t) {
    var e = this.has(t) && delete this.__data__[t];
    return this.size -= e ? 1 : 0, e;
  },
  He = Ze,
  Ye = Object.prototype.hasOwnProperty;
var Je = function Je(t) {
    var e = this.__data__;
    if (He) {
      var r = e[t];
      return "__lodash_hash_undefined__" === r ? void 0 : r;
    }
    return Ye.call(e, t) ? e[t] : void 0;
  },
  Ke = Ze,
  Qe = Object.prototype.hasOwnProperty;
var Xe = Ze;
var tr = Ge,
  er = qe,
  rr = Je,
  nr = function nr(t) {
    var e = this.__data__;
    return Ke ? void 0 !== e[t] : Qe.call(e, t);
  },
  or = function or(t, e) {
    var r = this.__data__;
    return this.size += this.has(t) ? 0 : 1, r[t] = Xe && void 0 === e ? "__lodash_hash_undefined__" : e, this;
  };
function ur(t) {
  var e = -1,
    r = null == t ? 0 : t.length;
  for (this.clear(); ++e < r;) {
    var n = t[e];
    this.set(n[0], n[1]);
  }
}
ur.prototype.clear = tr, ur.prototype.delete = er, ur.prototype.get = rr, ur.prototype.has = nr, ur.prototype.set = or;
var ar = ur,
  ir = de,
  cr = Be;
var fr = function fr(t) {
  var e = _typeof(t);
  return "string" == e || "number" == e || "symbol" == e || "boolean" == e ? "__proto__" !== t : null === t;
};
var sr = function sr(t, e) {
    var r = t.__data__;
    return fr(e) ? r["string" == typeof e ? "string" : "hash"] : r.map;
  },
  lr = sr;
var vr = sr;
var pr = sr;
var dr = sr;
var hr = function hr() {
    this.size = 0, this.__data__ = {
      hash: new ar(),
      map: new (cr || ir)(),
      string: new ar()
    };
  },
  br = function br(t) {
    var e = lr(this, t).delete(t);
    return this.size -= e ? 1 : 0, e;
  },
  gr = function gr(t) {
    return vr(this, t).get(t);
  },
  yr = function yr(t) {
    return pr(this, t).has(t);
  },
  $r = function $r(t, e) {
    var r = dr(this, t),
      n = r.size;
    return r.set(t, e), this.size += r.size == n ? 0 : 1, this;
  };
function jr(t) {
  var e = -1,
    r = null == t ? 0 : t.length;
  for (this.clear(); ++e < r;) {
    var n = t[e];
    this.set(n[0], n[1]);
  }
}
jr.prototype.clear = hr, jr.prototype.delete = br, jr.prototype.get = gr, jr.prototype.has = yr, jr.prototype.set = $r;
var _r = jr,
  mr = de,
  wr = Be,
  Ar = _r;
var xr = de,
  Or = be,
  Er = ge,
  zr = ye,
  Sr = $e,
  Vr = function Vr(t, e) {
    var r = this.__data__;
    if (r instanceof mr) {
      var n = r.__data__;
      if (!wr || n.length < 199) return n.push([t, e]), this.size = ++r.size, this;
      r = this.__data__ = new Ar(n);
    }
    return r.set(t, e), this.size = r.size, this;
  };
function Ur(t) {
  var e = this.__data__ = new xr(t);
  this.size = e.size;
}
Ur.prototype.clear = Or, Ur.prototype.delete = Er, Ur.prototype.get = zr, Ur.prototype.has = Sr, Ur.prototype.set = Vr;
var Ir = Ur;
var Pr = function Pr(t, e) {
    for (var r = -1, n = null == t ? 0 : t.length; ++r < n && !1 !== e(t[r], r, t);) {
      ;
    }
    return t;
  },
  kr = Fe,
  Tr = function () {
    try {
      var t = kr(Object, "defineProperty");
      return t({}, "", {}), t;
    } catch (t) {}
  }(),
  Cr = Tr;
var Rr = function Rr(t, e, r) {
    "__proto__" == e && Cr ? Cr(t, e, {
      configurable: !0,
      enumerable: !0,
      value: r,
      writable: !0
    }) : t[e] = r;
  },
  Dr = Rr,
  Nr = te,
  Lr = Object.prototype.hasOwnProperty;
var Mr = function Mr(t, e, r) {
    var n = t[e];
    Lr.call(t, e) && Nr(n, r) && (void 0 !== r || e in t) || Dr(t, e, r);
  },
  Fr = Mr,
  Br = Rr;
var Zr = function Zr(t, e, r, n) {
  var o = !r;
  r || (r = {});
  for (var u = -1, a = e.length; ++u < a;) {
    var i = e[u],
      c = n ? n(r[i], t[i], i, r, t) : void 0;
    void 0 === c && (c = t[i]), o ? Br(r, i, c) : Fr(r, i, c);
  }
  return r;
};
var Wr = function Wr(t, e) {
    for (var r = -1, n = Array(t); ++r < t;) {
      n[r] = e(r);
    }
    return n;
  },
  Gr = x,
  qr = O;
var Hr = function Hr(t) {
    return qr(t) && "[object Arguments]" == Gr(t);
  },
  Yr = O,
  Jr = Object.prototype,
  Kr = Jr.hasOwnProperty,
  Qr = Jr.propertyIsEnumerable,
  Xr = Hr(function () {
    return arguments;
  }()) ? Hr : function (t) {
    return Yr(t) && Kr.call(t, "callee") && !Qr.call(t, "callee");
  },
  tn = {
    exports: {}
  };
var en = function en() {
  return !1;
};
!function (t, e) {
  var r = s,
    n = en,
    o = e && !e.nodeType && e,
    u = o && t && !t.nodeType && t,
    a = u && u.exports === o ? r.Buffer : void 0,
    i = (a ? a.isBuffer : void 0) || n;
  t.exports = i;
}(tn, tn.exports);
var rn = /^(?:0|[1-9]\d*)$/;
var nn = function nn(t, e) {
  var r = _typeof(t);
  return !!(e = null == e ? 9007199254740991 : e) && ("number" == r || "symbol" != r && rn.test(t)) && t > -1 && t % 1 == 0 && t < e;
};
var on = function on(t) {
    return "number" == typeof t && t > -1 && t % 1 == 0 && t <= 9007199254740991;
  },
  un = x,
  an = on,
  cn = O,
  fn = {};
fn["[object Float32Array]"] = fn["[object Float64Array]"] = fn["[object Int8Array]"] = fn["[object Int16Array]"] = fn["[object Int32Array]"] = fn["[object Uint8Array]"] = fn["[object Uint8ClampedArray]"] = fn["[object Uint16Array]"] = fn["[object Uint32Array]"] = !0, fn["[object Arguments]"] = fn["[object Array]"] = fn["[object ArrayBuffer]"] = fn["[object Boolean]"] = fn["[object DataView]"] = fn["[object Date]"] = fn["[object Error]"] = fn["[object Function]"] = fn["[object Map]"] = fn["[object Number]"] = fn["[object Object]"] = fn["[object RegExp]"] = fn["[object Set]"] = fn["[object String]"] = fn["[object WeakMap]"] = !1;
var sn = function sn(t) {
  return cn(t) && an(t.length) && !!fn[un(t)];
};
var ln = function ln(t) {
    return function (e) {
      return t(e);
    };
  },
  vn = {
    exports: {}
  };
!function (t, e) {
  var r = i,
    n = e && !e.nodeType && e,
    o = n && t && !t.nodeType && t,
    u = o && o.exports === n && r.process,
    a = function () {
      try {
        var t = o && o.require && o.require("util").types;
        return t || u && u.binding && u.binding("util");
      } catch (t) {}
    }();
  t.exports = a;
}(vn, vn.exports);
var pn = sn,
  dn = ln,
  hn = vn.exports,
  bn = hn && hn.isTypedArray,
  gn = bn ? dn(bn) : pn,
  yn = Wr,
  $n = Xr,
  jn = p,
  _n = tn.exports,
  mn = nn,
  wn = gn,
  An = Object.prototype.hasOwnProperty;
var xn = function xn(t, e) {
    var r = jn(t),
      n = !r && $n(t),
      o = !r && !n && _n(t),
      u = !r && !n && !o && wn(t),
      a = r || n || o || u,
      i = a ? yn(t.length, String) : [],
      c = i.length;
    for (var f in t) {
      !e && !An.call(t, f) || a && ("length" == f || o && ("offset" == f || "parent" == f) || u && ("buffer" == f || "byteLength" == f || "byteOffset" == f) || mn(f, c)) || i.push(f);
    }
    return i;
  },
  On = Object.prototype;
var En = function En(t) {
  var e = t && t.constructor;
  return t === ("function" == typeof e && e.prototype || On);
};
var zn = function zn(t, e) {
    return function (r) {
      return t(e(r));
    };
  },
  Sn = zn(Object.keys, Object),
  Vn = En,
  Un = Sn,
  In = Object.prototype.hasOwnProperty;
var Pn = Ae,
  kn = on;
var Tn = function Tn(t) {
    return null != t && kn(t.length) && !Pn(t);
  },
  Cn = xn,
  Rn = function Rn(t) {
    if (!Vn(t)) return Un(t);
    var e = [];
    for (var r in Object(t)) {
      In.call(t, r) && "constructor" != r && e.push(r);
    }
    return e;
  },
  Dn = Tn;
var Nn = function Nn(t) {
    return Dn(t) ? Cn(t) : Rn(t);
  },
  Ln = Zr,
  Mn = Nn;
var Fn = function Fn(t, e) {
  return t && Ln(e, Mn(e), t);
};
var Bn = je,
  Zn = En,
  Wn = function Wn(t) {
    var e = [];
    if (null != t) for (var r in Object(t)) {
      e.push(r);
    }
    return e;
  },
  Gn = Object.prototype.hasOwnProperty;
var qn = xn,
  Hn = function Hn(t) {
    if (!Bn(t)) return Wn(t);
    var e = Zn(t),
      r = [];
    for (var n in t) {
      ("constructor" != n || !e && Gn.call(t, n)) && r.push(n);
    }
    return r;
  },
  Yn = Tn;
var Jn = function Jn(t) {
    return Yn(t) ? qn(t, !0) : Hn(t);
  },
  Kn = Zr,
  Qn = Jn;
var Xn = function Xn(t, e) {
    return t && Kn(e, Qn(e), t);
  },
  to = {
    exports: {}
  };
!function (t, e) {
  var r = s,
    n = e && !e.nodeType && e,
    o = n && t && !t.nodeType && t,
    u = o && o.exports === n ? r.Buffer : void 0,
    a = u ? u.allocUnsafe : void 0;
  t.exports = function (t, e) {
    if (e) return t.slice();
    var r = t.length,
      n = a ? a(r) : new t.constructor(r);
    return t.copy(n), n;
  };
}(to, to.exports);
var eo = function eo(t, e) {
  var r = -1,
    n = t.length;
  for (e || (e = Array(n)); ++r < n;) {
    e[r] = t[r];
  }
  return e;
};
var ro = function ro() {
    return [];
  },
  no = function no(t, e) {
    for (var r = -1, n = null == t ? 0 : t.length, o = 0, u = []; ++r < n;) {
      var a = t[r];
      e(a, r, t) && (u[o++] = a);
    }
    return u;
  },
  oo = ro,
  uo = Object.prototype.propertyIsEnumerable,
  ao = Object.getOwnPropertySymbols,
  io = ao ? function (t) {
    return null == t ? [] : (t = Object(t), no(ao(t), function (e) {
      return uo.call(t, e);
    }));
  } : oo,
  co = Zr,
  fo = io;
var so = function so(t, e) {
  return co(t, fo(t), e);
};
var lo = function lo(t, e) {
    for (var r = -1, n = e.length, o = t.length; ++r < n;) {
      t[o + r] = e[r];
    }
    return t;
  },
  vo = zn(Object.getPrototypeOf, Object),
  po = lo,
  ho = vo,
  bo = io,
  go = ro,
  yo = Object.getOwnPropertySymbols ? function (t) {
    for (var e = []; t;) {
      po(e, bo(t)), t = ho(t);
    }
    return e;
  } : go,
  $o = Zr,
  jo = yo;
var _o = function _o(t, e) {
    return $o(t, jo(t), e);
  },
  mo = lo,
  wo = p;
var Ao = function Ao(t, e, r) {
    var n = e(t);
    return wo(t) ? n : mo(n, r(t));
  },
  xo = Ao,
  Oo = io,
  Eo = Nn;
var zo = function zo(t) {
    return xo(t, Eo, Oo);
  },
  So = Ao,
  Vo = yo,
  Uo = Jn;
var Io = function Io(t) {
    return So(t, Uo, Vo);
  },
  Po = Fe(s, "DataView"),
  ko = Fe(s, "Promise"),
  To = Fe(s, "Set"),
  Co = Po,
  Ro = Be,
  Do = ko,
  No = To,
  Lo = Fe(s, "WeakMap"),
  Mo = x,
  Fo = Se,
  Bo = Fo(Co),
  Zo = Fo(Ro),
  Wo = Fo(Do),
  Go = Fo(No),
  qo = Fo(Lo),
  Ho = Mo;
(Co && "[object DataView]" != Ho(new Co(new ArrayBuffer(1))) || Ro && "[object Map]" != Ho(new Ro()) || Do && "[object Promise]" != Ho(Do.resolve()) || No && "[object Set]" != Ho(new No()) || Lo && "[object WeakMap]" != Ho(new Lo())) && (Ho = function Ho(t) {
  var e = Mo(t),
    r = "[object Object]" == e ? t.constructor : void 0,
    n = r ? Fo(r) : "";
  if (n) switch (n) {
    case Bo:
      return "[object DataView]";
    case Zo:
      return "[object Map]";
    case Wo:
      return "[object Promise]";
    case Go:
      return "[object Set]";
    case qo:
      return "[object WeakMap]";
  }
  return e;
});
var Yo = Ho,
  Jo = Object.prototype.hasOwnProperty;
var Ko = function Ko(t) {
    var e = t.length,
      r = new t.constructor(e);
    return e && "string" == typeof t[0] && Jo.call(t, "index") && (r.index = t.index, r.input = t.input), r;
  },
  Qo = s.Uint8Array,
  Xo = Qo;
var tu = function tu(t) {
    var e = new t.constructor(t.byteLength);
    return new Xo(e).set(new Xo(t)), e;
  },
  eu = tu;
var ru = function ru(t, e) {
    var r = e ? eu(t.buffer) : t.buffer;
    return new t.constructor(r, t.byteOffset, t.byteLength);
  },
  nu = /\w*$/;
var ou = function ou(t) {
    var e = new t.constructor(t.source, nu.exec(t));
    return e.lastIndex = t.lastIndex, e;
  },
  uu = l ? l.prototype : void 0,
  au = uu ? uu.valueOf : void 0;
var iu = tu;
var cu = tu,
  fu = ru,
  su = ou,
  lu = function lu(t) {
    return au ? Object(au.call(t)) : {};
  },
  vu = function vu(t, e) {
    var r = e ? iu(t.buffer) : t.buffer;
    return new t.constructor(r, t.byteOffset, t.length);
  };
var pu = function pu(t, e, r) {
    var n = t.constructor;
    switch (e) {
      case "[object ArrayBuffer]":
        return cu(t);
      case "[object Boolean]":
      case "[object Date]":
        return new n(+t);
      case "[object DataView]":
        return fu(t, r);
      case "[object Float32Array]":
      case "[object Float64Array]":
      case "[object Int8Array]":
      case "[object Int16Array]":
      case "[object Int32Array]":
      case "[object Uint8Array]":
      case "[object Uint8ClampedArray]":
      case "[object Uint16Array]":
      case "[object Uint32Array]":
        return vu(t, r);
      case "[object Map]":
      case "[object Set]":
        return new n();
      case "[object Number]":
      case "[object String]":
        return new n(t);
      case "[object RegExp]":
        return su(t);
      case "[object Symbol]":
        return lu(t);
    }
  },
  du = je,
  hu = Object.create,
  bu = function () {
    function t() {}
    return function (e) {
      if (!du(e)) return {};
      if (hu) return hu(e);
      t.prototype = e;
      var r = new t();
      return t.prototype = void 0, r;
    };
  }(),
  gu = vo,
  yu = En;
var $u = function $u(t) {
    return "function" != typeof t.constructor || yu(t) ? {} : bu(gu(t));
  },
  ju = Yo,
  _u = O;
var mu = function mu(t) {
    return _u(t) && "[object Map]" == ju(t);
  },
  wu = ln,
  Au = vn.exports,
  xu = Au && Au.isMap,
  Ou = xu ? wu(xu) : mu,
  Eu = Yo,
  zu = O;
var Su = function Su(t) {
    return zu(t) && "[object Set]" == Eu(t);
  },
  Vu = ln,
  Uu = vn.exports,
  Iu = Uu && Uu.isSet,
  Pu = Iu ? Vu(Iu) : Su,
  ku = Ir,
  Tu = Pr,
  Cu = Mr,
  Ru = Fn,
  Du = Xn,
  Nu = to.exports,
  Lu = eo,
  Mu = so,
  Fu = _o,
  Bu = zo,
  Zu = Io,
  Wu = Yo,
  Gu = Ko,
  qu = pu,
  Hu = $u,
  Yu = p,
  Ju = tn.exports,
  Ku = Ou,
  Qu = je,
  Xu = Pu,
  ta = Nn,
  ea = Jn,
  ra = {};
ra["[object Arguments]"] = ra["[object Array]"] = ra["[object ArrayBuffer]"] = ra["[object DataView]"] = ra["[object Boolean]"] = ra["[object Date]"] = ra["[object Float32Array]"] = ra["[object Float64Array]"] = ra["[object Int8Array]"] = ra["[object Int16Array]"] = ra["[object Int32Array]"] = ra["[object Map]"] = ra["[object Number]"] = ra["[object Object]"] = ra["[object RegExp]"] = ra["[object Set]"] = ra["[object String]"] = ra["[object Symbol]"] = ra["[object Uint8Array]"] = ra["[object Uint8ClampedArray]"] = ra["[object Uint16Array]"] = ra["[object Uint32Array]"] = !0, ra["[object Error]"] = ra["[object Function]"] = ra["[object WeakMap]"] = !1;
var na = function t(e, r, n, o, u, a) {
    var i,
      c = 1 & r,
      f = 2 & r,
      s = 4 & r;
    if (n && (i = u ? n(e, o, u, a) : n(e)), void 0 !== i) return i;
    if (!Qu(e)) return e;
    var l = Yu(e);
    if (l) {
      if (i = Gu(e), !c) return Lu(e, i);
    } else {
      var v = Wu(e),
        p = "[object Function]" == v || "[object GeneratorFunction]" == v;
      if (Ju(e)) return Nu(e, c);
      if ("[object Object]" == v || "[object Arguments]" == v || p && !u) {
        if (i = f || p ? {} : Hu(e), !c) return f ? Fu(e, Du(i, e)) : Mu(e, Ru(i, e));
      } else {
        if (!ra[v]) return u ? e : {};
        i = qu(e, v, c);
      }
    }
    a || (a = new ku());
    var d = a.get(e);
    if (d) return d;
    a.set(e, i), Xu(e) ? e.forEach(function (o) {
      i.add(t(o, r, n, o, e, a));
    }) : Ku(e) && e.forEach(function (o, u) {
      i.set(u, t(o, r, n, u, e, a));
    });
    var h = l ? void 0 : (s ? f ? Zu : Bu : f ? ea : ta)(e);
    return Tu(h || e, function (o, u) {
      h && (o = e[u = o]), Cu(i, u, t(o, r, n, u, e, a));
    }), i;
  },
  oa = p,
  ua = S,
  aa = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,
  ia = /^\w*$/;
var ca = function ca(t, e) {
    if (oa(t)) return !1;
    var r = _typeof(t);
    return !("number" != r && "symbol" != r && "boolean" != r && null != t && !ua(t)) || ia.test(t) || !aa.test(t) || null != e && t in Object(e);
  },
  fa = _r;
function sa(t, e) {
  if ("function" != typeof t || null != e && "function" != typeof e) throw new TypeError("Expected a function");
  var r = function r() {
    var n = arguments,
      o = e ? e.apply(this, n) : n[0],
      u = r.cache;
    if (u.has(o)) return u.get(o);
    var a = t.apply(this, n);
    return r.cache = u.set(o, a) || u, a;
  };
  return r.cache = new (sa.Cache || fa)(), r;
}
sa.Cache = fa;
var la = sa;
var va = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g,
  pa = /\\(\\)?/g,
  da = function (t) {
    var e = la(t, function (t) {
        return 500 === r.size && r.clear(), t;
      }),
      r = e.cache;
    return e;
  }(function (t) {
    var e = [];
    return 46 === t.charCodeAt(0) && e.push(""), t.replace(va, function (t, r, n, o) {
      e.push(n ? o.replace(pa, "$1") : r || t);
    }), e;
  }),
  ha = p,
  ba = ca,
  ga = da,
  ya = R;
var $a = function $a(t, e) {
  return ha(t) ? t : ba(t, e) ? [t] : ga(ya(t));
};
var ja = S;
var _a = function _a(t) {
    if ("string" == typeof t || ja(t)) return t;
    var e = t + "";
    return "0" == e && 1 / t == -Infinity ? "-0" : e;
  },
  ma = $a,
  wa = _a;
var Aa = function Aa(t, e) {
    for (var r = 0, n = (e = ma(e, t)).length; null != t && r < n;) {
      t = t[wa(e[r++])];
    }
    return r && r == n ? t : void 0;
  },
  xa = Aa,
  Oa = D;
var Ea = $a,
  za = function za(t) {
    var e = null == t ? 0 : t.length;
    return e ? t[e - 1] : void 0;
  },
  Sa = function Sa(t, e) {
    return e.length < 2 ? t : xa(t, Oa(e, 0, -1));
  },
  Va = _a;
var Ua = function Ua(t, e) {
    return e = Ea(e, t), null == (t = Sa(t, e)) || delete t[Va(za(e))];
  },
  Ia = x,
  Pa = vo,
  ka = O,
  Ta = Function.prototype,
  Ca = Object.prototype,
  Ra = Ta.toString,
  Da = Ca.hasOwnProperty,
  Na = Ra.call(Object);
var La = function La(t) {
  if (!ka(t) || "[object Object]" != Ia(t)) return !1;
  var e = Pa(t);
  if (null === e) return !0;
  var r = Da.call(e, "constructor") && e.constructor;
  return "function" == typeof r && r instanceof r && Ra.call(r) == Na;
};
var Ma = function Ma(t) {
    return La(t) ? void 0 : t;
  },
  Fa = Xr,
  Ba = p,
  Za = l ? l.isConcatSpreadable : void 0;
var Wa = lo,
  Ga = function Ga(t) {
    return Ba(t) || Fa(t) || !!(Za && t && t[Za]);
  };
var qa = function t(e, r, n, o, u) {
    var a = -1,
      i = e.length;
    for (n || (n = Ga), u || (u = []); ++a < i;) {
      var c = e[a];
      r > 0 && n(c) ? r > 1 ? t(c, r - 1, n, o, u) : Wa(u, c) : o || (u[u.length] = c);
    }
    return u;
  },
  Ha = qa;
var Ya = function Ya(t) {
  return (null == t ? 0 : t.length) ? Ha(t, 1) : [];
};
var Ja = function Ja(t, e, r) {
    switch (r.length) {
      case 0:
        return t.call(e);
      case 1:
        return t.call(e, r[0]);
      case 2:
        return t.call(e, r[0], r[1]);
      case 3:
        return t.call(e, r[0], r[1], r[2]);
    }
    return t.apply(e, r);
  },
  Ka = Math.max;
var Qa = function Qa(t, e, r) {
  return e = Ka(void 0 === e ? t.length - 1 : e, 0), function () {
    for (var n = arguments, o = -1, u = Ka(n.length - e, 0), a = Array(u); ++o < u;) {
      a[o] = n[e + o];
    }
    o = -1;
    for (var i = Array(e + 1); ++o < e;) {
      i[o] = n[o];
    }
    return i[e] = r(a), Ja(t, this, i);
  };
};
var Xa = function Xa(t) {
    return t;
  },
  ti = function ti(t) {
    return function () {
      return t;
    };
  },
  ei = Tr,
  ri = ei ? function (t, e) {
    return ei(t, "toString", {
      configurable: !0,
      enumerable: !1,
      value: ti(e),
      writable: !0
    });
  } : Xa,
  ni = Date.now;
var oi = function (t) {
    var e = 0,
      r = 0;
    return function () {
      var n = ni(),
        o = 16 - (n - r);
      if (r = n, o > 0) {
        if (++e >= 800) return arguments[0];
      } else e = 0;
      return t.apply(void 0, arguments);
    };
  }(ri),
  ui = Ya,
  ai = Qa,
  ii = oi;
var ci = v,
  fi = na,
  si = Ua,
  li = $a,
  vi = Zr,
  pi = Ma,
  di = Io,
  hi = function (t) {
    return ii(ai(t, void 0, ui), t + "");
  }(function (t, e) {
    var r = {};
    if (null == t) return r;
    var n = !1;
    e = ci(e, function (e) {
      return e = li(e, t), n || (n = e.length > 1), e;
    }), vi(t, di(t), r), n && (r = fi(r, 7, pi));
    for (var o = e.length; o--;) {
      si(r, e[o]);
    }
    return r;
  }),
  bi = hi,
  gi = Aa;
var yi = function yi(t, e, r) {
  var n = null == t ? void 0 : gi(t, e);
  return void 0 === n ? r : n;
};
var $i = function (t) {
    return function (e, r, n) {
      for (var o = -1, u = Object(e), a = n(e), i = a.length; i--;) {
        var c = a[t ? i : ++o];
        if (!1 === r(u[c], c, u)) break;
      }
      return e;
    };
  }(),
  ji = Nn;
var _i = Tn;
var mi = function (t, e) {
    return function (r, n) {
      if (null == r) return r;
      if (!_i(r)) return t(r, n);
      for (var o = r.length, u = e ? o : -1, a = Object(r); (e ? u-- : ++u < o) && !1 !== n(a[u], u, a);) {
        ;
      }
      return r;
    };
  }(function (t, e) {
    return t && $i(t, e, ji);
  }),
  wi = Xa;
var Ai = Pr,
  xi = mi,
  Oi = function Oi(t) {
    return "function" == typeof t ? t : wi;
  },
  Ei = p;
var zi = function zi(t, e) {
    return (Ei(t) ? Ai : xi)(t, Oi(e));
  },
  Si = Zt(function (t, e, r) {
    return t + (r ? "-" : "") + e.toLowerCase();
  }),
  Vi = Xa,
  Ui = Qa,
  Ii = oi;
var Pi = function Pi(t, e) {
  return Ii(Ui(t, e, Vi), t + "");
};
var ki = _r,
  Ti = function Ti(t) {
    return this.__data__.set(t, "__lodash_hash_undefined__"), this;
  },
  Ci = function Ci(t) {
    return this.__data__.has(t);
  };
function Ri(t) {
  var e = -1,
    r = null == t ? 0 : t.length;
  for (this.__data__ = new ki(); ++e < r;) {
    this.add(t[e]);
  }
}
Ri.prototype.add = Ri.prototype.push = Ti, Ri.prototype.has = Ci;
var Di = Ri;
var Ni = function Ni(t, e, r, n) {
    for (var o = t.length, u = r + (n ? 1 : -1); n ? u-- : ++u < o;) {
      if (e(t[u], u, t)) return u;
    }
    return -1;
  },
  Li = function Li(t) {
    return t != t;
  },
  Mi = function Mi(t, e, r) {
    for (var n = r - 1, o = t.length; ++n < o;) {
      if (t[n] === e) return n;
    }
    return -1;
  };
var Fi = function Fi(t, e, r) {
  return e == e ? Mi(t, e, r) : Ni(t, Li, r);
};
var Bi = function Bi(t, e) {
  return !!(null == t ? 0 : t.length) && Fi(t, e, 0) > -1;
};
var Zi = function Zi(t, e, r) {
  for (var n = -1, o = null == t ? 0 : t.length; ++n < o;) {
    if (r(e, t[n])) return !0;
  }
  return !1;
};
var Wi = function Wi(t, e) {
  return t.has(e);
};
var Gi = function Gi(t) {
    var e = -1,
      r = Array(t.size);
    return t.forEach(function (t) {
      r[++e] = t;
    }), r;
  },
  qi = To,
  Hi = function Hi() {},
  Yi = qi && 1 / Gi(new qi([, -0]))[1] == 1 / 0 ? function (t) {
    return new qi(t);
  } : Hi,
  Ji = Di,
  Ki = Bi,
  Qi = Zi,
  Xi = Wi,
  tc = Yi,
  ec = Gi;
var rc = function rc(t, e, r) {
    var n = -1,
      o = Ki,
      u = t.length,
      a = !0,
      i = [],
      c = i;
    if (r) a = !1, o = Qi;else if (u >= 200) {
      var f = e ? null : tc(t);
      if (f) return ec(f);
      a = !1, o = Xi, c = new Ji();
    } else c = e ? [] : i;
    t: for (; ++n < u;) {
      var s = t[n],
        l = e ? e(s) : s;
      if (s = r || 0 !== s ? s : 0, a && l == l) {
        for (var v = c.length; v--;) {
          if (c[v] === l) continue t;
        }
        e && c.push(l), i.push(s);
      } else o(c, l, r) || (c !== i && c.push(l), i.push(s));
    }
    return i;
  },
  nc = Tn,
  oc = O;
var uc = qa,
  ac = rc,
  ic = function ic(t) {
    return oc(t) && nc(t);
  },
  cc = Pi(function (t) {
    return ac(uc(t, 1, ic, !0));
  }),
  fc = rc;
var sc = function sc(t) {
  return t && t.length ? fc(t) : [];
};
var lc = Di,
  vc = function vc(t, e) {
    for (var r = -1, n = null == t ? 0 : t.length; ++r < n;) {
      if (e(t[r], r, t)) return !0;
    }
    return !1;
  },
  pc = Wi;
var dc = function dc(t, e, r, n, o, u) {
  var a = 1 & r,
    i = t.length,
    c = e.length;
  if (i != c && !(a && c > i)) return !1;
  var f = u.get(t),
    s = u.get(e);
  if (f && s) return f == e && s == t;
  var l = -1,
    v = !0,
    p = 2 & r ? new lc() : void 0;
  for (u.set(t, e), u.set(e, t); ++l < i;) {
    var d = t[l],
      h = e[l];
    if (n) var b = a ? n(h, d, l, e, t, u) : n(d, h, l, t, e, u);
    if (void 0 !== b) {
      if (b) continue;
      v = !1;
      break;
    }
    if (p) {
      if (!vc(e, function (t, e) {
        if (!pc(p, e) && (d === t || o(d, t, r, n, u))) return p.push(e);
      })) {
        v = !1;
        break;
      }
    } else if (d !== h && !o(d, h, r, n, u)) {
      v = !1;
      break;
    }
  }
  return u.delete(t), u.delete(e), v;
};
var hc = Qo,
  bc = te,
  gc = dc,
  yc = function yc(t) {
    var e = -1,
      r = Array(t.size);
    return t.forEach(function (t, n) {
      r[++e] = [n, t];
    }), r;
  },
  $c = Gi,
  jc = l ? l.prototype : void 0,
  _c = jc ? jc.valueOf : void 0;
var mc = function mc(t, e, r, n, o, u, a) {
    switch (r) {
      case "[object DataView]":
        if (t.byteLength != e.byteLength || t.byteOffset != e.byteOffset) return !1;
        t = t.buffer, e = e.buffer;
      case "[object ArrayBuffer]":
        return !(t.byteLength != e.byteLength || !u(new hc(t), new hc(e)));
      case "[object Boolean]":
      case "[object Date]":
      case "[object Number]":
        return bc(+t, +e);
      case "[object Error]":
        return t.name == e.name && t.message == e.message;
      case "[object RegExp]":
      case "[object String]":
        return t == e + "";
      case "[object Map]":
        var i = yc;
      case "[object Set]":
        var c = 1 & n;
        if (i || (i = $c), t.size != e.size && !c) return !1;
        var f = a.get(t);
        if (f) return f == e;
        n |= 2, a.set(t, e);
        var s = gc(i(t), i(e), n, o, u, a);
        return a.delete(t), s;
      case "[object Symbol]":
        if (_c) return _c.call(t) == _c.call(e);
    }
    return !1;
  },
  wc = zo,
  Ac = Object.prototype.hasOwnProperty;
var xc = Ir,
  Oc = dc,
  Ec = mc,
  zc = function zc(t, e, r, n, o, u) {
    var a = 1 & r,
      i = wc(t),
      c = i.length;
    if (c != wc(e).length && !a) return !1;
    for (var f = c; f--;) {
      var s = i[f];
      if (!(a ? s in e : Ac.call(e, s))) return !1;
    }
    var l = u.get(t),
      v = u.get(e);
    if (l && v) return l == e && v == t;
    var p = !0;
    u.set(t, e), u.set(e, t);
    for (var d = a; ++f < c;) {
      var h = t[s = i[f]],
        b = e[s];
      if (n) var g = a ? n(b, h, s, e, t, u) : n(h, b, s, t, e, u);
      if (!(void 0 === g ? h === b || o(h, b, r, n, u) : g)) {
        p = !1;
        break;
      }
      d || (d = "constructor" == s);
    }
    if (p && !d) {
      var y = t.constructor,
        $ = e.constructor;
      y == $ || !("constructor" in t) || !("constructor" in e) || "function" == typeof y && y instanceof y && "function" == typeof $ && $ instanceof $ || (p = !1);
    }
    return u.delete(t), u.delete(e), p;
  },
  Sc = Yo,
  Vc = p,
  Uc = tn.exports,
  Ic = gn,
  Pc = "[object Object]",
  kc = Object.prototype.hasOwnProperty;
var Tc = function Tc(t, e, r, n, o, u) {
    var a = Vc(t),
      i = Vc(e),
      c = a ? "[object Array]" : Sc(t),
      f = i ? "[object Array]" : Sc(e),
      s = (c = "[object Arguments]" == c ? Pc : c) == Pc,
      l = (f = "[object Arguments]" == f ? Pc : f) == Pc,
      v = c == f;
    if (v && Uc(t)) {
      if (!Uc(e)) return !1;
      a = !0, s = !1;
    }
    if (v && !s) return u || (u = new xc()), a || Ic(t) ? Oc(t, e, r, n, o, u) : Ec(t, e, c, r, n, o, u);
    if (!(1 & r)) {
      var p = s && kc.call(t, "__wrapped__"),
        d = l && kc.call(e, "__wrapped__");
      if (p || d) {
        var h = p ? t.value() : t,
          b = d ? e.value() : e;
        return u || (u = new xc()), o(h, b, r, n, u);
      }
    }
    return !!v && (u || (u = new xc()), zc(t, e, r, n, o, u));
  },
  Cc = O;
var Rc = function t(e, r, n, o, u) {
    return e === r || (null == e || null == r || !Cc(e) && !Cc(r) ? e != e && r != r : Tc(e, r, n, o, t, u));
  },
  Dc = Ir,
  Nc = Rc;
var Lc = je;
var Mc = function Mc(t) {
    return t == t && !Lc(t);
  },
  Fc = Mc,
  Bc = Nn;
var Zc = function Zc(t, e) {
    return function (r) {
      return null != r && r[t] === e && (void 0 !== e || t in Object(r));
    };
  },
  Wc = function Wc(t, e, r, n) {
    var o = r.length,
      u = o,
      a = !n;
    if (null == t) return !u;
    for (t = Object(t); o--;) {
      var i = r[o];
      if (a && i[2] ? i[1] !== t[i[0]] : !(i[0] in t)) return !1;
    }
    for (; ++o < u;) {
      var c = (i = r[o])[0],
        f = t[c],
        s = i[1];
      if (a && i[2]) {
        if (void 0 === f && !(c in t)) return !1;
      } else {
        var l = new Dc();
        if (n) var v = n(f, s, c, t, e, l);
        if (!(void 0 === v ? Nc(s, f, 3, n, l) : v)) return !1;
      }
    }
    return !0;
  },
  Gc = function Gc(t) {
    for (var e = Bc(t), r = e.length; r--;) {
      var n = e[r],
        o = t[n];
      e[r] = [n, o, Fc(o)];
    }
    return e;
  },
  qc = Zc;
var Hc = $a,
  Yc = Xr,
  Jc = p,
  Kc = nn,
  Qc = on,
  Xc = _a;
var tf = function tf(t, e) {
    return null != t && e in Object(t);
  },
  ef = function ef(t, e, r) {
    for (var n = -1, o = (e = Hc(e, t)).length, u = !1; ++n < o;) {
      var a = Xc(e[n]);
      if (!(u = null != t && r(t, a))) break;
      t = t[a];
    }
    return u || ++n != o ? u : !!(o = null == t ? 0 : t.length) && Qc(o) && Kc(a, o) && (Jc(t) || Yc(t));
  };
var rf = Rc,
  nf = yi,
  of = function of(t, e) {
    return null != t && ef(t, e, tf);
  },
  uf = ca,
  af = Mc,
  cf = Zc,
  ff = _a;
var sf = Aa;
var lf = function lf(t) {
    return function (e) {
      return null == e ? void 0 : e[t];
    };
  },
  vf = function vf(t) {
    return function (e) {
      return sf(e, t);
    };
  },
  pf = ca,
  df = _a;
var hf = function hf(t) {
    var e = Gc(t);
    return 1 == e.length && e[0][2] ? qc(e[0][0], e[0][1]) : function (r) {
      return r === t || Wc(r, t, e);
    };
  },
  bf = function bf(t, e) {
    return uf(t) && af(e) ? cf(ff(t), e) : function (r) {
      var n = nf(r, t);
      return void 0 === n && n === e ? of(r, t) : rf(e, n, 3);
    };
  },
  gf = Xa,
  yf = p,
  $f = function $f(t) {
    return pf(t) ? lf(df(t)) : vf(t);
  };
var jf = mi,
  _f = Tn;
var mf = S;
var wf = function wf(t, e) {
  if (t !== e) {
    var r = void 0 !== t,
      n = null === t,
      o = t == t,
      u = mf(t),
      a = void 0 !== e,
      i = null === e,
      c = e == e,
      f = mf(e);
    if (!i && !f && !u && t > e || u && a && c && !i && !f || n && a && c || !r && c || !o) return 1;
    if (!n && !u && !f && t < e || f && r && o && !n && !u || i && r && o || !a && o || !c) return -1;
  }
  return 0;
};
var Af = v,
  xf = Aa,
  Of = function Of(t) {
    return "function" == typeof t ? t : null == t ? gf : "object" == _typeof(t) ? yf(t) ? bf(t[0], t[1]) : hf(t) : $f(t);
  },
  Ef = function Ef(t, e) {
    var r = -1,
      n = _f(t) ? Array(t.length) : [];
    return jf(t, function (t, o, u) {
      n[++r] = e(t, o, u);
    }), n;
  },
  zf = function zf(t, e) {
    var r = t.length;
    for (t.sort(e); r--;) {
      t[r] = t[r].value;
    }
    return t;
  },
  Sf = ln,
  Vf = function Vf(t, e, r) {
    for (var n = -1, o = t.criteria, u = e.criteria, a = o.length, i = r.length; ++n < a;) {
      var c = wf(o[n], u[n]);
      if (c) return n >= i ? c : c * ("desc" == r[n] ? -1 : 1);
    }
    return t.index - e.index;
  },
  Uf = Xa,
  If = p;
var Pf = te,
  kf = Tn,
  Tf = nn,
  Cf = je;
var Rf = qa,
  Df = function Df(t, e, r) {
    e = e.length ? Af(e, function (t) {
      return If(t) ? function (e) {
        return xf(e, 1 === t.length ? t[0] : t);
      } : t;
    }) : [Uf];
    var n = -1;
    e = Af(e, Sf(Of));
    var o = Ef(t, function (t, r, o) {
      return {
        criteria: Af(e, function (e) {
          return e(t);
        }),
        index: ++n,
        value: t
      };
    });
    return zf(o, function (t, e) {
      return Vf(t, e, r);
    });
  },
  Nf = function Nf(t, e, r) {
    if (!Cf(r)) return !1;
    var n = _typeof(e);
    return !!("number" == n ? kf(r) && Tf(e, r.length) : "string" == n && e in r) && Pf(r[e], t);
  },
  Lf = Pi(function (t, e) {
    if (null == t) return [];
    var r = e.length;
    return r > 1 && Nf(t, e[0], e[1]) ? e = [] : r > 2 && Nf(e[0], e[1], e[2]) && (e = [e[0]]), Df(t, Rf(e, 1), []);
  });
var Mf = [function () {
  return {
    restrict: "A",
    terminal: !0,
    priority: 1001,
    link: function link(n, o, u) {
      var _t$prototype3, _t$prototype3$$ngVue;
      var a = function (t) {
          var _t$ngVueExpose;
          var r = /^&([a-z$_][a-z0-9$_]*)$/i,
            n = ((_t$ngVueExpose = t.ngVueExpose) !== null && _t$ngVueExpose !== void 0 ? _t$ngVueExpose : "").split(",").map(function (t) {
              return t.trim();
            }).filter(function (t) {
              return r.test(t);
            }).map(function (t) {
              return t.replace(r, "$1");
            }),
            o = /^(?:v-on:|@)[a-z-]+(:[a-z0-9-]+)?(\.[a-z0-9-]+)*/i,
            u = /^([a-z_$][a-z0-9_$]*)(?:\(\))?$/i,
            a = e(t);
          return zi(a, function (t, e) {
            o.test(e) && u.test(t) && n.push(t.replace(u, "$1"));
          }), n;
        }(u),
        i = function (t) {
          var _t$ngVueExpose2;
          var r = /^(?:v-model|v-html|v-text|v-show|v-class|v-attr|v-style|v-if)(?:\.[a-z0-9]+)*$/i,
            n = /^(?:v-bind)?:[a-z-]+(\.[a-z]+)*$/i,
            o = /^[a-z$_][a-z0-9$_]*(\.[a-z$_][a-z0-9$_]*)*$/i,
            u = ((_t$ngVueExpose2 = t.ngVueExpose) !== null && _t$ngVueExpose2 !== void 0 ? _t$ngVueExpose2 : "").split(",").map(function (t) {
              return t.trim();
            }).filter(function (t) {
              return o.test(t);
            }),
            a = e(t);
          zi(a, function (t, e) {
            (n.test(e) || r.test(e)) && o.test(t) && u.push(t);
          });
          var i = _toConsumableArray(u);
          return u.forEach(function (t) {
            i = cc(i, Jt.parents(t));
          }), Lf(sc(i));
        }(u),
        c = function (t) {
          var r = /^(?:v-model)$/i,
            n = /^(?:v-bind)?:([a-z-]+)\.sync*$/i,
            o = /^[a-z$_][a-z0-9$_]*(\.[a-z$_][a-z0-9$_]*)*$/i,
            u = {},
            a = e(t);
          return zi(a, function (t, e) {
            if (r.test(e)) {
              var _e2 = "value";
              if (!o.test(t)) throw Error("Unsupported v-model binding value: ".concat(t));
              u[_e2] = t;
            }
            if (n.test(e)) {
              var _r2 = e.replace(n, "$1").replace(/-[a-z]/g, function (t) {
                return t[1].toUpperCase();
              }).replace(/^[A-Z]/, function (t) {
                return t[1].toLowerCase();
              });
              if (!o.test(t)) throw Error("Unsupported v-bind:".concat(_r2, ".sync binding value: ").concat(t));
              u[_r2] = t;
            }
          }), u;
        }(u);
      i.forEach(function (t) {
        return r(n, t);
      }), a.forEach(function (t) {
        return r(n, t);
      });
      var f = {},
        s = {};
      i.filter(Jt.isRoot).forEach(function (t) {
        f[t] = n.$eval(t);
      });
      var l = {};
      u.ngVue && (l = n.$eval(u.ngVue) || {}), l = bi(l, "props", "data", "computed", "methods", "watch"), a.forEach(function (t) {
        s[t] = function () {
          for (var _len2 = arguments.length, e = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
            e[_key2] = arguments[_key2];
          }
          console.debug("ng(vue): Calling ng delegate: ".concat(t, "()")), qt(n, function () {
            return n.$eval(t).apply(n, e);
          });
        };
      });
      var v = function (t) {
          var _e3;
          var e = t,
            r = (_e3 = e) === null || _e3 === void 0 ? void 0 : _e3.$component;
          for (; !r && e;) {
            var _e4;
            e = e.parentElement, r = (_e4 = e) === null || _e4 === void 0 ? void 0 : _e4.$component;
          }
          return r;
        }(o) || ((_t$prototype3 = t.prototype) === null || _t$prototype3 === void 0 ? void 0 : (_t$prototype3$$ngVue = _t$prototype3.$ngVue) === null || _t$prototype3$$ngVue === void 0 ? void 0 : _t$prototype3$$ngVue.vueApp) || void 0,
        p = new t(_objectSpread(_objectSpread({
          parent: v
        }, l), {}, {
          data: f,
          methods: s
        })).$mount(o[0]);
      p.$el.$component = p, n.$on("$destroy", function () {
        console.debug("ng(vue): destroying vue-comp", p), p.$destroy();
      }), i.forEach(function (e) {
        var r = e;
        n.$watch(e, function (n) {
          console.debug("ng(vue): ng(".concat(e, ") => vue(").concat(r, ") ="), n);
          var o = p,
            u = r;
          Jt.isRoot(u) || (o = yi(p, Jt.parent(u)), u = Jt.leaf(u)), t.set(o, u, n);
        });
      }), zi(c, function (t, e) {
        p.$children.forEach(function (r) {
          return r.$on("update:".concat(Gt(e)), function (r) {
            console.debug("ng(vue): vue(".concat(e, ") => ng(").concat(t, ") ="), r), qt(n, function () {
              return yi(n, t, r);
            });
          });
        }), p.$children.forEach(function (r) {
          return r.$on("update:".concat(Si(e)), function (r) {
            console.warn("$emit event using camelCase (update:".concat(Gt(e), "). instead of kebabCase (update:").concat(Si(e), ").")), console.debug("ng(vue): vue(".concat(e, ") => ng(").concat(t, ") ="), r), qt(n, function () {
              return yi(n, t, r);
            });
          });
        });
      });
    }
  };
  function e(t) {
    var e = {};
    return zi(t.$attr, function (r, n) {
      var o = t[n];
      e[r] = o;
    }), e;
  }
  function r(t, e) {
    if (void 0 === t.$eval(e)) throw Error("\"".concat(e, "\" is not defined on parent scope"));
  }
}];
var Ff = _.camelCase;
var Bf = [function () {
  return {
    restrict: "A",
    terminal: !0,
    priority: 1001,
    link: function link(t, _ref5, r) {
      var _ref6 = _slicedToArray(_ref5, 1),
        e = _ref6[0];
      !function (t, e) {
        var r = Object.keys(e).find(function (t) {
          return /^vModel\.?/.test(t);
        });
        if (!r) return;
        var n = e[r],
          o = e.$attr[r],
          u = o.replace(/^v-model/i, "");
        delete e[r], delete e.$attr[r], t.removeAttributeNode(t.attributes[o]), e.value = n, e.$attr.value = "v-bind:value".concat(u), e.input = "".concat(n, " = ($event.target ? $event.target.value : $event)"), e.$attr.input = "v-on:input", t.setAttribute(e.$attr.value, e.value), t.setAttribute(e.$attr.input, e.input);
      }(e, r);
      var n = t.$eval(r.ngVue || "{}"),
        o = {},
        u = {},
        a = {},
        i = function (t) {
          return Object.keys(t).map(function (e) {
            var r = t.$attr[e],
              n = t[e];
            if (Zf.test(r)) {
              var _r$match = r.match(Zf),
                _t3 = _r$match.groups;
              return {
                type: "bind",
                rawAttribute: r,
                name: Ff(_t3.name),
                expression: n,
                modifiers: (_t3.modifiers || "").split(".").filter(function (t) {
                  return t;
                })
              };
            }
            if (Gf.test(r)) {
              var _r$match2 = r.match(Gf),
                _t4 = _r$match2.groups;
              return {
                type: "bind",
                rawAttribute: r,
                name: Ff(_t4.name),
                expression: n,
                modifiers: (_t4.modifiers || "").split(".").filter(function (t) {
                  return t;
                })
              };
            }
            if (Wf.test(r)) {
              var _r$match3 = r.match(Wf),
                _t5 = _r$match3.groups;
              return {
                type: "event",
                rawAttribute: r,
                name: _t5.name.split(":").map(function (t) {
                  return Ff(t);
                }).join(":"),
                expression: n,
                modifiers: (_t5.modifiers || "").split(".").filter(function (t) {
                  return t;
                })
              };
            }
          }).filter(function (t) {
            return !!t;
          });
        }(r);
      i.filter(function (_ref7) {
        var t = _ref7.type;
        return "bind" == t;
      }).forEach(function (_ref8) {
        var r = _ref8.rawAttribute,
          n = _ref8.name,
          a = _ref8.expression,
          i = _ref8.modifiers;
        var c = "ngVueDataWrapper_".concat(n);
        o[c] = t.$eval(a), u[n] = {
          get: function get() {
            return o[c];
          }
        }, i.includes("sync") && (u[n].set = function (e) {
          t.$eval(a) !== e && t.$apply(function () {
            console.debug("vue(".concat(n, ") => ng(").concat(a, "):"), e), t.$eval("".concat(a, " = $event"), {
              $event: e
            });
          });
        }), t.$watch(a, function (t) {
          o[c] !== t && (console.debug("ng(".concat(a, ") => vue(").concat(n, "): "), t), o[c] = t);
        }), e.attributes[r].value = c;
      }), i.filter(function (_ref9) {
        var t = _ref9.type;
        return "event" == t;
      }).forEach(function (_ref10) {
        var r = _ref10.rawAttribute,
          n = _ref10.name,
          o = _ref10.expression;
        var u = "ngVueDelegateWrapper_".concat(Ff(n));
        a[u] = function (e) {
          t.$apply(function () {
            console.debug("vue(".concat(n, ") calling ng(").concat(o, "):"), e), t.$eval(o, {
              $event: e
            });
          });
        }, e.attributes[r].value = "".concat(u, "($event)");
      }), console.debug(e.outerHTML);
      var c = new Vue(_objectSpread(_objectSpread({}, n), {}, {
        data: o,
        computed: u,
        methods: a
      }));
      t.$on("$destroy", function () {
        c.$destroy();
      }), c.$mount(e), i.filter(function (_ref11) {
        var t = _ref11.type,
          e = _ref11.modifiers;
        return "bind" == t && e.includes("sync");
      }).forEach(function (_ref12) {
        var e = _ref12.name,
          r = _ref12.expression,
          n = _ref12.updateEvent;
        c.$children.forEach(function (o) {
          o.$on("update:".concat(e), function (e) {
            t.$apply(function () {
              console.debug("vue(".concat(n, ") => ng(").concat(r, ") ="), e), t.$eval("".concat(r, " = $event"), {
                $event: e
              });
            });
          });
        });
      });
    }
  };
}];
var Zf = /*#__PURE__*/_wrapRegExp(/^(?:v\x2Dbind:|:)([a-z0-9-]+)((\.[a-z]+)*)$/i, {
    name: 1,
    modifiers: 2
  }),
  Wf = /*#__PURE__*/_wrapRegExp(/^(?:v\x2Don:|@)([a-z0-9-]+(?::[a-z0-9-]+)*)((\.[a-z]+)*)$/i, {
    name: 1,
    modifiers: 2
  }),
  Gf = /*#__PURE__*/_wrapRegExp(/^(v\x2Dmodel|v\x2Dhtml|v\x2Dtext|v\x2Dshow|v\x2Dclass|v\x2Dattr|v\x2Dstyle|v\x2Dif)((\.[a-z]+)*)$/i, {
    name: 1,
    modifiers: 2
  });
export { Bf as AngularVue2Directive, u as AngularVueAuthPlugin, Mf as AngularVueDirective, Yt as AngularVuePlugin, n as AngularVueRoutePlugin, o as AngularVueRouterPlugin, r as CreateAngularVuePlainPlugin, Ht as VueAngularComponent };
//# sourceMappingURL=index.min.mjs.map
