function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
import t from "angular";
import r from "Vue";
var e = {
  parent: n,
  parents: function parents(t) {
    var r = [];
    var e = n(t);
    for (; e;) {
      r.push(e), e = n(e);
    }
    return r;
  },
  leaf: function leaf(t) {
    return o(t).pop();
  },
  root: function root(t) {
    return o(t)[0];
  },
  isRoot: function isRoot(t) {
    return 1 === o(t).length;
  }
};
function n(t) {
  var r = o(t);
  return r.pop(), function (t) {
    return t.join(".");
  }(r);
}
function o(t) {
  if (!t) throw new Error("Invalid path ".concat(t));
  return t.split(".");
}
var u = "undefined" != typeof globalThis ? globalThis : "undefined" != typeof window ? window : "undefined" != typeof global ? global : "undefined" != typeof self ? self : {};
var a = function a(t, r) {
  for (var e = -1, n = null == t ? 0 : t.length, o = Array(n); ++e < n;) {
    o[e] = r(t[e], e, t);
  }
  return o;
};
var i = function i() {
  this.__data__ = [], this.size = 0;
};
var c = function c(t, r) {
    return t === r || t != t && r != r;
  },
  f = c;
var v = function v(t, r) {
    for (var e = t.length; e--;) {
      if (f(t[e][0], r)) return e;
    }
    return -1;
  },
  l = v,
  s = Array.prototype.splice;
var p = v;
var b = v;
var d = v;
var h = i,
  y = function y(t) {
    var r = this.__data__,
      e = l(r, t);
    return !(e < 0) && (e == r.length - 1 ? r.pop() : s.call(r, e, 1), --this.size, !0);
  },
  g = function g(t) {
    var r = this.__data__,
      e = p(r, t);
    return e < 0 ? void 0 : r[e][1];
  },
  j = function j(t) {
    return b(this.__data__, t) > -1;
  },
  _ = function _(t, r) {
    var e = this.__data__,
      n = d(e, t);
    return n < 0 ? (++this.size, e.push([t, r])) : e[n][1] = r, this;
  };
function w(t) {
  var r = -1,
    e = null == t ? 0 : t.length;
  for (this.clear(); ++r < e;) {
    var n = t[r];
    this.set(n[0], n[1]);
  }
}
w.prototype.clear = h, w.prototype.delete = y, w.prototype.get = g, w.prototype.has = j, w.prototype.set = _;
var x = w,
  O = x;
var A = function A() {
  this.__data__ = new O(), this.size = 0;
};
var $ = function $(t) {
  var r = this.__data__,
    e = r.delete(t);
  return this.size = r.size, e;
};
var m = function m(t) {
  return this.__data__.get(t);
};
var z = function z(t) {
    return this.__data__.has(t);
  },
  E = "object" == _typeof(u) && u && u.Object === Object && u,
  S = E,
  U = "object" == (typeof self === "undefined" ? "undefined" : _typeof(self)) && self && self.Object === Object && self,
  I = S || U || Function("return this")(),
  P = I.Symbol,
  C = P,
  T = Object.prototype,
  L = T.hasOwnProperty,
  R = T.toString,
  D = C ? C.toStringTag : void 0;
var k = function k(t) {
    var r = L.call(t, D),
      e = t[D];
    try {
      t[D] = void 0;
      var n = !0;
    } catch (t) {}
    var o = R.call(t);
    return n && (r ? t[D] = e : delete t[D]), o;
  },
  F = Object.prototype.toString;
var M = k,
  V = function V(t) {
    return F.call(t);
  },
  B = P ? P.toStringTag : void 0;
var Z = function Z(t) {
  return null == t ? void 0 === t ? "[object Undefined]" : "[object Null]" : B && B in Object(t) ? M(t) : V(t);
};
var N = function N(t) {
    var r = _typeof(t);
    return null != t && ("object" == r || "function" == r);
  },
  G = Z,
  W = N;
var H,
  Y = function Y(t) {
    if (!W(t)) return !1;
    var r = G(t);
    return "[object Function]" == r || "[object GeneratorFunction]" == r || "[object AsyncFunction]" == r || "[object Proxy]" == r;
  },
  q = I["__core-js_shared__"],
  J = (H = /[^.]+$/.exec(q && q.keys && q.keys.IE_PROTO || "")) ? "Symbol(src)_1." + H : "";
var K = function K(t) {
    return !!J && J in t;
  },
  Q = Function.prototype.toString;
var X = function X(t) {
    if (null != t) {
      try {
        return Q.call(t);
      } catch (t) {}
      try {
        return t + "";
      } catch (t) {}
    }
    return "";
  },
  tt = Y,
  rt = K,
  et = N,
  nt = X,
  ot = /^\[object .+?Constructor\]$/,
  ut = Function.prototype,
  at = Object.prototype,
  it = ut.toString,
  ct = at.hasOwnProperty,
  ft = RegExp("^" + it.call(ct).replace(/[\\^$.*+?()[\]{}|]/g, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$");
var vt = function vt(t) {
    return !(!et(t) || rt(t)) && (tt(t) ? ft : ot).test(nt(t));
  },
  lt = function lt(t, r) {
    return null == t ? void 0 : t[r];
  };
var st = function st(t, r) {
    var e = lt(t, r);
    return vt(e) ? e : void 0;
  },
  pt = st(I, "Map"),
  bt = st(Object, "create"),
  dt = bt;
var ht = function ht() {
  this.__data__ = dt ? dt(null) : {}, this.size = 0;
};
var yt = function yt(t) {
    var r = this.has(t) && delete this.__data__[t];
    return this.size -= r ? 1 : 0, r;
  },
  gt = bt,
  jt = Object.prototype.hasOwnProperty;
var _t = function _t(t) {
    var r = this.__data__;
    if (gt) {
      var e = r[t];
      return "__lodash_hash_undefined__" === e ? void 0 : e;
    }
    return jt.call(r, t) ? r[t] : void 0;
  },
  wt = bt,
  xt = Object.prototype.hasOwnProperty;
var Ot = bt;
var At = ht,
  $t = yt,
  mt = _t,
  zt = function zt(t) {
    var r = this.__data__;
    return wt ? void 0 !== r[t] : xt.call(r, t);
  },
  Et = function Et(t, r) {
    var e = this.__data__;
    return this.size += this.has(t) ? 0 : 1, e[t] = Ot && void 0 === r ? "__lodash_hash_undefined__" : r, this;
  };
function St(t) {
  var r = -1,
    e = null == t ? 0 : t.length;
  for (this.clear(); ++r < e;) {
    var n = t[r];
    this.set(n[0], n[1]);
  }
}
St.prototype.clear = At, St.prototype.delete = $t, St.prototype.get = mt, St.prototype.has = zt, St.prototype.set = Et;
var Ut = St,
  It = x,
  Pt = pt;
var Ct = function Ct(t) {
  var r = _typeof(t);
  return "string" == r || "number" == r || "symbol" == r || "boolean" == r ? "__proto__" !== t : null === t;
};
var Tt = function Tt(t, r) {
    var e = t.__data__;
    return Ct(r) ? e["string" == typeof r ? "string" : "hash"] : e.map;
  },
  Lt = Tt;
var Rt = Tt;
var Dt = Tt;
var kt = Tt;
var Ft = function Ft() {
    this.size = 0, this.__data__ = {
      hash: new Ut(),
      map: new (Pt || It)(),
      string: new Ut()
    };
  },
  Mt = function Mt(t) {
    var r = Lt(this, t).delete(t);
    return this.size -= r ? 1 : 0, r;
  },
  Vt = function Vt(t) {
    return Rt(this, t).get(t);
  },
  Bt = function Bt(t) {
    return Dt(this, t).has(t);
  },
  Zt = function Zt(t, r) {
    var e = kt(this, t),
      n = e.size;
    return e.set(t, r), this.size += e.size == n ? 0 : 1, this;
  };
function Nt(t) {
  var r = -1,
    e = null == t ? 0 : t.length;
  for (this.clear(); ++r < e;) {
    var n = t[r];
    this.set(n[0], n[1]);
  }
}
Nt.prototype.clear = Ft, Nt.prototype.delete = Mt, Nt.prototype.get = Vt, Nt.prototype.has = Bt, Nt.prototype.set = Zt;
var Gt = Nt,
  Wt = x,
  Ht = pt,
  Yt = Gt;
var qt = x,
  Jt = A,
  Kt = $,
  Qt = m,
  Xt = z,
  tr = function tr(t, r) {
    var e = this.__data__;
    if (e instanceof Wt) {
      var n = e.__data__;
      if (!Ht || n.length < 199) return n.push([t, r]), this.size = ++e.size, this;
      e = this.__data__ = new Yt(n);
    }
    return e.set(t, r), this.size = e.size, this;
  };
function rr(t) {
  var r = this.__data__ = new qt(t);
  this.size = r.size;
}
rr.prototype.clear = Jt, rr.prototype.delete = Kt, rr.prototype.get = Qt, rr.prototype.has = Xt, rr.prototype.set = tr;
var er = rr;
var nr = function nr(t, r) {
    for (var e = -1, n = null == t ? 0 : t.length; ++e < n && !1 !== r(t[e], e, t);) {
      ;
    }
    return t;
  },
  or = st,
  ur = function () {
    try {
      var t = or(Object, "defineProperty");
      return t({}, "", {}), t;
    } catch (t) {}
  }(),
  ar = ur;
var ir = function ir(t, r, e) {
    "__proto__" == r && ar ? ar(t, r, {
      configurable: !0,
      enumerable: !0,
      value: e,
      writable: !0
    }) : t[r] = e;
  },
  cr = ir,
  fr = c,
  vr = Object.prototype.hasOwnProperty;
var lr = function lr(t, r, e) {
    var n = t[r];
    vr.call(t, r) && fr(n, e) && (void 0 !== e || r in t) || cr(t, r, e);
  },
  sr = lr,
  pr = ir;
var br = function br(t, r, e, n) {
  var o = !e;
  e || (e = {});
  for (var u = -1, a = r.length; ++u < a;) {
    var i = r[u],
      c = n ? n(e[i], t[i], i, e, t) : void 0;
    void 0 === c && (c = t[i]), o ? pr(e, i, c) : sr(e, i, c);
  }
  return e;
};
var dr = function dr(t, r) {
  for (var e = -1, n = Array(t); ++e < t;) {
    n[e] = r(e);
  }
  return n;
};
var hr = function hr(t) {
    return null != t && "object" == _typeof(t);
  },
  yr = Z,
  gr = hr;
var jr = function jr(t) {
    return gr(t) && "[object Arguments]" == yr(t);
  },
  _r = hr,
  wr = Object.prototype,
  xr = wr.hasOwnProperty,
  Or = wr.propertyIsEnumerable,
  Ar = jr(function () {
    return arguments;
  }()) ? jr : function (t) {
    return _r(t) && xr.call(t, "callee") && !Or.call(t, "callee");
  },
  $r = Array.isArray,
  mr = {
    exports: {}
  };
var zr = function zr() {
  return !1;
};
!function (t, r) {
  var e = I,
    n = zr,
    o = r && !r.nodeType && r,
    u = o && t && !t.nodeType && t,
    a = u && u.exports === o ? e.Buffer : void 0,
    i = (a ? a.isBuffer : void 0) || n;
  t.exports = i;
}(mr, mr.exports);
var Er = /^(?:0|[1-9]\d*)$/;
var Sr = function Sr(t, r) {
  var e = _typeof(t);
  return !!(r = null == r ? 9007199254740991 : r) && ("number" == e || "symbol" != e && Er.test(t)) && t > -1 && t % 1 == 0 && t < r;
};
var Ur = function Ur(t) {
    return "number" == typeof t && t > -1 && t % 1 == 0 && t <= 9007199254740991;
  },
  Ir = Z,
  Pr = Ur,
  Cr = hr,
  Tr = {};
Tr["[object Float32Array]"] = Tr["[object Float64Array]"] = Tr["[object Int8Array]"] = Tr["[object Int16Array]"] = Tr["[object Int32Array]"] = Tr["[object Uint8Array]"] = Tr["[object Uint8ClampedArray]"] = Tr["[object Uint16Array]"] = Tr["[object Uint32Array]"] = !0, Tr["[object Arguments]"] = Tr["[object Array]"] = Tr["[object ArrayBuffer]"] = Tr["[object Boolean]"] = Tr["[object DataView]"] = Tr["[object Date]"] = Tr["[object Error]"] = Tr["[object Function]"] = Tr["[object Map]"] = Tr["[object Number]"] = Tr["[object Object]"] = Tr["[object RegExp]"] = Tr["[object Set]"] = Tr["[object String]"] = Tr["[object WeakMap]"] = !1;
var Lr = function Lr(t) {
  return Cr(t) && Pr(t.length) && !!Tr[Ir(t)];
};
var Rr = function Rr(t) {
    return function (r) {
      return t(r);
    };
  },
  Dr = {
    exports: {}
  };
!function (t, r) {
  var e = E,
    n = r && !r.nodeType && r,
    o = n && t && !t.nodeType && t,
    u = o && o.exports === n && e.process,
    a = function () {
      try {
        var t = o && o.require && o.require("util").types;
        return t || u && u.binding && u.binding("util");
      } catch (t) {}
    }();
  t.exports = a;
}(Dr, Dr.exports);
var kr = Lr,
  Fr = Rr,
  Mr = Dr.exports,
  Vr = Mr && Mr.isTypedArray,
  Br = Vr ? Fr(Vr) : kr,
  Zr = dr,
  Nr = Ar,
  Gr = $r,
  Wr = mr.exports,
  Hr = Sr,
  Yr = Br,
  qr = Object.prototype.hasOwnProperty;
var Jr = function Jr(t, r) {
    var e = Gr(t),
      n = !e && Nr(t),
      o = !e && !n && Wr(t),
      u = !e && !n && !o && Yr(t),
      a = e || n || o || u,
      i = a ? Zr(t.length, String) : [],
      c = i.length;
    for (var f in t) {
      !r && !qr.call(t, f) || a && ("length" == f || o && ("offset" == f || "parent" == f) || u && ("buffer" == f || "byteLength" == f || "byteOffset" == f) || Hr(f, c)) || i.push(f);
    }
    return i;
  },
  Kr = Object.prototype;
var Qr = function Qr(t) {
  var r = t && t.constructor;
  return t === ("function" == typeof r && r.prototype || Kr);
};
var Xr = function Xr(t, r) {
    return function (e) {
      return t(r(e));
    };
  },
  te = Xr(Object.keys, Object),
  re = Qr,
  ee = te,
  ne = Object.prototype.hasOwnProperty;
var oe = Y,
  ue = Ur;
var ae = function ae(t) {
    return null != t && ue(t.length) && !oe(t);
  },
  ie = Jr,
  ce = function ce(t) {
    if (!re(t)) return ee(t);
    var r = [];
    for (var e in Object(t)) {
      ne.call(t, e) && "constructor" != e && r.push(e);
    }
    return r;
  },
  fe = ae;
var ve = function ve(t) {
    return fe(t) ? ie(t) : ce(t);
  },
  le = br,
  se = ve;
var pe = function pe(t, r) {
  return t && le(r, se(r), t);
};
var be = N,
  de = Qr,
  he = function he(t) {
    var r = [];
    if (null != t) for (var e in Object(t)) {
      r.push(e);
    }
    return r;
  },
  ye = Object.prototype.hasOwnProperty;
var ge = Jr,
  je = function je(t) {
    if (!be(t)) return he(t);
    var r = de(t),
      e = [];
    for (var n in t) {
      ("constructor" != n || !r && ye.call(t, n)) && e.push(n);
    }
    return e;
  },
  _e = ae;
var we = function we(t) {
    return _e(t) ? ge(t, !0) : je(t);
  },
  xe = br,
  Oe = we;
var Ae = function Ae(t, r) {
    return t && xe(r, Oe(r), t);
  },
  $e = {
    exports: {}
  };
!function (t, r) {
  var e = I,
    n = r && !r.nodeType && r,
    o = n && t && !t.nodeType && t,
    u = o && o.exports === n ? e.Buffer : void 0,
    a = u ? u.allocUnsafe : void 0;
  t.exports = function (t, r) {
    if (r) return t.slice();
    var e = t.length,
      n = a ? a(e) : new t.constructor(e);
    return t.copy(n), n;
  };
}($e, $e.exports);
var me = function me(t, r) {
  var e = -1,
    n = t.length;
  for (r || (r = Array(n)); ++e < n;) {
    r[e] = t[e];
  }
  return r;
};
var ze = function ze() {
    return [];
  },
  Ee = function Ee(t, r) {
    for (var e = -1, n = null == t ? 0 : t.length, o = 0, u = []; ++e < n;) {
      var a = t[e];
      r(a, e, t) && (u[o++] = a);
    }
    return u;
  },
  Se = ze,
  Ue = Object.prototype.propertyIsEnumerable,
  Ie = Object.getOwnPropertySymbols,
  Pe = Ie ? function (t) {
    return null == t ? [] : (t = Object(t), Ee(Ie(t), function (r) {
      return Ue.call(t, r);
    }));
  } : Se,
  Ce = br,
  Te = Pe;
var Le = function Le(t, r) {
  return Ce(t, Te(t), r);
};
var Re = function Re(t, r) {
    for (var e = -1, n = r.length, o = t.length; ++e < n;) {
      t[o + e] = r[e];
    }
    return t;
  },
  De = Xr(Object.getPrototypeOf, Object),
  ke = Re,
  Fe = De,
  Me = Pe,
  Ve = ze,
  Be = Object.getOwnPropertySymbols ? function (t) {
    for (var r = []; t;) {
      ke(r, Me(t)), t = Fe(t);
    }
    return r;
  } : Ve,
  Ze = br,
  Ne = Be;
var Ge = function Ge(t, r) {
    return Ze(t, Ne(t), r);
  },
  We = Re,
  He = $r;
var Ye = function Ye(t, r, e) {
    var n = r(t);
    return He(t) ? n : We(n, e(t));
  },
  qe = Ye,
  Je = Pe,
  Ke = ve;
var Qe = function Qe(t) {
    return qe(t, Ke, Je);
  },
  Xe = Ye,
  tn = Be,
  rn = we;
var en = function en(t) {
    return Xe(t, rn, tn);
  },
  nn = st(I, "DataView"),
  on = st(I, "Promise"),
  un = st(I, "Set"),
  an = nn,
  cn = pt,
  fn = on,
  vn = un,
  ln = st(I, "WeakMap"),
  sn = Z,
  pn = X,
  bn = pn(an),
  dn = pn(cn),
  hn = pn(fn),
  yn = pn(vn),
  gn = pn(ln),
  jn = sn;
(an && "[object DataView]" != jn(new an(new ArrayBuffer(1))) || cn && "[object Map]" != jn(new cn()) || fn && "[object Promise]" != jn(fn.resolve()) || vn && "[object Set]" != jn(new vn()) || ln && "[object WeakMap]" != jn(new ln())) && (jn = function jn(t) {
  var r = sn(t),
    e = "[object Object]" == r ? t.constructor : void 0,
    n = e ? pn(e) : "";
  if (n) switch (n) {
    case bn:
      return "[object DataView]";
    case dn:
      return "[object Map]";
    case hn:
      return "[object Promise]";
    case yn:
      return "[object Set]";
    case gn:
      return "[object WeakMap]";
  }
  return r;
});
var _n = jn,
  wn = Object.prototype.hasOwnProperty;
var xn = function xn(t) {
    var r = t.length,
      e = new t.constructor(r);
    return r && "string" == typeof t[0] && wn.call(t, "index") && (e.index = t.index, e.input = t.input), e;
  },
  On = I.Uint8Array,
  An = On;
var $n = function $n(t) {
    var r = new t.constructor(t.byteLength);
    return new An(r).set(new An(t)), r;
  },
  mn = $n;
var zn = function zn(t, r) {
    var e = r ? mn(t.buffer) : t.buffer;
    return new t.constructor(e, t.byteOffset, t.byteLength);
  },
  En = /\w*$/;
var Sn = function Sn(t) {
    var r = new t.constructor(t.source, En.exec(t));
    return r.lastIndex = t.lastIndex, r;
  },
  Un = P ? P.prototype : void 0,
  In = Un ? Un.valueOf : void 0;
var Pn = $n;
var Cn = $n,
  Tn = zn,
  Ln = Sn,
  Rn = function Rn(t) {
    return In ? Object(In.call(t)) : {};
  },
  Dn = function Dn(t, r) {
    var e = r ? Pn(t.buffer) : t.buffer;
    return new t.constructor(e, t.byteOffset, t.length);
  };
var kn = function kn(t, r, e) {
    var n = t.constructor;
    switch (r) {
      case "[object ArrayBuffer]":
        return Cn(t);
      case "[object Boolean]":
      case "[object Date]":
        return new n(+t);
      case "[object DataView]":
        return Tn(t, e);
      case "[object Float32Array]":
      case "[object Float64Array]":
      case "[object Int8Array]":
      case "[object Int16Array]":
      case "[object Int32Array]":
      case "[object Uint8Array]":
      case "[object Uint8ClampedArray]":
      case "[object Uint16Array]":
      case "[object Uint32Array]":
        return Dn(t, e);
      case "[object Map]":
      case "[object Set]":
        return new n();
      case "[object Number]":
      case "[object String]":
        return new n(t);
      case "[object RegExp]":
        return Ln(t);
      case "[object Symbol]":
        return Rn(t);
    }
  },
  Fn = N,
  Mn = Object.create,
  Vn = function () {
    function t() {}
    return function (r) {
      if (!Fn(r)) return {};
      if (Mn) return Mn(r);
      t.prototype = r;
      var e = new t();
      return t.prototype = void 0, e;
    };
  }(),
  Bn = De,
  Zn = Qr;
var Nn = function Nn(t) {
    return "function" != typeof t.constructor || Zn(t) ? {} : Vn(Bn(t));
  },
  Gn = _n,
  Wn = hr;
var Hn = function Hn(t) {
    return Wn(t) && "[object Map]" == Gn(t);
  },
  Yn = Rr,
  qn = Dr.exports,
  Jn = qn && qn.isMap,
  Kn = Jn ? Yn(Jn) : Hn,
  Qn = _n,
  Xn = hr;
var to = function to(t) {
    return Xn(t) && "[object Set]" == Qn(t);
  },
  ro = Rr,
  eo = Dr.exports,
  no = eo && eo.isSet,
  oo = no ? ro(no) : to,
  uo = er,
  ao = nr,
  io = lr,
  co = pe,
  fo = Ae,
  vo = $e.exports,
  lo = me,
  so = Le,
  po = Ge,
  bo = Qe,
  ho = en,
  yo = _n,
  go = xn,
  jo = kn,
  _o = Nn,
  wo = $r,
  xo = mr.exports,
  Oo = Kn,
  Ao = N,
  $o = oo,
  mo = ve,
  zo = we,
  Eo = {};
Eo["[object Arguments]"] = Eo["[object Array]"] = Eo["[object ArrayBuffer]"] = Eo["[object DataView]"] = Eo["[object Boolean]"] = Eo["[object Date]"] = Eo["[object Float32Array]"] = Eo["[object Float64Array]"] = Eo["[object Int8Array]"] = Eo["[object Int16Array]"] = Eo["[object Int32Array]"] = Eo["[object Map]"] = Eo["[object Number]"] = Eo["[object Object]"] = Eo["[object RegExp]"] = Eo["[object Set]"] = Eo["[object String]"] = Eo["[object Symbol]"] = Eo["[object Uint8Array]"] = Eo["[object Uint8ClampedArray]"] = Eo["[object Uint16Array]"] = Eo["[object Uint32Array]"] = !0, Eo["[object Error]"] = Eo["[object Function]"] = Eo["[object WeakMap]"] = !1;
var So = function t(r, e, n, o, u, a) {
    var i,
      c = 1 & e,
      f = 2 & e,
      v = 4 & e;
    if (n && (i = u ? n(r, o, u, a) : n(r)), void 0 !== i) return i;
    if (!Ao(r)) return r;
    var l = wo(r);
    if (l) {
      if (i = go(r), !c) return lo(r, i);
    } else {
      var s = yo(r),
        p = "[object Function]" == s || "[object GeneratorFunction]" == s;
      if (xo(r)) return vo(r, c);
      if ("[object Object]" == s || "[object Arguments]" == s || p && !u) {
        if (i = f || p ? {} : _o(r), !c) return f ? po(r, fo(i, r)) : so(r, co(i, r));
      } else {
        if (!Eo[s]) return u ? r : {};
        i = jo(r, s, c);
      }
    }
    a || (a = new uo());
    var b = a.get(r);
    if (b) return b;
    a.set(r, i), $o(r) ? r.forEach(function (o) {
      i.add(t(o, e, n, o, r, a));
    }) : Oo(r) && r.forEach(function (o, u) {
      i.set(u, t(o, e, n, u, r, a));
    });
    var d = l ? void 0 : (v ? f ? ho : bo : f ? zo : mo)(r);
    return ao(d || r, function (o, u) {
      d && (o = r[u = o]), io(i, u, t(o, e, n, u, r, a));
    }), i;
  },
  Uo = Z,
  Io = hr;
var Po = function Po(t) {
    return "symbol" == _typeof(t) || Io(t) && "[object Symbol]" == Uo(t);
  },
  Co = $r,
  To = Po,
  Lo = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,
  Ro = /^\w*$/;
var Do = function Do(t, r) {
    if (Co(t)) return !1;
    var e = _typeof(t);
    return !("number" != e && "symbol" != e && "boolean" != e && null != t && !To(t)) || Ro.test(t) || !Lo.test(t) || null != r && t in Object(r);
  },
  ko = Gt;
function Fo(t, r) {
  if ("function" != typeof t || null != r && "function" != typeof r) throw new TypeError("Expected a function");
  var e = function e() {
    var n = arguments,
      o = r ? r.apply(this, n) : n[0],
      u = e.cache;
    if (u.has(o)) return u.get(o);
    var a = t.apply(this, n);
    return e.cache = u.set(o, a) || u, a;
  };
  return e.cache = new (Fo.Cache || ko)(), e;
}
Fo.Cache = ko;
var Mo = Fo;
var Vo = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g,
  Bo = /\\(\\)?/g,
  Zo = function (t) {
    var r = Mo(t, function (t) {
        return 500 === e.size && e.clear(), t;
      }),
      e = r.cache;
    return r;
  }(function (t) {
    var r = [];
    return 46 === t.charCodeAt(0) && r.push(""), t.replace(Vo, function (t, e, n, o) {
      r.push(n ? o.replace(Bo, "$1") : e || t);
    }), r;
  }),
  No = a,
  Go = $r,
  Wo = Po,
  Ho = P ? P.prototype : void 0,
  Yo = Ho ? Ho.toString : void 0;
var qo = function t(r) {
    if ("string" == typeof r) return r;
    if (Go(r)) return No(r, t) + "";
    if (Wo(r)) return Yo ? Yo.call(r) : "";
    var e = r + "";
    return "0" == e && 1 / r == -Infinity ? "-0" : e;
  },
  Jo = qo;
var Ko = function Ko(t) {
    return null == t ? "" : Jo(t);
  },
  Qo = $r,
  Xo = Do,
  tu = Zo,
  ru = Ko;
var eu = function eu(t, r) {
  return Qo(t) ? t : Xo(t, r) ? [t] : tu(ru(t));
};
var nu = Po;
var ou = function ou(t) {
    if ("string" == typeof t || nu(t)) return t;
    var r = t + "";
    return "0" == r && 1 / t == -Infinity ? "-0" : r;
  },
  uu = eu,
  au = ou;
var iu = function iu(t, r) {
  for (var e = 0, n = (r = uu(r, t)).length; null != t && e < n;) {
    t = t[au(r[e++])];
  }
  return e && e == n ? t : void 0;
};
var cu = function cu(t, r, e) {
    var n = -1,
      o = t.length;
    r < 0 && (r = -r > o ? 0 : o + r), (e = e > o ? o : e) < 0 && (e += o), o = r > e ? 0 : e - r >>> 0, r >>>= 0;
    for (var u = Array(o); ++n < o;) {
      u[n] = t[n + r];
    }
    return u;
  },
  fu = iu,
  vu = cu;
var lu = eu,
  su = function su(t) {
    var r = null == t ? 0 : t.length;
    return r ? t[r - 1] : void 0;
  },
  pu = function pu(t, r) {
    return r.length < 2 ? t : fu(t, vu(r, 0, -1));
  },
  bu = ou;
var du = function du(t, r) {
    return r = lu(r, t), null == (t = pu(t, r)) || delete t[bu(su(r))];
  },
  hu = Z,
  yu = De,
  gu = hr,
  ju = Function.prototype,
  _u = Object.prototype,
  wu = ju.toString,
  xu = _u.hasOwnProperty,
  Ou = wu.call(Object);
var Au = function Au(t) {
  if (!gu(t) || "[object Object]" != hu(t)) return !1;
  var r = yu(t);
  if (null === r) return !0;
  var e = xu.call(r, "constructor") && r.constructor;
  return "function" == typeof e && e instanceof e && wu.call(e) == Ou;
};
var $u = function $u(t) {
    return Au(t) ? void 0 : t;
  },
  mu = Ar,
  zu = $r,
  Eu = P ? P.isConcatSpreadable : void 0;
var Su = Re,
  Uu = function Uu(t) {
    return zu(t) || mu(t) || !!(Eu && t && t[Eu]);
  };
var Iu = function t(r, e, n, o, u) {
    var a = -1,
      i = r.length;
    for (n || (n = Uu), u || (u = []); ++a < i;) {
      var c = r[a];
      e > 0 && n(c) ? e > 1 ? t(c, e - 1, n, o, u) : Su(u, c) : o || (u[u.length] = c);
    }
    return u;
  },
  Pu = Iu;
var Cu = function Cu(t) {
  return (null == t ? 0 : t.length) ? Pu(t, 1) : [];
};
var Tu = function Tu(t, r, e) {
    switch (e.length) {
      case 0:
        return t.call(r);
      case 1:
        return t.call(r, e[0]);
      case 2:
        return t.call(r, e[0], e[1]);
      case 3:
        return t.call(r, e[0], e[1], e[2]);
    }
    return t.apply(r, e);
  },
  Lu = Math.max;
var Ru = function Ru(t, r, e) {
  return r = Lu(void 0 === r ? t.length - 1 : r, 0), function () {
    for (var n = arguments, o = -1, u = Lu(n.length - r, 0), a = Array(u); ++o < u;) {
      a[o] = n[r + o];
    }
    o = -1;
    for (var i = Array(r + 1); ++o < r;) {
      i[o] = n[o];
    }
    return i[r] = e(a), Tu(t, this, i);
  };
};
var Du = function Du(t) {
    return t;
  },
  ku = function ku(t) {
    return function () {
      return t;
    };
  },
  Fu = ur,
  Mu = Fu ? function (t, r) {
    return Fu(t, "toString", {
      configurable: !0,
      enumerable: !1,
      value: ku(r),
      writable: !0
    });
  } : Du,
  Vu = Date.now;
var Bu = function (t) {
    var r = 0,
      e = 0;
    return function () {
      var n = Vu(),
        o = 16 - (n - e);
      if (e = n, o > 0) {
        if (++r >= 800) return arguments[0];
      } else r = 0;
      return t.apply(void 0, arguments);
    };
  }(Mu),
  Zu = Cu,
  Nu = Ru,
  Gu = Bu;
var Wu = a,
  Hu = So,
  Yu = du,
  qu = eu,
  Ju = br,
  Ku = $u,
  Qu = en,
  Xu = function (t) {
    return Gu(Nu(t, void 0, Zu), t + "");
  }(function (t, r) {
    var e = {};
    if (null == t) return e;
    var n = !1;
    r = Wu(r, function (r) {
      return r = qu(r, t), n || (n = r.length > 1), r;
    }), Ju(t, Qu(t), e), n && (e = Hu(e, 7, Ku));
    for (var o = r.length; o--;) {
      Yu(e, r[o]);
    }
    return e;
  }),
  ta = Xu,
  ra = iu;
var ea = function ea(t, r, e) {
  var n = null == t ? void 0 : ra(t, r);
  return void 0 === n ? e : n;
};
var na = function (t) {
    return function (r, e, n) {
      for (var o = -1, u = Object(r), a = n(r), i = a.length; i--;) {
        var c = a[t ? i : ++o];
        if (!1 === e(u[c], c, u)) break;
      }
      return r;
    };
  }(),
  oa = ve;
var ua = ae;
var aa = function (t, r) {
    return function (e, n) {
      if (null == e) return e;
      if (!ua(e)) return t(e, n);
      for (var o = e.length, u = r ? o : -1, a = Object(e); (r ? u-- : ++u < o) && !1 !== n(a[u], u, a);) {
        ;
      }
      return e;
    };
  }(function (t, r) {
    return t && na(t, r, oa);
  }),
  ia = Du;
var ca = nr,
  fa = aa,
  va = function va(t) {
    return "function" == typeof t ? t : ia;
  },
  la = $r;
var sa = function sa(t, r) {
  return (la(t) ? ca : fa)(t, va(r));
};
var pa = function pa(t, r, e, n) {
  var o = -1,
    u = null == t ? 0 : t.length;
  for (n && u && (e = t[++o]); ++o < u;) {
    e = r(e, t[o], o, t);
  }
  return e;
};
var ba = function (t) {
    return function (r) {
      return null == t ? void 0 : t[r];
    };
  }({
    "À": "A",
    "Á": "A",
    "Â": "A",
    "Ã": "A",
    "Ä": "A",
    "Å": "A",
    "à": "a",
    "á": "a",
    "â": "a",
    "ã": "a",
    "ä": "a",
    "å": "a",
    "Ç": "C",
    "ç": "c",
    "Ð": "D",
    "ð": "d",
    "È": "E",
    "É": "E",
    "Ê": "E",
    "Ë": "E",
    "è": "e",
    "é": "e",
    "ê": "e",
    "ë": "e",
    "Ì": "I",
    "Í": "I",
    "Î": "I",
    "Ï": "I",
    "ì": "i",
    "í": "i",
    "î": "i",
    "ï": "i",
    "Ñ": "N",
    "ñ": "n",
    "Ò": "O",
    "Ó": "O",
    "Ô": "O",
    "Õ": "O",
    "Ö": "O",
    "Ø": "O",
    "ò": "o",
    "ó": "o",
    "ô": "o",
    "õ": "o",
    "ö": "o",
    "ø": "o",
    "Ù": "U",
    "Ú": "U",
    "Û": "U",
    "Ü": "U",
    "ù": "u",
    "ú": "u",
    "û": "u",
    "ü": "u",
    "Ý": "Y",
    "ý": "y",
    "ÿ": "y",
    "Æ": "Ae",
    "æ": "ae",
    "Þ": "Th",
    "þ": "th",
    "ß": "ss",
    "Ā": "A",
    "Ă": "A",
    "Ą": "A",
    "ā": "a",
    "ă": "a",
    "ą": "a",
    "Ć": "C",
    "Ĉ": "C",
    "Ċ": "C",
    "Č": "C",
    "ć": "c",
    "ĉ": "c",
    "ċ": "c",
    "č": "c",
    "Ď": "D",
    "Đ": "D",
    "ď": "d",
    "đ": "d",
    "Ē": "E",
    "Ĕ": "E",
    "Ė": "E",
    "Ę": "E",
    "Ě": "E",
    "ē": "e",
    "ĕ": "e",
    "ė": "e",
    "ę": "e",
    "ě": "e",
    "Ĝ": "G",
    "Ğ": "G",
    "Ġ": "G",
    "Ģ": "G",
    "ĝ": "g",
    "ğ": "g",
    "ġ": "g",
    "ģ": "g",
    "Ĥ": "H",
    "Ħ": "H",
    "ĥ": "h",
    "ħ": "h",
    "Ĩ": "I",
    "Ī": "I",
    "Ĭ": "I",
    "Į": "I",
    "İ": "I",
    "ĩ": "i",
    "ī": "i",
    "ĭ": "i",
    "į": "i",
    "ı": "i",
    "Ĵ": "J",
    "ĵ": "j",
    "Ķ": "K",
    "ķ": "k",
    "ĸ": "k",
    "Ĺ": "L",
    "Ļ": "L",
    "Ľ": "L",
    "Ŀ": "L",
    "Ł": "L",
    "ĺ": "l",
    "ļ": "l",
    "ľ": "l",
    "ŀ": "l",
    "ł": "l",
    "Ń": "N",
    "Ņ": "N",
    "Ň": "N",
    "Ŋ": "N",
    "ń": "n",
    "ņ": "n",
    "ň": "n",
    "ŋ": "n",
    "Ō": "O",
    "Ŏ": "O",
    "Ő": "O",
    "ō": "o",
    "ŏ": "o",
    "ő": "o",
    "Ŕ": "R",
    "Ŗ": "R",
    "Ř": "R",
    "ŕ": "r",
    "ŗ": "r",
    "ř": "r",
    "Ś": "S",
    "Ŝ": "S",
    "Ş": "S",
    "Š": "S",
    "ś": "s",
    "ŝ": "s",
    "ş": "s",
    "š": "s",
    "Ţ": "T",
    "Ť": "T",
    "Ŧ": "T",
    "ţ": "t",
    "ť": "t",
    "ŧ": "t",
    "Ũ": "U",
    "Ū": "U",
    "Ŭ": "U",
    "Ů": "U",
    "Ű": "U",
    "Ų": "U",
    "ũ": "u",
    "ū": "u",
    "ŭ": "u",
    "ů": "u",
    "ű": "u",
    "ų": "u",
    "Ŵ": "W",
    "ŵ": "w",
    "Ŷ": "Y",
    "ŷ": "y",
    "Ÿ": "Y",
    "Ź": "Z",
    "Ż": "Z",
    "Ž": "Z",
    "ź": "z",
    "ż": "z",
    "ž": "z",
    "Ĳ": "IJ",
    "ĳ": "ij",
    "Œ": "Oe",
    "œ": "oe",
    "ŉ": "'n",
    "ſ": "s"
  }),
  da = Ko,
  ha = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g,
  ya = RegExp("[\\u0300-\\u036f\\ufe20-\\ufe2f\\u20d0-\\u20ff]", "g");
var ga = function ga(t) {
    return (t = da(t)) && t.replace(ha, ba).replace(ya, "");
  },
  ja = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g;
var _a = function _a(t) {
    return t.match(ja) || [];
  },
  wa = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/;
var xa = function xa(t) {
    return wa.test(t);
  },
  Oa = "\\xac\\xb1\\xd7\\xf7\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf\\u2000-\\u206f \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000",
  Aa = "[" + Oa + "]",
  $a = "\\d+",
  ma = "[\\u2700-\\u27bf]",
  za = "[a-z\\xdf-\\xf6\\xf8-\\xff]",
  Ea = "[^\\ud800-\\udfff" + Oa + $a + "\\u2700-\\u27bfa-z\\xdf-\\xf6\\xf8-\\xffA-Z\\xc0-\\xd6\\xd8-\\xde]",
  Sa = "(?:\\ud83c[\\udde6-\\uddff]){2}",
  Ua = "[\\ud800-\\udbff][\\udc00-\\udfff]",
  Ia = "[A-Z\\xc0-\\xd6\\xd8-\\xde]",
  Pa = "(?:" + za + "|" + Ea + ")",
  Ca = "(?:" + Ia + "|" + Ea + ")",
  Ta = "(?:[\\u0300-\\u036f\\ufe20-\\ufe2f\\u20d0-\\u20ff]|\\ud83c[\\udffb-\\udfff])?",
  La = "[\\ufe0e\\ufe0f]?" + Ta + ("(?:\\u200d(?:" + ["[^\\ud800-\\udfff]", Sa, Ua].join("|") + ")[\\ufe0e\\ufe0f]?" + Ta + ")*"),
  Ra = "(?:" + [ma, Sa, Ua].join("|") + ")" + La,
  Da = RegExp([Ia + "?" + za + "+(?:['’](?:d|ll|m|re|s|t|ve))?(?=" + [Aa, Ia, "$"].join("|") + ")", Ca + "+(?:['’](?:D|LL|M|RE|S|T|VE))?(?=" + [Aa, Ia + Pa, "$"].join("|") + ")", Ia + "?" + Pa + "+(?:['’](?:d|ll|m|re|s|t|ve))?", Ia + "+(?:['’](?:D|LL|M|RE|S|T|VE))?", "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", $a, Ra].join("|"), "g");
var ka = _a,
  Fa = xa,
  Ma = Ko,
  Va = function Va(t) {
    return t.match(Da) || [];
  };
var Ba = pa,
  Za = ga,
  Na = function Na(t, r, e) {
    return t = Ma(t), void 0 === (r = e ? void 0 : r) ? Fa(t) ? Va(t) : ka(t) : t.match(r) || [];
  },
  Ga = RegExp("['’]", "g");
var Wa = function Wa(t) {
    return function (r) {
      return Ba(Na(Za(r).replace(Ga, "")), t, "");
    };
  },
  Ha = Wa(function (t, r, e) {
    return t + (e ? "-" : "") + r.toLowerCase();
  }),
  Ya = cu;
var qa = function qa(t, r, e) {
    var n = t.length;
    return e = void 0 === e ? n : e, !r && e >= n ? t : Ya(t, r, e);
  },
  Ja = RegExp("[\\u200d\\ud800-\\udfff\\u0300-\\u036f\\ufe20-\\ufe2f\\u20d0-\\u20ff\\ufe0e\\ufe0f]");
var Ka = function Ka(t) {
  return Ja.test(t);
};
var Qa = function Qa(t) {
    return t.split("");
  },
  Xa = "[\\ud800-\\udfff]",
  ti = "[\\u0300-\\u036f\\ufe20-\\ufe2f\\u20d0-\\u20ff]",
  ri = "\\ud83c[\\udffb-\\udfff]",
  ei = "[^\\ud800-\\udfff]",
  ni = "(?:\\ud83c[\\udde6-\\uddff]){2}",
  oi = "[\\ud800-\\udbff][\\udc00-\\udfff]",
  ui = "(?:" + ti + "|" + ri + ")" + "?",
  ai = "[\\ufe0e\\ufe0f]?" + ui + ("(?:\\u200d(?:" + [ei, ni, oi].join("|") + ")[\\ufe0e\\ufe0f]?" + ui + ")*"),
  ii = "(?:" + [ei + ti + "?", ti, ni, oi, Xa].join("|") + ")",
  ci = RegExp(ri + "(?=" + ri + ")|" + ii + ai, "g");
var fi = Qa,
  vi = Ka,
  li = function li(t) {
    return t.match(ci) || [];
  };
var si = qa,
  pi = Ka,
  bi = function bi(t) {
    return vi(t) ? li(t) : fi(t);
  },
  di = Ko;
var hi = function (t) {
    return function (r) {
      r = di(r);
      var e = pi(r) ? bi(r) : void 0,
        n = e ? e[0] : r.charAt(0),
        o = e ? si(e, 1).join("") : r.slice(1);
      return n[t]() + o;
    };
  }("toUpperCase"),
  yi = Ko,
  gi = hi;
var ji = function ji(t) {
    return gi(yi(t).toLowerCase());
  },
  _i = Wa(function (t, r, e) {
    return r = r.toLowerCase(), t + (e ? ji(r) : r);
  }),
  wi = Du,
  xi = Ru,
  Oi = Bu;
var Ai = function Ai(t, r) {
  return Oi(xi(t, r, wi), t + "");
};
var $i = Gt,
  mi = function mi(t) {
    return this.__data__.set(t, "__lodash_hash_undefined__"), this;
  },
  zi = function zi(t) {
    return this.__data__.has(t);
  };
function Ei(t) {
  var r = -1,
    e = null == t ? 0 : t.length;
  for (this.__data__ = new $i(); ++r < e;) {
    this.add(t[r]);
  }
}
Ei.prototype.add = Ei.prototype.push = mi, Ei.prototype.has = zi;
var Si = Ei;
var Ui = function Ui(t, r, e, n) {
    for (var o = t.length, u = e + (n ? 1 : -1); n ? u-- : ++u < o;) {
      if (r(t[u], u, t)) return u;
    }
    return -1;
  },
  Ii = function Ii(t) {
    return t != t;
  },
  Pi = function Pi(t, r, e) {
    for (var n = e - 1, o = t.length; ++n < o;) {
      if (t[n] === r) return n;
    }
    return -1;
  };
var Ci = function Ci(t, r, e) {
  return r == r ? Pi(t, r, e) : Ui(t, Ii, e);
};
var Ti = function Ti(t, r) {
  return !!(null == t ? 0 : t.length) && Ci(t, r, 0) > -1;
};
var Li = function Li(t, r, e) {
  for (var n = -1, o = null == t ? 0 : t.length; ++n < o;) {
    if (e(r, t[n])) return !0;
  }
  return !1;
};
var Ri = function Ri(t, r) {
  return t.has(r);
};
var Di = function Di(t) {
    var r = -1,
      e = Array(t.size);
    return t.forEach(function (t) {
      e[++r] = t;
    }), e;
  },
  ki = un,
  Fi = function Fi() {},
  Mi = ki && 1 / Di(new ki([, -0]))[1] == 1 / 0 ? function (t) {
    return new ki(t);
  } : Fi,
  Vi = Si,
  Bi = Ti,
  Zi = Li,
  Ni = Ri,
  Gi = Mi,
  Wi = Di;
var Hi = function Hi(t, r, e) {
    var n = -1,
      o = Bi,
      u = t.length,
      a = !0,
      i = [],
      c = i;
    if (e) a = !1, o = Zi;else if (u >= 200) {
      var f = r ? null : Gi(t);
      if (f) return Wi(f);
      a = !1, o = Ni, c = new Vi();
    } else c = r ? [] : i;
    t: for (; ++n < u;) {
      var v = t[n],
        l = r ? r(v) : v;
      if (v = e || 0 !== v ? v : 0, a && l == l) {
        for (var s = c.length; s--;) {
          if (c[s] === l) continue t;
        }
        r && c.push(l), i.push(v);
      } else o(c, l, e) || (c !== i && c.push(l), i.push(v));
    }
    return i;
  },
  Yi = ae,
  qi = hr;
var Ji = Iu,
  Ki = Hi,
  Qi = function Qi(t) {
    return qi(t) && Yi(t);
  },
  Xi = Ai(function (t) {
    return Ki(Ji(t, 1, Qi, !0));
  }),
  tc = Hi;
var rc = function rc(t) {
  return t && t.length ? tc(t) : [];
};
var ec = Si,
  nc = function nc(t, r) {
    for (var e = -1, n = null == t ? 0 : t.length; ++e < n;) {
      if (r(t[e], e, t)) return !0;
    }
    return !1;
  },
  oc = Ri;
var uc = function uc(t, r, e, n, o, u) {
  var a = 1 & e,
    i = t.length,
    c = r.length;
  if (i != c && !(a && c > i)) return !1;
  var f = u.get(t),
    v = u.get(r);
  if (f && v) return f == r && v == t;
  var l = -1,
    s = !0,
    p = 2 & e ? new ec() : void 0;
  for (u.set(t, r), u.set(r, t); ++l < i;) {
    var b = t[l],
      d = r[l];
    if (n) var h = a ? n(d, b, l, r, t, u) : n(b, d, l, t, r, u);
    if (void 0 !== h) {
      if (h) continue;
      s = !1;
      break;
    }
    if (p) {
      if (!nc(r, function (t, r) {
        if (!oc(p, r) && (b === t || o(b, t, e, n, u))) return p.push(r);
      })) {
        s = !1;
        break;
      }
    } else if (b !== d && !o(b, d, e, n, u)) {
      s = !1;
      break;
    }
  }
  return u.delete(t), u.delete(r), s;
};
var ac = On,
  ic = c,
  cc = uc,
  fc = function fc(t) {
    var r = -1,
      e = Array(t.size);
    return t.forEach(function (t, n) {
      e[++r] = [n, t];
    }), e;
  },
  vc = Di,
  lc = P ? P.prototype : void 0,
  sc = lc ? lc.valueOf : void 0;
var pc = function pc(t, r, e, n, o, u, a) {
    switch (e) {
      case "[object DataView]":
        if (t.byteLength != r.byteLength || t.byteOffset != r.byteOffset) return !1;
        t = t.buffer, r = r.buffer;
      case "[object ArrayBuffer]":
        return !(t.byteLength != r.byteLength || !u(new ac(t), new ac(r)));
      case "[object Boolean]":
      case "[object Date]":
      case "[object Number]":
        return ic(+t, +r);
      case "[object Error]":
        return t.name == r.name && t.message == r.message;
      case "[object RegExp]":
      case "[object String]":
        return t == r + "";
      case "[object Map]":
        var i = fc;
      case "[object Set]":
        var c = 1 & n;
        if (i || (i = vc), t.size != r.size && !c) return !1;
        var f = a.get(t);
        if (f) return f == r;
        n |= 2, a.set(t, r);
        var v = cc(i(t), i(r), n, o, u, a);
        return a.delete(t), v;
      case "[object Symbol]":
        if (sc) return sc.call(t) == sc.call(r);
    }
    return !1;
  },
  bc = Qe,
  dc = Object.prototype.hasOwnProperty;
var hc = er,
  yc = uc,
  gc = pc,
  jc = function jc(t, r, e, n, o, u) {
    var a = 1 & e,
      i = bc(t),
      c = i.length;
    if (c != bc(r).length && !a) return !1;
    for (var f = c; f--;) {
      var v = i[f];
      if (!(a ? v in r : dc.call(r, v))) return !1;
    }
    var l = u.get(t),
      s = u.get(r);
    if (l && s) return l == r && s == t;
    var p = !0;
    u.set(t, r), u.set(r, t);
    for (var b = a; ++f < c;) {
      var d = t[v = i[f]],
        h = r[v];
      if (n) var y = a ? n(h, d, v, r, t, u) : n(d, h, v, t, r, u);
      if (!(void 0 === y ? d === h || o(d, h, e, n, u) : y)) {
        p = !1;
        break;
      }
      b || (b = "constructor" == v);
    }
    if (p && !b) {
      var g = t.constructor,
        j = r.constructor;
      g == j || !("constructor" in t) || !("constructor" in r) || "function" == typeof g && g instanceof g && "function" == typeof j && j instanceof j || (p = !1);
    }
    return u.delete(t), u.delete(r), p;
  },
  _c = _n,
  wc = $r,
  xc = mr.exports,
  Oc = Br,
  Ac = "[object Object]",
  $c = Object.prototype.hasOwnProperty;
var mc = function mc(t, r, e, n, o, u) {
    var a = wc(t),
      i = wc(r),
      c = a ? "[object Array]" : _c(t),
      f = i ? "[object Array]" : _c(r),
      v = (c = "[object Arguments]" == c ? Ac : c) == Ac,
      l = (f = "[object Arguments]" == f ? Ac : f) == Ac,
      s = c == f;
    if (s && xc(t)) {
      if (!xc(r)) return !1;
      a = !0, v = !1;
    }
    if (s && !v) return u || (u = new hc()), a || Oc(t) ? yc(t, r, e, n, o, u) : gc(t, r, c, e, n, o, u);
    if (!(1 & e)) {
      var p = v && $c.call(t, "__wrapped__"),
        b = l && $c.call(r, "__wrapped__");
      if (p || b) {
        var d = p ? t.value() : t,
          h = b ? r.value() : r;
        return u || (u = new hc()), o(d, h, e, n, u);
      }
    }
    return !!s && (u || (u = new hc()), jc(t, r, e, n, o, u));
  },
  zc = hr;
var Ec = function t(r, e, n, o, u) {
    return r === e || (null == r || null == e || !zc(r) && !zc(e) ? r != r && e != e : mc(r, e, n, o, t, u));
  },
  Sc = er,
  Uc = Ec;
var Ic = N;
var Pc = function Pc(t) {
    return t == t && !Ic(t);
  },
  Cc = Pc,
  Tc = ve;
var Lc = function Lc(t, r) {
    return function (e) {
      return null != e && e[t] === r && (void 0 !== r || t in Object(e));
    };
  },
  Rc = function Rc(t, r, e, n) {
    var o = e.length,
      u = o,
      a = !n;
    if (null == t) return !u;
    for (t = Object(t); o--;) {
      var i = e[o];
      if (a && i[2] ? i[1] !== t[i[0]] : !(i[0] in t)) return !1;
    }
    for (; ++o < u;) {
      var c = (i = e[o])[0],
        f = t[c],
        v = i[1];
      if (a && i[2]) {
        if (void 0 === f && !(c in t)) return !1;
      } else {
        var l = new Sc();
        if (n) var s = n(f, v, c, t, r, l);
        if (!(void 0 === s ? Uc(v, f, 3, n, l) : s)) return !1;
      }
    }
    return !0;
  },
  Dc = function Dc(t) {
    for (var r = Tc(t), e = r.length; e--;) {
      var n = r[e],
        o = t[n];
      r[e] = [n, o, Cc(o)];
    }
    return r;
  },
  kc = Lc;
var Fc = eu,
  Mc = Ar,
  Vc = $r,
  Bc = Sr,
  Zc = Ur,
  Nc = ou;
var Gc = function Gc(t, r) {
    return null != t && r in Object(t);
  },
  Wc = function Wc(t, r, e) {
    for (var n = -1, o = (r = Fc(r, t)).length, u = !1; ++n < o;) {
      var a = Nc(r[n]);
      if (!(u = null != t && e(t, a))) break;
      t = t[a];
    }
    return u || ++n != o ? u : !!(o = null == t ? 0 : t.length) && Zc(o) && Bc(a, o) && (Vc(t) || Mc(t));
  };
var Hc = Ec,
  Yc = ea,
  qc = function qc(t, r) {
    return null != t && Wc(t, r, Gc);
  },
  Jc = Do,
  Kc = Pc,
  Qc = Lc,
  Xc = ou;
var tf = iu;
var rf = function rf(t) {
    return function (r) {
      return null == r ? void 0 : r[t];
    };
  },
  ef = function ef(t) {
    return function (r) {
      return tf(r, t);
    };
  },
  nf = Do,
  of = ou;
var uf = function uf(t) {
    var r = Dc(t);
    return 1 == r.length && r[0][2] ? kc(r[0][0], r[0][1]) : function (e) {
      return e === t || Rc(e, t, r);
    };
  },
  af = function af(t, r) {
    return Jc(t) && Kc(r) ? Qc(Xc(t), r) : function (e) {
      var n = Yc(e, t);
      return void 0 === n && n === r ? qc(e, t) : Hc(r, n, 3);
    };
  },
  cf = Du,
  ff = $r,
  vf = function vf(t) {
    return nf(t) ? rf(of(t)) : ef(t);
  };
var lf = aa,
  sf = ae;
var pf = Po;
var bf = function bf(t, r) {
  if (t !== r) {
    var e = void 0 !== t,
      n = null === t,
      o = t == t,
      u = pf(t),
      a = void 0 !== r,
      i = null === r,
      c = r == r,
      f = pf(r);
    if (!i && !f && !u && t > r || u && a && c && !i && !f || n && a && c || !e && c || !o) return 1;
    if (!n && !u && !f && t < r || f && e && o && !n && !u || i && e && o || !a && o || !c) return -1;
  }
  return 0;
};
var df = a,
  hf = iu,
  yf = function yf(t) {
    return "function" == typeof t ? t : null == t ? cf : "object" == _typeof(t) ? ff(t) ? af(t[0], t[1]) : uf(t) : vf(t);
  },
  gf = function gf(t, r) {
    var e = -1,
      n = sf(t) ? Array(t.length) : [];
    return lf(t, function (t, o, u) {
      n[++e] = r(t, o, u);
    }), n;
  },
  jf = function jf(t, r) {
    var e = t.length;
    for (t.sort(r); e--;) {
      t[e] = t[e].value;
    }
    return t;
  },
  _f = Rr,
  wf = function wf(t, r, e) {
    for (var n = -1, o = t.criteria, u = r.criteria, a = o.length, i = e.length; ++n < a;) {
      var c = bf(o[n], u[n]);
      if (c) return n >= i ? c : c * ("desc" == e[n] ? -1 : 1);
    }
    return t.index - r.index;
  },
  xf = Du,
  Of = $r;
var Af = c,
  $f = ae,
  mf = Sr,
  zf = N;
var Ef = Iu,
  Sf = function Sf(t, r, e) {
    r = r.length ? df(r, function (t) {
      return Of(t) ? function (r) {
        return hf(r, 1 === t.length ? t[0] : t);
      } : t;
    }) : [xf];
    var n = -1;
    r = df(r, _f(yf));
    var o = gf(t, function (t, e, o) {
      return {
        criteria: df(r, function (r) {
          return r(t);
        }),
        index: ++n,
        value: t
      };
    });
    return jf(o, function (t, r) {
      return wf(t, r, e);
    });
  },
  Uf = function Uf(t, r, e) {
    if (!zf(e)) return !1;
    var n = _typeof(r);
    return !!("number" == n ? $f(e) && mf(r, e.length) : "string" == n && r in e) && Af(e[r], t);
  },
  If = Ai(function (t, r) {
    if (null == t) return [];
    var e = r.length;
    return e > 1 && Uf(t, r[0], r[1]) ? r = [] : e > 2 && Uf(r[0], r[1], r[2]) && (r = [r[0]]), Sf(t, Ef(r, 1), []);
  });
function Pf(t, r) {
  var e = t.$root.$$phase;
  "$apply" == e || "$digest" == e ? r() : t.$apply(r);
}
var Cf = [function () {
  return {
    restrict: "A",
    terminal: !0,
    priority: 1001,
    link: function link(o, u, a) {
      var _r$prototype, _r$prototype$$ngVue;
      var i = function (r) {
          var _r$ngVueExpose;
          var e = /^&([a-z$_][a-z0-9$_]*)$/i,
            n = ((_r$ngVueExpose = r.ngVueExpose) !== null && _r$ngVueExpose !== void 0 ? _r$ngVueExpose : "").split(",").map(function (t) {
              return t.trim();
            }).filter(function (t) {
              return e.test(t);
            }).map(function (t) {
              return t.replace(e, "$1");
            }),
            o = /^(?:v-on:|@)[a-z-]+(:[a-z0-9-]+)?(\.[a-z0-9-]+)*/i,
            u = /^([a-z_$][a-z0-9_$]*)(?:\(\))?$/i,
            a = t(r);
          return sa(a, function (t, r) {
            o.test(r) && u.test(t) && n.push(t.replace(u, "$1"));
          }), n;
        }(a),
        c = function (r) {
          var _r$ngVueExpose2;
          var n = /^(?:v-model|v-html|v-text|v-show|v-class|v-attr|v-style|v-if)(?:\.[a-z0-9]+)*$/i,
            o = /^(?:v-bind)?:[a-z-]+(\.[a-z]+)*$/i,
            u = /^[a-z$_][a-z0-9$_]*(\.[a-z$_][a-z0-9$_]*)*$/i,
            a = ((_r$ngVueExpose2 = r.ngVueExpose) !== null && _r$ngVueExpose2 !== void 0 ? _r$ngVueExpose2 : "").split(",").map(function (t) {
              return t.trim();
            }).filter(function (t) {
              return u.test(t);
            }),
            i = t(r);
          sa(i, function (t, r) {
            (o.test(r) || n.test(r)) && u.test(t) && a.push(t);
          });
          var c = _toConsumableArray(a);
          return a.forEach(function (t) {
            c = Xi(c, e.parents(t));
          }), If(rc(c));
        }(a),
        f = function (r) {
          var e = /^(?:v-model)$/i,
            n = /^(?:v-bind)?:([a-z-]+)\.sync*$/i,
            o = /^[a-z$_][a-z0-9$_]*(\.[a-z$_][a-z0-9$_]*)*$/i,
            u = {},
            a = t(r);
          return sa(a, function (t, r) {
            if (e.test(r)) {
              var _r2 = "value";
              if (!o.test(t)) throw Error("Unsupported v-model binding value: ".concat(t));
              u[_r2] = t;
            }
            if (n.test(r)) {
              var _e2 = r.replace(n, "$1").replace(/-[a-z]/g, function (t) {
                return t[1].toUpperCase();
              }).replace(/^[A-Z]/, function (t) {
                return t[1].toLowerCase();
              });
              if (!o.test(t)) throw Error("Unsupported v-bind:".concat(_e2, ".sync binding value: ").concat(t));
              u[_e2] = t;
            }
          }), u;
        }(a);
      c.forEach(function (t) {
        return n(o, t);
      }), i.forEach(function (t) {
        return n(o, t);
      });
      var v = {},
        l = {};
      c.filter(e.isRoot).forEach(function (t) {
        v[t] = o.$eval(t);
      });
      var s = {};
      a.ngVue && (s = o.$eval(a.ngVue) || {}), s = ta(s, "props", "data", "computed", "methods", "watch"), i.forEach(function (t) {
        l[t] = function () {
          for (var _len = arguments.length, r = new Array(_len), _key = 0; _key < _len; _key++) {
            r[_key] = arguments[_key];
          }
          console.debug("ng(vue): Calling ng delegate: ".concat(t, "()")), Pf(o, function () {
            return o.$eval(t).apply(o, r);
          });
        };
      });
      var p = function (t) {
          var _r3;
          var r = t,
            e = (_r3 = r) === null || _r3 === void 0 ? void 0 : _r3.$component;
          for (; !e && r;) {
            var _r4;
            r = r.parentElement, e = (_r4 = r) === null || _r4 === void 0 ? void 0 : _r4.$component;
          }
          return e;
        }(u) || ((_r$prototype = r.prototype) === null || _r$prototype === void 0 ? void 0 : (_r$prototype$$ngVue = _r$prototype.$ngVue) === null || _r$prototype$$ngVue === void 0 ? void 0 : _r$prototype$$ngVue.vueApp) || void 0,
        b = new r(_objectSpread(_objectSpread({
          parent: p
        }, s), {}, {
          data: v,
          methods: l
        })).$mount(u[0]);
      b.$el.$component = b, o.$on("$destroy", function () {
        console.debug("ng(vue): destroying vue-comp", b), b.$destroy();
      }), c.forEach(function (t) {
        var n = t;
        o.$watch(t, function (o) {
          console.debug("ng(vue): ng(".concat(t, ") => vue(").concat(n, ") ="), o);
          var u = b,
            a = n;
          e.isRoot(a) || (u = ea(b, e.parent(a)), a = e.leaf(a)), r.set(u, a, o);
        });
      }), sa(f, function (t, r) {
        b.$children.forEach(function (e) {
          return e.$on("update:".concat(_i(r)), function (e) {
            console.debug("ng(vue): vue(".concat(r, ") => ng(").concat(t, ") ="), e), Pf(o, function () {
              return ea(o, t, e);
            });
          });
        }), b.$children.forEach(function (e) {
          return e.$on("update:".concat(Ha(r)), function (e) {
            console.warn("$emit event using camelCase (update:".concat(_i(r), "). instead of kebabCase (update:").concat(Ha(r), ").")), console.debug("ng(vue): vue(".concat(r, ") => ng(").concat(t, ") ="), e), Pf(o, function () {
              return ea(o, t, e);
            });
          });
        });
      });
    }
  };
  function t(t) {
    var r = {};
    return sa(t.$attr, function (e, n) {
      var o = t[n];
      r[e] = o;
    }), r;
  }
  function n(t, r) {
    if (void 0 === t.$eval(r)) throw Error("\"".concat(r, "\" is not defined on parent scope"));
  }
}];
var Tf = t.module("angularVue", []);
Tf.directive("ngVue", Cf);
export { Tf as default };
//# sourceMappingURL=angular-vue.min.mjs.map
