function _wrapRegExp() { _wrapRegExp = function _wrapRegExp(re, groups) { return new BabelRegExp(re, void 0, groups); }; var _super = RegExp.prototype, _groups = new WeakMap(); function BabelRegExp(re, flags, groups) { var _this = new RegExp(re, flags); return _groups.set(_this, groups || _groups.get(re)), _setPrototypeOf(_this, BabelRegExp.prototype); } function buildGroups(result, re) { var g = _groups.get(re); return Object.keys(g).reduce(function (groups, name) { var i = g[name]; if ("number" == typeof i) groups[name] = result[i];else { for (var k = 0; void 0 === result[i[k]] && k + 1 < i.length;) { k++; } groups[name] = result[i[k]]; } return groups; }, Object.create(null)); } return _inherits(BabelRegExp, RegExp), BabelRegExp.prototype.exec = function (str) { var result = _super.exec.call(this, str); return result && (result.groups = buildGroups(result, this)), result; }, BabelRegExp.prototype[Symbol.replace] = function (str, substitution) { if ("string" == typeof substitution) { var groups = _groups.get(this); return _super[Symbol.replace].call(this, str, substitution.replace(/\$<([^>]+)>/g, function (_, name) { return "$" + groups[name]; })); } if ("function" == typeof substitution) { var _this = this; return _super[Symbol.replace].call(this, str, function () { var args = arguments; return "object" != _typeof(args[args.length - 1]) && (args = [].slice.call(args)).push(buildGroups(args, _this)), substitution.apply(this, args); }); } return _super[Symbol.replace].call(this, str, substitution); }, _wrapRegExp.apply(this, arguments); }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
!function (e, t) {
  "object" == (typeof exports === "undefined" ? "undefined" : _typeof(exports)) && "undefined" != typeof module ? module.exports = t() : "function" == typeof define && define.amd ? define(t) : (e = "undefined" != typeof globalThis ? globalThis : e || self).AngularVue2Directive = t();
}(this, function () {
  "use strict";

  var e = _.camelCase;
  var t = [function () {
    return {
      restrict: "A",
      terminal: !0,
      priority: 1001,
      link: function link(t, _ref, o) {
        var _ref2 = _slicedToArray(_ref, 1),
          a = _ref2[0];
        !function (e, t) {
          var n = Object.keys(t).find(function (e) {
            return /^vModel\.?/.test(e);
          });
          if (!n) return;
          var i = t[n],
            r = t.$attr[n],
            a = r.replace(/^v-model/i, "");
          delete t[n], delete t.$attr[n], e.removeAttributeNode(e.attributes[r]), t.value = i, t.$attr.value = "v-bind:value".concat(a), t.input = "".concat(i, " = ($event.target ? $event.target.value : $event)"), t.$attr.input = "v-on:input", e.setAttribute(t.$attr.value, t.value), e.setAttribute(t.$attr.input, t.input);
        }(a, o);
        var s = t.$eval(o.ngVue || "{}"),
          u = {},
          l = {},
          $ = {},
          d = function (t) {
            return Object.keys(t).map(function (a) {
              var o = t.$attr[a],
                s = t[a];
              if (n.test(o)) {
                var _o$match = o.match(n),
                  _t = _o$match.groups;
                return {
                  type: "bind",
                  rawAttribute: o,
                  name: e(_t.name),
                  expression: s,
                  modifiers: (_t.modifiers || "").split(".").filter(function (e) {
                    return e;
                  })
                };
              }
              if (r.test(o)) {
                var _o$match2 = o.match(r),
                  _t2 = _o$match2.groups;
                return {
                  type: "bind",
                  rawAttribute: o,
                  name: e(_t2.name),
                  expression: s,
                  modifiers: (_t2.modifiers || "").split(".").filter(function (e) {
                    return e;
                  })
                };
              }
              if (i.test(o)) {
                var _o$match3 = o.match(i),
                  _t3 = _o$match3.groups;
                return {
                  type: "event",
                  rawAttribute: o,
                  name: _t3.name.split(":").map(function (t) {
                    return e(t);
                  }).join(":"),
                  expression: s,
                  modifiers: (_t3.modifiers || "").split(".").filter(function (e) {
                    return e;
                  })
                };
              }
            }).filter(function (e) {
              return !!e;
            });
          }(o);
        d.filter(function (_ref3) {
          var e = _ref3.type;
          return "bind" == e;
        }).forEach(function (_ref4) {
          var e = _ref4.rawAttribute,
            n = _ref4.name,
            i = _ref4.expression,
            r = _ref4.modifiers;
          var o = "ngVueDataWrapper_".concat(n);
          u[o] = t.$eval(i), l[n] = {
            get: function get() {
              return u[o];
            }
          }, r.includes("sync") && (l[n].set = function (e) {
            t.$eval(i) !== e && t.$apply(function () {
              console.debug("vue(".concat(n, ") => ng(").concat(i, "):"), e), t.$eval("".concat(i, " = $event"), {
                $event: e
              });
            });
          }), t.$watch(i, function (e) {
            u[o] !== e && (console.debug("ng(".concat(i, ") => vue(").concat(n, "): "), e), u[o] = e);
          }), a.attributes[e].value = o;
        }), d.filter(function (_ref5) {
          var e = _ref5.type;
          return "event" == e;
        }).forEach(function (_ref6) {
          var n = _ref6.rawAttribute,
            i = _ref6.name,
            r = _ref6.expression;
          var o = "ngVueDelegateWrapper_".concat(e(i));
          $[o] = function (e) {
            t.$apply(function () {
              console.debug("vue(".concat(i, ") calling ng(").concat(r, "):"), e), t.$eval(r, {
                $event: e
              });
            });
          }, a.attributes[n].value = "".concat(o, "($event)");
        }), console.debug(a.outerHTML);
        var c = new Vue(_objectSpread(_objectSpread({}, s), {}, {
          data: u,
          computed: l,
          methods: $
        }));
        t.$on("$destroy", function () {
          c.$destroy();
        }), c.$mount(a), d.filter(function (_ref7) {
          var e = _ref7.type,
            t = _ref7.modifiers;
          return "bind" == e && t.includes("sync");
        }).forEach(function (_ref8) {
          var e = _ref8.name,
            n = _ref8.expression,
            i = _ref8.updateEvent;
          c.$children.forEach(function (r) {
            r.$on("update:".concat(e), function (e) {
              t.$apply(function () {
                console.debug("vue(".concat(i, ") => ng(").concat(n, ") ="), e), t.$eval("".concat(n, " = $event"), {
                  $event: e
                });
              });
            });
          });
        });
      }
    };
  }];
  var n = /*#__PURE__*/_wrapRegExp(/^(?:v\x2Dbind:|:)([a-z0-9-]+)((\.[a-z]+)*)$/i, {
      name: 1,
      modifiers: 2
    }),
    i = /*#__PURE__*/_wrapRegExp(/^(?:v\x2Don:|@)([a-z0-9-]+(?::[a-z0-9-]+)*)((\.[a-z]+)*)$/i, {
      name: 1,
      modifiers: 2
    }),
    r = /*#__PURE__*/_wrapRegExp(/^(v\x2Dmodel|v\x2Dhtml|v\x2Dtext|v\x2Dshow|v\x2Dclass|v\x2Dattr|v\x2Dstyle|v\x2Dif)((\.[a-z]+)*)$/i, {
      name: 1,
      modifiers: 2
    });
  return t;
});
//# sourceMappingURL=ng-vue2.min.js.map
