function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
(function (global, factory) {
  (typeof exports === "undefined" ? "undefined" : _typeof(exports)) === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('Vue')) : typeof define === 'function' && define.amd ? define(['Vue'], factory) : (global = typeof globalThis !== 'undefined' ? globalThis : global || self, global.AngularVueRouterPlugin = factory(global.Vue));
})(this, function (Vue) {
  'use strict';

  function _interopDefaultLegacy(e) {
    return e && _typeof(e) === 'object' && 'default' in e ? e : {
      'default': e
    };
  }
  var Vue__default = /*#__PURE__*/_interopDefaultLegacy(Vue);
  function AngularVueRouterPlugin($injector) {
    var _Vue__default$default, _Vue__default$default2, _Vue__default$default3;
    if (!$injector) $injector = (_Vue__default$default = Vue__default["default"]) === null || _Vue__default$default === void 0 ? void 0 : (_Vue__default$default2 = _Vue__default$default.prototype) === null || _Vue__default$default2 === void 0 ? void 0 : (_Vue__default$default3 = _Vue__default$default2.$ngVue) === null || _Vue__default$default3 === void 0 ? void 0 : _Vue__default$default3.$injector;
    if (!$injector) throw new Error('Angular $injector not provided, cannot use AngularVueRouterPlugin plugin');
    var $location = $injector.get('$location');
    var $rootScope = $injector.get('$rootScope');
    if (!$location) throw new Error('Angular $location service not available, cannot use AngularVueRouterPlugin plugin');
    var ngApply = function ngApply(callback) {
      if ($rootScope.$$phase) callback();else $rootScope.$apply(callback);
    };
    var router = {
      push: function push(_ref) {
        var path = _ref.path,
          query = _ref.query,
          hash = _ref.hash;
        ngApply(function () {
          if (path) $location.path(path);
          if (query) $location.search(query || {});
          if (hash !== undefined) $location.hash((hash || '').replace(/^#/, ''));
        });
      },
      replace: function replace() {
        var _this = this;
        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }
        ngApply(function () {
          $location.replace();
          _this.push.apply(_this, args);
        });
      }
    };
    return {
      install: function install(Vue, options) {
        if (!Vue.prototype.$router) Vue.prototype.$router = router;
      }
    };
  }
  return AngularVueRouterPlugin;
});
//# sourceMappingURL=ng-vue-router-plugin.js.map
