import Vue from 'Vue';
function AngularVueRouterPlugin($injector) {
  var _Vue$prototype, _Vue$prototype$$ngVue;
  if (!$injector) $injector = Vue === null || Vue === void 0 ? void 0 : (_Vue$prototype = Vue.prototype) === null || _Vue$prototype === void 0 ? void 0 : (_Vue$prototype$$ngVue = _Vue$prototype.$ngVue) === null || _Vue$prototype$$ngVue === void 0 ? void 0 : _Vue$prototype$$ngVue.$injector;
  if (!$injector) throw new Error('Angular $injector not provided, cannot use AngularVueRouterPlugin plugin');
  var $location = $injector.get('$location');
  var $rootScope = $injector.get('$rootScope');
  if (!$location) throw new Error('Angular $location service not available, cannot use AngularVueRouterPlugin plugin');
  var ngApply = function ngApply(callback) {
    if ($rootScope.$$phase) callback();else $rootScope.$apply(callback);
  };
  var router = {
    push: function push(_ref) {
      var path = _ref.path,
        query = _ref.query,
        hash = _ref.hash;
      ngApply(function () {
        if (path) $location.path(path);
        if (query) $location.search(query || {});
        if (hash !== undefined) $location.hash((hash || '').replace(/^#/, ''));
      });
    },
    replace: function replace() {
      var _this = this;
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }
      ngApply(function () {
        $location.replace();
        _this.push.apply(_this, args);
      });
    }
  };
  return {
    install: function install(Vue, options) {
      if (!Vue.prototype.$router) Vue.prototype.$router = router;
    }
  };
}
export { AngularVueRouterPlugin as default };
//# sourceMappingURL=ng-vue-router-plugin.mjs.map
